Package: TreeSummarizedExperiment
Type: Package
Title: TreeSummarizedExperiment: a S4 Class for Data with Tree
        Structures
Version: 2.18.0
Date: 2025-03-10
Authors@R: 
    c(person("Ruizhu", "Huang", email = "ruizhuRH@gmail.com",
      role = c("aut", "cre"), comment = c(ORCID = "0000-0003-3285-1945")),
      person("Felix G.M.", "Ernst", email = "felix.gm.ernst@outlook.com",
      role = c("ctb"), comment = c(ORCID = "0000-0001-5064-0928")),
      person(given = "Mark", family = "Robinson", role = c("ctb"),
             email = "mark.robinson@mls.uzh.ch",
             comment = c(ORCID = "0000-0002-3048-5518")),
      person(given = "Tuomas", family = "Borman", role = c("ctb"),
             comment = c(ORCID = "0000-0002-8563-8884")))
Description: TreeSummarizedExperiment has extended SingleCellExperiment to 
    include hierarchical information on the rows or columns of the rectangular 
    data.
Depends: R(>= 3.6.0), SingleCellExperiment, S4Vectors (>= 0.23.18),
        Biostrings
License: GPL (>=2)
Encoding: UTF-8
LazyData: true
biocViews: DataRepresentation, Infrastructure
Imports: methods, BiocGenerics, utils, ape, rlang, dplyr,
        SummarizedExperiment, BiocParallel, IRanges, treeio
VignetteBuilder: knitr
Suggests: ggtree, ggplot2, BiocStyle, knitr, rmarkdown, testthat
RoxygenNote: 7.1.1
Collate: 'TreeSummarizedExperiment.R' 'aboutLoop.R' 'allClass.R'
        'aggTSE.R' 'allGenerics.R' 'changeTree.R' 'classAccessor.R'
        'classValid.R' 'coercion.R' 'combine.R' 'data.R'
        'deprecate_Fun.R' 'internal_utils.R' 'makeTSE.R'
        'tree_addLabel.R' 'tree_asLeaf.R' 'tree_asPhylo.R'
        'tree_convertNode.R' 'tree_countLeaf.R' 'tree_countNode.R'
        'tree_distNode.R' 'tree_findAncestor.R' 'tree_findChild.R'
        'tree_findDescendant.R' 'tree_findSibling.R' 'tree_isLeaf.R'
        'tree_joinNode.R' 'tree_matTree.R' 'tree_printNode.R'
        'tree_shareNode.R' 'tree_showNode.R' 'tree_toTree.R'
        'tree_trackNode.R' 'tree_unionLeaf.R' 'updateObject.R'
git_url: https://git.bioconductor.org/packages/TreeSummarizedExperiment
git_branch: RELEASE_3_22
git_last_commit: f463a1d
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-31 00:37:34 UTC; biocbuild
Author: Ruizhu Huang [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-3285-1945>),
  Felix G.M. Ernst [ctb] (ORCID: <https://orcid.org/0000-0001-5064-0928>),
  Mark Robinson [ctb] (ORCID: <https://orcid.org/0000-0002-3048-5518>),
  Tuomas Borman [ctb] (ORCID: <https://orcid.org/0000-0002-8563-8884>)
Maintainer: Ruizhu Huang <ruizhuRH@gmail.com>

# TreeSummarizedExperiment

[![codecov](https://codecov.io/gh/fionarhuang/TreeSummarizedExperiment/branch/master/graph/badge.svg)](https://codecov.io/gh/fionarhuang/TreeSummarizedExperiment)
[![R-CMD-check](https://github.com/fionarhuang/TreeSummarizedExperiment/workflows/R-CMD-check/badge.svg?branch=CI-1)](https://github.com/fionarhuang/TreeSummarizedExperiment/actions)

# Installation

`BiocManager::install("TreeSummarizedExperiment")`

# The structure

![](https://github.com/fionarhuang/TreeSummarizedExperiment/blob/master/vignettes/tse.png)

# [TreeSummarizedExperiment in F1000article](https://f1000research.com/articles/9-1246)

#' Transform a phylo object into a matrix.
#'
#' \code{matTree} transforms a phylo tree into a matrix. The entry of the matrix
#' is node number. Each row represents a path connecting a leaf node and the
#' root. The columns are arranged in the order as the path passing the nodes to
#' reach the root.
#'
#' @param tree A phylo object
#' @export
#' @return A matrix
#' @author Ruizhu Huang
#'
#' @examples
#' library(ggtree)
#'
#' data(tinyTree)
#' ggtree(tinyTree, branch.length = 'none') +
#'  geom_text2(aes(label = node))
#'
#'
#' # each row of the matrix representing a path.
#' # the first column is leaf nodes; the last non-NA value in a row is the root
#' mat <- matTree(tree = tinyTree)
#'
matTree <- function(tree) {

    if (!inherits(tree, "phylo")) {
        stop("tree: should be a phylo object")
    }


    # the edge matrix
    mat <- tree$edge

    # the leaves
    L1 <- setdiff(mat[, 2], mat[, 1])

    # each path connects a tip with the root.
    # each path is stored as a row of matN
    # the first column stores the tips (or leaves)
    matN <- cbind(L1)
    i <- 1
    repeat {
        li <- mat[match(matN[, i], mat[, 2]), 1]
        ll <- length(unique(li[!is.na(li)]))
        if (ll == 0) {
            break
        }
        matN <- cbind(matN, li)
        i <- i + 1
    }
    rownames(matN) <- NULL
    colnames(matN) <- paste("L", seq_len(ncol(matN)), sep = "")

    return(matN)
}

context("matTree")

test_that("findSibling could find correct nodes", {
    data(tinyTree)

    mt <- matTree(tree = tinyTree)

    expect_matTree_setequal <- function(ith, truth) {
        expect_setequal(matTree(tree = tinyTree)[ith, ], truth)
    }

    expect_matTree_setequal(1, c(1, 11:13, rep(NA, 3)))
    expect_matTree_setequal(2, c(2, 11:14, rep(NA, 2)))
    expect_matTree_setequal(3, c(3, 11:14, rep(NA, 2)))
    expect_matTree_setequal(4, c(4, 11, 12, 15:18))
    expect_matTree_setequal(10, c(10:11, rep(NA, 5)))

})

#' Change the row or column tree 
#' 
#' \code{changeTree} changes a row or column tree in a
#' \code{TreeSummarizedExperiment} object.
#' 
#' @param x A TreeSummarizedExperiment object
#' @param rowTree A phylo object. A new row tree.
#' @param rowNodeLab A character string. It provides the labels of nodes that
#'   the rows of assays tables corresponding to. If NULL (default), the row
#'   names of the assays tables are used.
#' @param colTree A phylo object. A new column tree.
#' @param colNodeLab A character string. It provides the labels of nodes that
#'   the columns of assays tables corresponding to. If NULL (default), the
#'   column names of the assays tables are used.
#' @param whichRowTree Which row tree to be replaced? Default is 1 (the first
#'   tree in the \code{rowTree} slot).
#' @param whichColTree Which column tree to be replaced? Default is 1 (the first
#'   tree in the \code{colTree} slot).
#' @return A TreeSummarizedExperiment object
#' @importFrom stats setNames
#' @export
#' @author Ruizhu Huang
#' @examples 
#' 
#' library(ape)
#' set.seed(1)
#' treeR <- ape::rtree(10)
#' 
#' # the count table
#' count <- matrix(rpois(160, 50), nrow = 20)
#' rownames(count) <- paste0("entity", 1:20)
#' colnames(count) <- paste("sample", 1:8, sep = "_")
#' # The sample information
#' sampC <- data.frame(condition = rep(c("control", "trt"), 
#'                                     each = 4),
#'                     gender = sample(x = 1:2, size = 8, 
#'                                     replace = TRUE))
#' rownames(sampC) <- colnames(count)
#' # build a TreeSummarizedExperiment object
#' tse <- TreeSummarizedExperiment(assays = list(count),
#'                                 colData = sampC,
#'                                 rowTree = treeR,
#'                                 rowNodeLab = rep(treeR$tip.label, each =2))
#' 
#' treeR2 <- drop.tip(phy = treeR, tip = c("t10", "t9", "t8"))
#' 
#' # if rownames are not used in node labels of the tree, provide rowNodeLab
#' use <- changeTree(x = tse, rowTree = treeR2, 
#'                   rowNodeLab = rep(treeR$tip.label, each =2))
#' use
#' 
#' # if rownames are used in node labels of tree, rowNodeLab is not required.
#' 
#' rownames(tse) <- rep(treeR$tip.label, each =2)
#' cse <- changeTree(x = tse, rowTree = treeR2)
#' cse
changeTree <- function(x, 
                       rowTree = NULL, rowNodeLab = NULL,
                       colTree = NULL, colNodeLab = NULL,
                       whichRowTree = 1, whichColTree = 1) {
    
    if (!is.null(rowTree)) {
        out <- .replace_tree(x = x, value = rowTree, 
                             whichTree = whichRowTree, 
                             nodeLab = rowNodeLab, dim = "row")
        if (length(out$drop)) {x <- x[-out$drop, ]}
        x <- BiocGenerics:::replaceSlots(object = x, 
                                         rowTree = out$new_tree,
                                         rowLinks = out$new_links)
    }
    
    if (!is.null(colTree)) {
        out <- .replace_tree(x = x, value = colTree, 
                             whichTree = whichColTree, 
                             nodeLab = colNodeLab, dim = "col")
        if (length(out$drop)) {x <- x[, -out$drop]}
        x <- BiocGenerics:::replaceSlots(object = x, 
                                         colTree = out$new_tree,
                                         colLinks = out$new_links)
    }
    
    return(x)
}

context("subsetByLeaf")
library(ape)
set.seed(1)
z <- makeTSE(nrow = 5, ncol = 4, include.rowTree = TRUE, include.colTree = FALSE)
y <- makeTSE(nrow = 4, ncol = 4, include.rowTree = TRUE, include.colTree = FALSE)
tr <- ape::rtree(4)
zy <- rbind(z, y)

tse <- changeTree(x = zy, rowTree = tr, whichRowTree = 2, rowNodeLab = tr$tip.label)
   
test_that("subsetByLeaf works properly in the row dimension", {
    
    # warning if the dim tree is not available.
    expect_warning(subsetByLeaf(x = tse, colLeaf = 2:3,
                                whichRowTree = "phylo"),
                   "The column tree is not available")
    
    ## 1) rowLeaf exist only in one of trees
    rf <- c("t4", "t2")
    sx <- subsetByLeaf(x = tse, rowLeaf = rf, updateTree = TRUE)
    expect_equal(rowLinks(sx)$nodeLab, rf)
    expect_equal(unname(rowLinks(sx)$nodeNum), c(1, 2))
    
    sx <- subsetByLeaf(x = tse, rowLeaf = rf, updateTree = FALSE)
    expect_equal(unname(rowLinks(sx)$nodeNum), c(1, 4))
    
    ## 2) rowLeaf exist in all trees
    rf <- 1:3
    sx <- subsetByLeaf(x = tse, rowLeaf = rf)
    expect_equal(length(rowTree(x = sx, whichTree = NULL)), 2)
    expect_equal(rowLinks(sx)$nodeNum, 
                 setNames(rep(1:3, 2), paste0("entity", rep(1:3, 2))))
    
    
    ## 3) rowLeaf exist in all trees, but subset and update 
    ##    only the specified
    rf <- 1:3
    sx <- subsetByLeaf(x = tse, rowLeaf = rf, whichRowTree = "phylo")
    expect_equal(length(rowTree(x = sx, whichTree = NULL)), 1)
    expect_equal(rowLinks(sx)$nodeNum, 
                 setNames(1:3, paste0("entity", 1:3)))
    
    
    rf <- 3:4
    sx <- subsetByLeaf(x = tse, rowLeaf = rf, whichRowTree = "phylo.1")
    expect_equal(length(rowTree(x = sx, whichTree = NULL)), 1)
    expect_equal(rowLinks(sx)$nodeNum, 
                 setNames(1:2, paste0("entity", 3:4)))
    
    rf <- 3:4
    sx <- subsetByLeaf(x = tse, rowLeaf = rf, whichRowTree = "phylo.1",
                       updateTree = FALSE)
    expect_equal(length(rowTree(x = sx, whichTree = NULL)), 1)
    expect_equal(rowLinks(sx)$nodeNum, 
                 setNames(3:4, paste0("entity", 3:4)))
})

z <- makeTSE(nrow = 5, ncol = 5, include.rowTree = FALSE, include.colTree = TRUE)
y <- makeTSE(nrow = 5, ncol = 4, include.rowTree = FALSE, include.colTree = TRUE)
tr <- ape::rtree(4)
zy <- cbind(z, y)

tse <- changeTree(x = zy, colTree = tr, whichColTree = 2, colNodeLab = tr$tip.label)

test_that("subsetByLeaf works properly in the column dimension", {
    
    # warning if the dim tree is not available.
    expect_warning(subsetByLeaf(x = tse, rowLeaf = 2:3,
                                whichRowTree = "phylo"),
                   "The row tree is not available")
    
    ## 1) rowLeaf exist only in one of trees
    rf <- c("t2", "t4")
    sx <- subsetByLeaf(x = tse, colLeaf = rf, updateTree = TRUE)
    expect_equal(colLinks(sx)$nodeLab, rf)
    expect_equal(unname(colLinks(sx)$nodeNum), c(1, 2))
    
    sx <- subsetByLeaf(x = tse, colLeaf = rf, updateTree = FALSE)
    expect_equal(unique(colLinks(sx)$whichTree), "phylo.1")
    
    ## 2) rowLeaf exist in all trees
    rf <- 1:3
    sx <- subsetByLeaf(x = tse, colLeaf = rf)
    expect_equal(length(colTree(x = sx, whichTree = NULL)), 2)
    expect_equal(unique(colLinks(sx)$whichTree), c("phylo", "phylo.1"))
    
    
    ## 3) rowLeaf exist in all trees, but subset and update 
    ##    only the specified
    rf <- 1:3
    sx <- subsetByLeaf(x = tse, colLeaf = rf, whichColTree = "phylo")
    expect_equal(length(colTree(x = sx, whichTree = NULL)), 1)
    expect_equal(unique(colLinks(sx)$whichTree), "phylo")
})


tse <- makeTSE(nrow = 10, ncol = 5)
test_that("subsetByLeaf works properly in both dimensions", {
    
    sse <- subsetByLeaf(x = tse, rowLeaf = 1:3, colLeaf = 3:5)
    expect_equal(dim(sse), c(3, 3))
})

context("changeTree")

set.seed(1)
tse_a <- makeTSE()

library(ape)
tree_1 <- tree_2 <- rtree(10)
tree_1$tip.label <- rownames(tse_a)

tree_3 <- drop.tip(tree_1, tip = rownames(tse_a)[1:3])

test_that("Test changeTree work properly", {
    # rownames of TSE can be found in node labels of the tree
    tse_a1 <- changeTree(x = tse_a, rowTree = tree_1)
    expect_s4_class(tse_a1,
                    "TreeSummarizedExperiment")
    expect_equal(nrow(tse_a1), nrow(tse_a))
    
    # rownames of TSE can't be found in node labels of the tree
    expect_error(changeTree(x = tse_a, rowTree = tree_2))
    tse_a2 <- changeTree(x = tse_a, rowTree = tree_2,
                         rowNodeLab = tree_2$tip.label)
    expect_equal(nrow(tse_a2), nrow(tse_a))
    
    # duplicated rownames; rownames agree with node labels of the tree
    tse_aa <- rbind(tse_a, tse_a)
    tse_aa1 <- changeTree(x = tse_aa, rowTree = tree_1)
    expect_equal(nrow(tse_aa1), nrow(tse_aa))
    
    # duplicated rownames; rownames can't be found in node labels of the tree
    expect_warning(tse_aa3 <- changeTree(x = tse_aa, rowTree = tree_3))
    expect_equal(nrow(tse_aa3), nrow(tse_aa) - 6)
    
})

#' Join nodes
#'
#' \code{joinNode} is to use as few as possible nodes to represent the provided
#' nodes so that descendant leaves covered by the input nodes and output nodes
#' are exactly the same.
#'
#' @param tree A tree (phylo object)
#' @param node A vector of node numbers or node labels
#' @param use.alias A logical value, TRUE or FALSE. The default is FALSE, and
#'   the node label would be used to name the output; otherwise, the alias of
#'   node label would be used to name the output. The alias of node label is
#'   created by adding a prefix \code{"alias_"} to the node number.
#' @export
#' @return A vector of nodes. The numeric value is the node number, and the
#'   vector name is the corresponding node label. If a node has no label, it
#'   would have NA as name when \code{use.alias = FALSE}, and have the alias of
#'   node label as name when \code{use.alias = TRUE}.
#' @author Ruizhu Huang
#' @examples
#'
#' data(tinyTree)
#' library(ggtree)
#'
#' # PLOT tree
#' # The node labels are in orange texts and the node numbers are in blue
#' ggtree(tinyTree,branch.length = 'none')+
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#'
#' ## find the node shared by provided node labels
#' joinNode(node = c('t4','t9'), tree = tinyTree)
#' joinNode(node = c('t4','t9'), tree = tinyTree)
#' joinNode(node = c('t10','Node_18', 't8'), 
#'          tree = tinyTree,
#'          use.alias = FALSE)
#' joinNode(node = c('t10','Node_18', 't8'), 
#'          tree = tinyTree,
#'          use.alias = TRUE)
#'
#' ## find the node shared by provided node numbers
#' joinNode(node = c(2, 3), tree = tinyTree)
#' joinNode(node = c(2, 3, 16), tree = tinyTree)
#'
joinNode <- function(tree, node, use.alias = FALSE) {

    if (!inherits(tree, "phylo")) {
        stop("tree is not a phylo object.")
    }

    if (!is.atomic(node)) {
        stop("node is a vector")
    }

    # transfer node label to node number
    if (is.character(node)) {
        node <- convertNode(tree, node = node,
                          message = FALSE)
    } else {
        node <- node
    }

    # path matrix
    mat <- matTree(tree)

    if (!all(node %in% as.vector(mat))) {
        stop("Some nodes could not be found in the tree")
    }

    # select paths which include the input nodes
    ind <- apply(mat, 1, FUN = function(x) {
        any(x %in% node)
    })
    # select nodes which only exist in the selected paths
    selN <- setdiff(as.vector(mat[ind, ]), as.vector(mat[!ind, ]))
    selN <- selN[!is.na(selN)]
    # remove nodes which are descendants of any others
    matI <- mat[ind,, drop = FALSE]
    selF <- apply(matI, MARGIN = 1,
                FUN = function(x){
                    y <- x %in% selN
                    x[sum(y)]
                })
    sNode <- unique(selF)
    out <- sNode[!is.na(sNode)]

    # final output
    names(out) <- convertNode(tree = tree, node = out,
                            use.alias = use.alias,
                            message = FALSE)
    return(out)
}

context("tree functions")

test_that("tree functions", {
    data("tinyTree")
    # distNode
    expect_equal(distNode(tree = tinyTree, node = c("Node_12","Node_15")),
                 0.2186453,
                 tolerance = 10^-6)
    expect_equal(distNode(tree = tinyTree, node = c("Node_13","Node_15")),
                 0.3290059,
                 tolerance = 10^-6)
    expect_equal(distNode(tree = tinyTree, node = c("Node_14","Node_15")),
                 0.6469696,
                 tolerance = 10^-6)
    
    # findChild
    expect_equivalent(findChild(tree = tinyTree, node = c("Node_12","Node_15")),
                      c(15,16))
    expect_equivalent(findChild(tree = tinyTree, node = c("Node_13","Node_15")),
                      c(1,16))
    expect_equivalent(findChild(tree = tinyTree, node = c("Node_14","Node_15")),
                      c(2,16))
    
    
    # findSibling
    expect_equivalent(findSibling(tree = tinyTree, node = c("Node_12","Node_15")),
                      c(10, 13))
    expect_equivalent(findSibling(tree = tinyTree, node = c(10, 18)),
                      c(12,6))
    expect_error(findSibling(tree = tinyTree, node = 11))
    
    expect_equivalent(findSibling(tree = tinyTree, node = 17), 19)
    expect_equivalent(findSibling(tree = tinyTree, node = 16), 9)
    expect_equivalent(findSibling(tree = tinyTree, node = 16:17), c(9, 19))
    expect_error(findSibling(tree = tinyTree, node = 51))
    
    # printNode
    expect_error(printNode(tree = "a"),
                 "tree should be a phylo object")
    expect_error(printNode(tree = tinyTree, type = "node"),
                 "'arg' should be one of ")
    check_printNode <- function(type){
        actual <- printNode(tree = tinyTree, type = "leaf")
        expect_s3_class(actual,"data.frame")
        expect_named(actual,c("nodeLab", "nodeLab_alias", "nodeNum", "isLeaf"))
    }
    check_printNode("leaf")
    check_printNode("internal")
    check_printNode("all")
    
    # showNode
    actual <- showNode(tree = tinyTree)
    expect_equal(unname(actual), seq_len(19L))
    expect_named(actual, c(tinyTree$tip.label,tinyTree$node.label))
    actual <- showNode(tree = tinyTree, only.leaf = TRUE)
    expect_equal(unname(actual), seq_len(10L))
    expect_named(actual, c(tinyTree$tip.label))
    actual <- showNode(tree = tinyTree, only.leaf = FALSE, use.alias = TRUE)
    expect_true(all(grepl("alias",names(actual))))
    
    # joinNode
    actual <- joinNode(tree = tinyTree, node = c("Node_12","Node_15"))
    expect_equal(unname(actual), 12L)
    actual <- joinNode(tree = tinyTree, node = c("Node_13","Node_15"))
    expect_equal(unname(actual), 12L)
    actual <- joinNode(tree = tinyTree, node = c("Node_14","Node_15"))
    expect_equal(unname(actual), c(14L,15L))
    actual <- joinNode(tree = tinyTree, node = c('t4','t9'))
    expect_equal(actual, c("Node_18" = 18))
    actual <- joinNode(tree = tinyTree, node = c('t10','Node_18', 't8'))
    expect_equal(actual, c("Node_17" = 17, "t10" = 7))
    actual <- joinNode(tree = tinyTree, node = c(5, 10))
    expect_equal(actual, c("t4" = 5, "t3" = 10))
    expect_error(joinNode(node = c('t4','t9', 't11'), tree = tinyTree,
                          use.alias = FALSE))
    expect_warning(signalNode(node = 4:5, tree = tinyTree),
                   "'signalNode' is deprecated.")
    # trackNode
    actual <- showNode(trackNode(tree = tinyTree))
    expect_equal(unname(actual),seq_len(19L))
    expect_true(all(grepl("alias",names(actual))))
    
    # unionLeaf 
    actual <- unionLeaf(tree = tinyTree, node = c("Node_16","Node_19"))
    expect_equal(actual, seq.int(4L, 8L))
    actual <- unionLeaf(tree = tinyTree, node = c("t2","Node_19"))
    expect_equal(actual, c(1L, seq.int(7L, 8L)))
    
    # shareNode
    expect_equal(shareNode(tree = tinyTree, node = c('t4','t9')),
                      c("Node_18" = 18))
    expect_equal(shareNode(tree = tinyTree, node = c('t4','t9')),
                      c("Node_18" = 18))
    expect_equal(shareNode(tree = tinyTree, node = c('t4','t9', 't1')),
                 c("Node_16" = 16))
    expect_error(shareNode(node = c('t4','t9', 't11'), tree = tinyTree,
                           use.alias = FALSE))
    
    
    # countNode
    actual <- countNode(tree = tinyTree)
    expect_equal(actual, 19L)
    
    # isLeaf
    actual <- isLeaf(tree = tinyTree, node = 1:10)
    expect_true(all(actual))
    actual <- isLeaf(tree = tinyTree, node = 11)
    expect_false(actual)
    
    # asLeaf
    newTree <- asLeaf(tree = tinyTree, node = "Node_16")
    expect_true(isLeaf(tree = newTree, node = "Node_16"))
    expect_equal(asLeaf(tree = tinyTree, node = "Node_16"),
                asLeaf(tree = tinyTree, node = 16))
    })

#' Convert a data frame to a phylo object
#'
#' \code{asPhylo} converts a data frame to a phylo object. Compared to
#' \code{toTree}, \code{asPhylo} allows the output tree to have different number
#' of nodes in paths connecting leaves to the root.
#'
#' @param data A data frame or matrix.
#' @param column_order A vector that includes the column names of data to
#'   reorder columns of \code{data}. Default is NULL, the original order of
#'   \code{data} is kept.
#' @param asNA This specifies strings that are considered as NA
#' @details The last column is used as the leaf nodes
#' @importFrom treeio as.phylo
#' @importFrom rlang .data
#' @return a phylo object
#' @author Ruizhu Huang
#' @export
#' @examples
#' 
#' library(ggtree)
#' 
#' # Example 0:
#' taxTab <- data.frame(R1 = rep("A", 5),
#'                      R2 = c("B1", rep("B2", 4)),
#'                      R3 = paste0("C", 1:5))
#' # Internal nodes: their labels are prefixed with colnames of taxTab
#' #  e.g., R2:B2
#' taxTree <- asPhylo(data = taxTab)
#' ggtree(taxTree) + 
#'  geom_text2(aes(label = label), color = "red", vjust = 1) + 
#'  geom_nodepoint()
#'  
#'  # (Below gives the same output as toTree)
#'  taxTab$R1 <- paste0("R1:", taxTab$R1)
#'  taxTab$R2 <- paste0("R2:", taxTab$R2)
#'  taxTree <- asPhylo(data = taxTab)
#' # viz the tree           
#'  ggtree(taxTree) + 
#'  geom_text2(aes(label = label), color = "red", vjust = 1) + 
#'  geom_nodepoint()
#'  
#' # Example 1
#' df1 <- rbind.data.frame(c("root", "A1", "A2", NA),
#'                         c("root", "B1", NA, NA))
#' colnames(df1) <- paste0("L", 1:4)
#' tree1 <- asPhylo(df1)
#' 
#' ggtree(tree1, color = "grey") +
#' geom_nodepoint() +
#'    geom_text2(aes(label = label), angle = 90,
#'                color = "red", vjust = 2,
#'                size = 4)
#'                
#' # Example 2
#' df2 <- data.frame(Group_1 = rep("Root", 11),
#'                   Group_2 = rep(c(13, 21), c(9, 2)),
#'                   Group_3 = rep(c(14, 18, "unknown"), c(5, 4, 2)),
#'                   Group_4 = rep(c(15, "unknown", 19, "unknown"), c(4, 1, 3, 3)),
#'                   Group_5 = rep(c(16, "unknown", 20, "unknown"), c(3, 2, 2, 4)),
#'                   Group_6 = rep(c(17, "unknown"), c(2, 9)),
#'                   LEAF = 1:11)
#'                   
#' tree2 <- asPhylo(df2, asNA = "unknown")
#' 
#' ggtree(tree2, color = "grey") +
#' geom_nodepoint() +
#'    geom_text2(aes(label = label), angle = 90,
#'                color = "red", vjust = 2,
#'                size = 4) 
#'                
#' # Example 3
#' df3 <- df2
#' df3[10:11, 3] <- ""                                            
#'  
#' tree3 <- asPhylo(df3, asNA = c("unknown", ""))
#' 
#' ggtree(tree3, color = "grey") +
#' geom_nodepoint() +
#'    geom_text2(aes(label = label), angle = 90,
#'                color = "red", vjust = 2,
#'                size = 4) 

asPhylo <- function(data, column_order = NULL, asNA = NULL) {
    
    # the column order 
    if (!is.null(column_order)) {
        data <- data[, column_order, drop = FALSE]
    }
    
    # convert specified strings as NA
    if (!is.null(asNA)) {
        ind <- lapply(asNA, function(x) {
            which(data == x, arr.ind = TRUE)
        })
        ind <- do.call(rbind, ind)
        data[ind] <- NA
    }
    
    # assign nodeID
    leaf <- apply(data, 1, .capture_last_noNA)
    id <- sort(.assign_node(data = data))
    data <- .replace_with_nodeID(data = data)
    
    # move NA to the end of each row
    data <- t(apply(data, 1, .move_na_to_end))
    
    # convert to edges
    ed <- .convert_to_edges(data = data)
    ed <- data.frame(ed)
    # convert it into phylo
    out <- as.phylo(ed)
    out$tip.label <- names(id)[seq_along(leaf)]
    out$node.label <- names(id)[-seq_along(leaf)]
    return(out)
}

.move_na_to_end <- function(x) {
    na <- is.na(x)
    c(x[!na], x[na])
}

.capture_last_noNA <- function(x) {
    na <- is.na(x)
    tail(x[!na], 1)
}

.assign_node <- function(data){
    leaf <- apply(data, 1, .capture_last_noNA)
    
    # internal nodes
    vv <- as.vector(t(data))
    vv <- vv[!is.na(vv)]
    inNode <- unique(setdiff(vv, leaf))
    
    lab <- c(unique(leaf), inNode)
    nodeID <- setNames(seq_along(lab), lab)
    
    return(nodeID)
    
}

.replace_with_nodeID <- function(data){
    id <- .assign_node(data)
    apply(data, 2, function(x) {
        id[x]
    })
}

.convert_to_edges <- function(data){
    data <- t(apply(data, 1, .move_na_to_end))
    n <- seq_len(ncol(data)-1)
    ed <- lapply(n, function(i) {
        xi <- data[, i:(i+1), drop = FALSE]
        na_i <- which(is.na(xi), arr.ind = TRUE)[, "row"]
        if (length(na_i)) {
            xi <- xi[-na_i, ]
        }
        
        unname(unique(xi))
        
    })
    
    ed <- do.call(rbind, ed)
    unique(ed)
}

context("asPhylo")

test_that("asPhylo works properly", {
    df1 <- data.frame(L1 = rep("A", 10),
                     L2 = rep(c("B1", "B2"), c(5, 5)),
                     L3 = rep(NA, 10),
                     L4 = rep(NA, 10),
                     L5 = letters[1:10])
    tr1 <- asPhylo(df1)
    expect_equal(class(tr1), "phylo")
    expect_equal(tr1$Nnode, 3)
    expect_equal(tr1$tip.label, letters[1:10])
    
    # test usNA
    df2 <- data.frame(L1 = rep("A", 10),
                      L2 = rep(c("B1", "B2"), c(5, 5)),
                      L3 = rep("unknown", 10),
                      L4 = rep(c("missing", ""), 5),
                      L5 = letters[1:10])
    tr2 <- asPhylo(df2, asNA = c("unknown", "missing", ""))
    expect_equal(tr1, tr2)    

    df3 <- data.frame(L1 = rep("A", 10),
                      L2 = rep(c("B1", "B2"), c(5, 5)),
                      L5 = letters[1:10])
    tr3 <- asPhylo(df3)
    expect_equal(tr1, tr3)  
    
    # test column_order 
    df4 <- data.frame(L1 = rep("A", 10),
                      L5 = letters[1:10],
                      L2 = rep(c("B1", "B2"), c(5, 5)))
    tr4 <- asPhylo(df3, column_order = c("L1", "L2", "L5"))
    expect_equal(tr3, tr4) 
})

#' add labels to nodes of a tree
#' 
#' \code{addLabel} label nodes of a tree (\code{phylo} object)
#' 
#' @param tree A phylo object
#' @param label A character vector to provide node labels. The label is passed to
#'   nodes that are sorted by their node number in ascending order. The default
#'   is NULL, nodes are labeled by adding a prefix \code{Node_} to their node number. 
#' @param on Chosen from "all", "leaf", "internal". If "all", all nodes are
#'   labeled; if "leaf", leaves are labeled; if "internal", internal nodes are
#'   labeled.
#' @export
#' @return a phylo object
#' @author Ruizhu Huang
#' @examples  
#' data(tinyTree)
#' library(ggtree)
#'
#' # PLOT tree
#' # The node labels are in orange texts and the node numbers are in blue
#' ggtree(tinyTree, branch.length = 'none')+
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#'
#' # change labels
#' nodes <- showNode(tree = tinyTree, only.leaf = FALSE)
#' tt <- addLabel(tree = tinyTree, label = LETTERS[nodes],
#'                on = "all")
#' 
#' ggtree(tt, branch.length = 'none')+
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#' 
addLabel <- function(tree, label = NULL,
                     on = c("all", "leaf", "internal")) {
    on <- match.arg(on)
    
    # edges; leaves; internal nodes
    ed <- tree$edge
    leaf <- setdiff(ed[, 2], ed[, 1])
    leaf <- sort(leaf)
    inNode <- setdiff(ed[, 1], leaf)
    inNode <- sort(inNode)
    allNode <- c(leaf, inNode)
    
    if (on == "leaf") {
        if (is.null(label)) {label <- paste0("Node_", leaf)}
        if (length(label) != length(leaf)) {
            stop("The number of labels and leaves are different.",
                 call. = FALSE)
        }
        tree <- .add_leaf_label(tree = tree, label = label)
    }
    
    if (on == "internal") {
        if (is.null(label)) {label <- paste0("Node_", inNode)}
        if (length(label) != length(inNode)) {
            stop("The number of labels and internal nodes are different.",
                 call. = FALSE)
        }
        tree <- .add_inner_label(tree = tree, label = label)
    }
   
    if (on == "all") {
        if (is.null(label)) {label <- paste0("Node_", c(leaf, inNode))}
        if (length(label) != length(allNode)) {
            stop("The number of labels and nodes are different.",
                 call. = FALSE)
        }
        leafLab <- label[seq_along(leaf)]
        inLab <- setdiff(label, leafLab)
        tree <- .add_leaf_label(tree = tree, label = label[seq_along(leaf)])
        tree <- .add_inner_label(tree = tree, label = inLab)
    }
    
    lab <- c(tree$tip.label, tree$node.label)
    if (anyDuplicated(lab)) {
        warning("The tree has duplicated labels")
    }
    return(tree)
}

.add_leaf_label <- function(tree, label) {
    tree$tip.label <- label
    return(tree)
}
.add_inner_label <- function(tree, label) {
    tree$node.label <- label
    return(tree)
}

context("addLabel")

set.seed(1)
n <- 10
tr <- ape::rtree(n)

test_that("addLabel works properly", {
    tr1 <- addLabel(tree = tr, on = "leaf")
    tr2 <- addLabel(tree = tr, on = "internal")
    tr3 <- addLabel(tree = tr, on = "all")
    
    expect_equal(tr1$tip.label, paste0("Node_", seq_len(n)))
    expect_equal(tr1$tip.label, tr3$tip.label)
    expect_equal(tr2$node.label, tr3$node.label)
    expect_false(setequal(tr1$tip.label, tr2$tip.label))
    
    tr4 <- addLabel(tree = tr, on = "leaf", label = LETTERS[seq_len(n)])
    tr5 <- addLabel(tree = tr, on = "internal", label = LETTERS[seq_len(n-1)])
    tr6 <- addLabel(tree = tr, on = "all", label = LETTERS[seq_len(2*n-1)])
    expect_equal(tr4$tip.label, LETTERS[seq_len(n)])
    expect_equal(tr5$node.label, LETTERS[seq_len(n-1)])
    expect_equal(c(tr6$tip.label, tr6$node.label), LETTERS[seq_len(2*n-1)])
})

#' To print out the node labels
#'
#' \code{nodeLabel} is to print out the node labels of a \code{phylo} tree.
#'
#' @param tree A phylo object.
#' @param type A character value choose from \code{leaf}, \code{all}, and
#'   \code{internal}. If \code{leaf}, the output is a data frame including only
#'   leaf nodes; if \code{internal}, the output is a data frame including only
#'   internal nodes; if \code{all}, the output is a data frame including all
#'   nodes.
#'
#' @export
#' @author Ruizhu HUANG
#' @return a data frame
#' @examples
#' data(tinyTree)
#' library(ggtree)
#'
#' # PLOT tree
#' # The node labels are in orange texts and the node numbers are in blue
#' ggtree(tinyTree,branch.length = 'none')+
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#'
#' (pn1 <- printNode(tinyTree, type = "leaf"))
#' (pn2 <- printNode(tinyTree, type = "internal"))
#' (pn3 <- printNode(tinyTree, type = "all"))
#'
printNode <- function(tree, type = c("leaf","internal","all")){
    
    # ===========check inputs =================
    if (!is(tree, "phylo")) {
        stop("tree should be a phylo object")
    }
    type <- match.arg(type)
    # edges
    edge <- tree$edge

    # all nodes
    nodeA <- unique(as.vector(edge))
    nodeA <- sort(nodeA)

    # the alias label
    labAlias <- tree$alias.label

    if (is.null(labAlias)) {
        labAlias <- paste("alias_", nodeA, sep = "")

    }
    # leaves
    leaf <- setdiff(edge[, 2], edge[, 1])
    leaf <- sort(leaf)
    labL <- tree$tip.label

    outL <- data.frame(nodeLab = labL,
                       nodeLab_alias = paste0("alias_", leaf),
                       nodeNum = leaf,
                       isLeaf = TRUE,
                       stringsAsFactors = FALSE)




    # internal nodes
    nodeI <- setdiff(nodeA, leaf)
    labI <- tree$node.label
    outI <- data.frame(nodeLab_alias = paste0("alias_", nodeI),
                       nodeNum = nodeI,
                       isLeaf = FALSE)
    if (length(labI) == length(nodeI)) {
            outI$nodeLab <- labI
        } else{
            if (length(labI)) {
                warning("The node.label is less than the internal nodes")
                outI$nodeLab <- rep_len(labI, length(nodeI))
            } else {
                outI$nodeLab <- NA
            }
        }
    outI <- outI[, c("nodeLab", "nodeLab_alias", "nodeNum", "isLeaf")]

    if (type == "leaf") { out <- outL }
    if (type == "internal") { out <- outI }
    if (type == "all") { out <- rbind(outL, outI)}

    return(out)
}

context("aggTSE")

set.seed(1)
tse_a <- makeTSE()
tse_b <- makeTSE(include.rowTree = FALSE, include.colTree = FALSE)
tse_c <- makeTSE()
tse_ac <- rbind(tse_a, tse_c)


test_that("aggTSE works correctly", {
    # check error/warning message
    expect_warning(aggValue(x = tse_a, rowLevel = 6),
                   "'aggValue' is deprecated.")     # aggValue is deprecated
    expect_error(aggTSE(x = tse_a, rowLevel = 200)) # the node doesn't exist
    expect_error(aggTSE(x = tse_b, rowLevel = 11))  # the rowTree doesn't exist
    expect_error(aggTSE(x = tse_b, colLevel = 11))  # the rowTree doesn't exist
    expect_message(aggTSE(x = tse_a, rowLevel = 3, message = TRUE),
                   "Preparing data")
    
    # test colBlock & rowBlock
    set.seed(2)
    tse_e <- cbind(tse_a, tse_a, tse_a)
    colData(tse_e)$group <- sample(LETTERS[1:2], size = ncol(tse_e),
                                   replace = TRUE)
    
    cl <- printNode(tree = colTree(tse_e), type = "internal")$nodeNum
    tse_E <- aggTSE(x = tse_e, colLevel = cl, colBlock = "group") 
    
    expect_equal(dim(tse_E), c(10, 6))
    # For alias_7 (2 sample1 & 1 sample2 in A group)
    table(colData(tse_e)$group, colnames(tse_e))
    cd <- colData(tse_E)
    sel1 <- cd$group == "A" & colnames(tse_E) == "alias_7"
    sel2 <- cd$group == "B" & colnames(tse_E) == "alias_7"
    sel3 <- cd$group == "A" & colnames(tse_E) == "alias_5"
    sel4 <- cd$group == "B" & colnames(tse_E) == "alias_5"
    expect_equal(assays(tse_E["entity1", sel1])[[1]][1, 1], 13)
    expect_equal(assays(tse_E["entity1", sel2])[[1]][1, 1], 23)
    expect_equal(assays(tse_E["entity1", sel3])[[1]][1, 1], 117)
    expect_equal(assays(tse_E["entity1", sel4])[[1]][1, 1], 75)
    
    # aggregate on the row dim when one tree in 'rowTree'
    rlev <- printNode(tree = rowTree(tse_a), type = "all")$nodeNum
    tse_R <- aggTSE(x = tse_a, rowLevel = rlev, rowFun = sum)
    expect_equal(assays(tse_R)[[1]][14, ], 
                 setNames(c(6, 36, 66, 96), paste0("sample", 1:4)))
    
    # aggregate on the row dim when multiple trees in 'rowTree'
    rlev <- printNode(tree = rowTree(tse_ac, whichTree = 1), 
                      type = "all")$nodeNum
    tse_RR <- aggTSE(x = tse_ac, rowLevel = rlev, rowFun = sum, 
                    whichRowTree = 1)
    expect_equal(dim(tse_RR), c(19, 4))
    expect_equal(assays(tse_RR)[[1]][14, ], 
                 setNames(c(6, 36, 66, 96), paste0("sample", 1:4)))
    expect_equal(tse_RR, tse_R)
    expect_equal(colnames(rowData(tse_RR)), c("var1", "var2"))
    
    tse_RR <- aggTSE(x = tse_ac, rowLevel = rlev, rowFun = sum, 
                     whichRowTree = 1, rowDataCols = "var1")
    expect_equal(colnames(rowData(tse_RR)), "var1")
    
    # aggregate on the col dim when one tree in 'colTree'
    expect_warning(tse_ac <- cbind(tse_a, tse_c))
    clev <- printNode(tree = colTree(tse_a), type = "all")$nodeNum
    tse_C <- aggTSE(x = tse_a, colLevel = clev, colFun = sum)
    expect_equal(assays(tse_C)[[1]][, 6], 
                 setNames(seq(from = 33, by = 3, length.out = 10), 
                          paste0("entity", 1:10)))
    
    # aggregate on the col dim when multiple trees in 'colTree'
    clev <- printNode(tree = colTree(tse_ac, whichTree = 1), 
                      type = "all")$nodeNum
    tse_CC <- aggTSE(x = tse_ac, colLevel = clev, colFun = sum, 
                     whichColTree = 1)
    expect_equal(dim(tse_CC), c(10, 7))
    expect_equal(assays(tse_CC)[[1]][, 6], 
                 setNames(seq(from = 33, by = 3, length.out = 10), 
                          paste0("entity", 1:10)))
    expect_equal(tse_CC, tse_C)
    
    tse_CC <- aggTSE(x = tse_ac, colLevel = clev, colFun = sum, 
                     whichColTree = 1, colDataCols = c("ID"))
    expect_equal(colnames(colData(tse_CC)), "ID")
    
    
    clev2 <- printNode(tree = colTree(tse_ac, whichTree = 2), 
                      type = "all")$nodeNum
    tse_CC2 <- aggTSE(x = tse_ac, colLevel = clev2, colFun = sum, 
                     whichColTree = 2)
    expect_equal(dim(tse_CC2), c(10, 7))
    expect_equal(assays(tse_CC2)[[1]][, 6], 
                 setNames(seq(from = 63, by = 3, length.out = 10), 
                          paste0("entity", 1:10)))
    
    # aggregate on both dims
    rl <- printNode(tree = rowTree(tse_a, whichTree = 1), 
                    type = "internal")$nodeNum
    cl <- printNode(tree = colTree(tse_a, whichTree = 1), 
                    type = "internal")$nodeNum
    tse_B <- aggTSE(tse_a, rowLevel = rl, colLevel = cl, 
                    rowFun = sum, colFun = sum)
    count <- assays(tse_B)[[1]]
    expect_equal(count[1, 1], sum(assays(tse_a)[[1]]))
    
    # Use rowFUN = median, rowFirst = TRUE & rowFirst = FALSE
    set.seed(2)
    new_count <- matrix(rnorm(nrow(tse_a)*ncol(tse_a), mean = 10, sd = 2),
                        nrow = nrow(tse_a))
    rownames(new_count) <- rownames(tse_a)
    colnames(new_count) <- colnames(tse_a)
    assays(tse_a)[["new"]] <- new_count
    tse_RF <- aggTSE(x = tse_a, rowLevel = rl, rowFun = median, 
                     colLevel = cl, colFun = median, 
                     rowFirst = TRUE, whichAssay = "new")
    tse_CF <- aggTSE(x = tse_a, rowLevel = rl, rowFun = median, 
                     colLevel = cl, rowFirst = FALSE, whichAssay = "new")
    
    expect_false(identical(assays(tse_RF)[[1]], assays(tse_CF)[[1]]))
    
    
    
    
    # test the parallel computation
    set.seed(2)
    tse_d <- makeTSE(nrow = 1000, ncol = 1000)
    rl <- printNode(tree = rowTree(tse_d), type = "internal")$nodeNum
    cl <- printNode(tree = colTree(tse_d), type = "internal")$nodeNum
    
    tse_D <- aggTSE(x = tse_d, rowLevel = rl, colLevel = cl)
    tse_DD <- aggTSE(x = tse_d, rowLevel = rl, colLevel = cl, 
                     BPPARAM = BiocParallel::MulticoreParam(workers = 2, 
                                                            progressbar = TRUE))
    expect_equal(tse_D, tse_DD)
})

#' Find descendants (or offsprings)
#'
#' \code{findDescendant} finds descendants of a node.
#'
#' @param node An internal node. It could be the node number or the node
#'   label.
#' @param tree A phylo object.
#' @param only.leaf A logical value, TRUE or FALSE. The default is TRUE. If
#'   default, only the leaf nodes in the descendant nodes would be returned.
#' @param self.include A logical value, TRUE or FALSE. The default is FALSE. If
#'   TRUE, the node specified in \strong{node} is included and the leaf node
#'   itself is returned as its descendant.
#' @param use.alias A logical value, TRUE or FALSE. The default is FALSE, and
#'   the node label would be used to name the output; otherwise, the alias of
#'   node label would be used to name the output. The alias of node label is
#'   created by adding a prefix \code{"alias_"} to the node number.
#' @export
#' @return A vector of nodes. The numeric value is the node number, and the
#'   vector name is the corresponding node label. If a node has no label, it
#'   would have NA as name when \code{use.alias = FALSE}, and have the alias of
#'   node label as name when \code{use.alias = TRUE}.
#' @author Ruizhu Huang
#'
#' @examples
#' data(tinyTree)
#'
#' library(ggtree)
#' ggtree(tinyTree) +
#' geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7) +
#' geom_hilight(node = 17, fill = 'steelblue', alpha = 0.5) +
#' geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7)
#'
#' (tips <- findDescendant(tree = tinyTree, node = c(17), only.leaf = TRUE))

findDescendant <- function(tree,
                   node,
                   only.leaf = TRUE,
                   self.include = FALSE,
                   use.alias = FALSE) {
    
    if (!inherits(tree, "phylo")) {
        stop("tree: should be a phylo object")
    }
    
    if (anyDuplicated(node)) {
        warning("duplicated values are found in input 'node'")
    }
    
    if (!(is.character(node) |
          is.numeric(node) |
          is.integer(node))) {
        stop("The argument (node) should be character or numeric")
    }
    # the edge matrix
    mat <- tree$edge
    matN <- matTree(tree = tree)
    
    if (is.character(node)) {
        numA <- convertNode(tree = tree, node = node,
                          use.alias = TRUE,
                          message = FALSE)
    } else {
        numA <- node
        isOut <- !numA %in% mat
        if (any(isOut)) {
            stop("Node ", numA,
                 " can't be found in the ",
                 deparse(substitute(tree)), "\n")
        }
        
    }
    
    loc <- lapply(seq_len(ncol(matN)), FUN = function(x){
        xx <- matN[, x]
        xm <- match(xx, numA)
        # which elements in xx could be matched to numA
        xi <- which(!is.na(xm))
        # which elements in numA
        mi <- xm[!is.na(xm)]
        
        mm <- cbind("row" = xi,
                    "col" = rep(x, length(xi)),
                    "node" = numA[mi])
        
    })
    
    moc <- do.call(rbind, loc)
    
    
    # separate leaf and internal nodes
    mocL <- moc[moc[, "col"] == 1, , drop = FALSE]
    mocI <- moc[moc[, "col"] != 1, , drop = FALSE]
    
    if (only.leaf) {
        if (!self.include) {
            mocL<- NULL
        }
        if (nrow(mocI)) {
            mocI[, "col"] <- 1
        }
        
    } else {
        if (!self.include) {
            mocL <- NULL
            if (nrow(mocI)) {
                mocI[, "col"] <- mocI[, "col"] - 1
            }
        }
        ll <- lapply(mocI[, "col"],
                     FUN = function(x) {
                         seq(from = 1, to = x , by = 1)
                     })
        mocII <- cbind("row" = rep(mocI[, "row"], mocI[, "col"]),
                       "col" = unlist(ll),
                       "node" = rep(mocI[, "node"], mocI[, "col"]))
        mocI <- mocII
    }
    
    out <- vector("list", length(numA))
    if (is.null(mocL)) {
        mocC <- mocI
    } else {
        mocC <- rbind(mocL, mocI)
    }
    
    # descendants: get, remove duplicates and sort
    desd <- cbind("found" = matN[mocC[, c("row", "col"), drop = FALSE]],
                  "node" = mocC[, "node"])
    desd <- desd[!duplicated(desd), , drop = FALSE]
    od <- order(desd[, "node"], desd[, "found"], decreasing = FALSE)
    desd <- desd[od, , drop = FALSE]
    
    # split according to the parent node
    parent <- factor(desd[, "node"],
                     levels = unique(desd[, "node"]))
    dList <- split(desd[, "found"], f = parent)
    
    # output result in the order as the input node
    #o <- match(unique(desd[, "node"]), numA)
    # out[o] <- dList
    o <- match(numA, unique(desd[, "node"]))
    out <- dList[o]
    names(out) <- convertNode(tree = tree, node = numA,
                            use.alias = use.alias)
    return(out)
}

context("findDescendant")

data("tinyTree")

test_that("findDescendant return error when the node is not in the tree", {
    expect_error(findDescendant(node = 20, tree = tinyTree, only.leaf = TRUE))
    expect_error(findDescendant(node = 2, tree = 2, only.leaf = TRUE))
})

test_that("findDescendant could find descendant leaves correctly", {
    expect_findDescendant_leaf_expect_equal <- function(node, truth) {
        x <- findDescendant(node = node, tree = tinyTree,
                    only.leaf = TRUE, self.include = TRUE)[[1]]
        expect_equal(x, truth)
    }

    expect_findDescendant_leaf_expect_equal(15, 4:9)
    expect_findDescendant_leaf_expect_equal(13, 1:3)
    expect_findDescendant_leaf_expect_equal(18, 4:5)
    expect_findDescendant_leaf_expect_equal(11, 1:10)
})

test_that("findDescendant could find all descendant nodes correctly", {
    expect_findDescendant_leaf_expect_equal <- function(node, truth) {
        x <- findDescendant(node = node, tree = tinyTree,
                    only.leaf = FALSE, self.include = FALSE)[[1]]
        expect_equal(x, truth)
    }

    expect_findDescendant_leaf_expect_equal(15, c(4:9,16:19))
    expect_findDescendant_leaf_expect_equal(17, c(4:6,18))
    expect_findDescendant_leaf_expect_equal(11, c(1:10, 12:19))
})

test_that("findDescendant could include the input node in the result", {
    expect_findDescendant_leaf_expect_equal <- function(node, truth) {
        x <- findDescendant(node = node, tree = tinyTree,
                    only.leaf = TRUE, self.include = TRUE)[[1]]
        expect_equal(x, truth)
    }

    expect_findDescendant_leaf_expect_equal(5, 5)
    expect_findDescendant_leaf_expect_equal(17, c(4:6))
})

#' Find the ancestors of specified nodes
#'
#' \code{findAncestor} finds the ancestor in the nth generation above
#' specified nodes.
#'
#' @param tree A phylo object
#' @param node A vector of node numbers or node labels
#' @param level A vector of numbers to define nth generation before the
#' specified nodes
#' @param use.alias A logical value, TRUE or FALSE. The default is FALSE, and
#'   the node label would be used to name the output; otherwise, the alias of
#'   node label would be used to name the output. The alias of node label is
#'   created by adding a prefix \code{"alias_"} to the node number.
#' @export
#' @return A vector of nodes. The numeric value is the node number, and the
#'   vector name is the corresponding node label. If a node has no label, it
#'   would have NA as name when \code{use.alias = FALSE}, and have the alias of
#'   node label as name when \code{use.alias = TRUE}.
#' @author Ruizhu Huang
#'
#' @examples
#' library(ggtree)
#' data(tinyTree)
#' ggtree(tinyTree, branch.length = 'none') +
#'  geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'  geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#'
#'  findAncestor(tree = tinyTree, node = c(18, 13), level = 1)

findAncestor <- function(tree, node, level,
                         use.alias = FALSE) {

    if (!inherits(tree, "phylo")) {
        stop("tree: should be a phylo object", call. = FALSE)
    }

    if (!length(node)) {
        stop("Please provide at least one node on the tree.", call. = FALSE)
    }
    # convert a tree to a matrix
    # each row is a path connecting the root and a leaf
    treeMat <- matTree(tree)


    if (is.character(node)) {
        node <- convertNode(tree = tree, node = node,
                            use.alias = TRUE,
                            message = FALSE)
    }

    if (length(level) == 1) {
        level <- rep(level, length(node))
    } else {
        if (length(level) == length(node)) {
            level <- level
        } else {
            stop("the length of level is not equal to the length of node",
                 call. = FALSE)
        }
    }

    selNod <- lapply(seq_along(node), FUN = function(x) {
        # the node
        nod.x <- node[x]

        # where is the node
        ind <- which(treeMat == nod.x, arr.ind = TRUE)

        # the level
        level.x <- level[x]
        ind.x <- ind
        ind.x[, "col"] <- ind[, "col"] + level.x

        if (any (ind.x[, "col"] > ncol(treeMat))) {
            stop("Exceed the root; try a lower level.")
        }

        vv <- treeMat[ind.x]
        uv <- unique(as.vector(vv))

        if (length(uv) > 1) {
            stop("More than one node are found.")
        }
        return(uv)
    })

    out <- unlist(selNod)

    # return a vector of the found node (the node number of the node)
    # name the vector with the node label
    names(out) <- convertNode(tree = tree, node = out,
                            use.alias = use.alias,
                            message = FALSE)
    return(out)
}

#' list leaf nodes that are the descendants of at least one specified node
#'
#' \code{unionLeaf} list the leaf nodes that are the desendants of (at least one)
#' specified nodes.
#'
#' @param tree A phylo object.
#' @param node A numeric or character vector. It specifies internal nodes that
#'   are changed to leaves via their node labels or numbers.
#' @importFrom methods is
#' @export
#' @return A phylo object.
#'
#' @examples
#' library(ggtree)
#' data(tinyTree)
#' ggtree(tinyTree, ladderize = FALSE) +
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7) +
#'     geom_hilight(node = 18) +
#'     geom_point2()
#'
#' u1 <- unionLeaf(tree = tinyTree, node = c(19, 17))
#' u2 <- unionLeaf(tree = tinyTree, node = c(19, 17, 7))
#' (u3 <- unionLeaf(tree = tinyTree, node = c(11, 17, 7)))
unionLeaf <- function(tree, node) {

  # ===========check inputs =================
  if (!is(tree, "phylo")) {
    stop("tree should be a phylo object")
  }

  if (!is(node, "numeric") & !is(node, "character")) {
    stop("node should a numeric or character vector")
  }
  # ============remove descendants ============
  if (is(node, "character")) {
    node <- convertNode(tree = tree, node = node)
  }

  # all paths that connecting leaves and the root
  mat <- matTree(tree = tree)

  loc <- lapply(seq_len(ncol(mat)), FUN = function(x){
    xx <- mat[, x]
    xm <- match(xx, node)

    # which elements in xx could be matched to numA
    xi <- which(!is.na(xm))
    return(xi)
    })
  loc <- unlist(loc)
  loc <- unique(loc)

  moc <- cbind("row" = loc, "col" = rep(1, length(loc)))

  out <- sort(mat[moc])
  return(out)
  }

#' Perform data aggregations based on the available tree structures
#'
#' \code{aggTSE} aggregates values on the leaf nodes of a tree to a specific
#' arbitrary level of the tree. The level is specified via the nodes of the
#' tree. Users could decide on which dimension (row or column) and how should
#' the aggregation be performed.
#'
#' @param x A \code{TreeSummarizedExperiment} object.
#' @param rowLevel A numeric (node numbers) or character (node labels) vector.
#'   It provides the level on the tree that data is aggregated to. The
#'   aggregation is on the row dimension. The default is \code{rowLevel = NULL},
#'   and no aggregation is performed.
#' @param rowBlock A column name in the \code{rowData} to separate the
#'   aggregation.
#' @param colLevel A numeric (node numbers) or character (node labels) vector.
#'   It provides the level on the tree that data is aggregated to. The
#'   aggregation is on the column dimension. The default is \code{colLevel =
#'   NULL}, and no aggregation is performed.
#' @param colBlock A column name in the \code{colData} to separate the
#'   aggregation.
#' @param rowFun A function to be applied on the row aggregation. It's similar
#'   to the \code{FUN} in \code{\link[base]{apply}}.
#' @param colFun A function to be applied on the col aggregation. It's similar
#'   to the \code{FUN} in \code{\link[base]{apply}}.
#' @param whichAssay A integer scalar or string indicating which assay of
#'   \code{x} to use in the aggregation. If NULL, all assay tables are used in
#'   aggregation.
#' @param whichRowTree A integer scalar or string indicating which row tree is
#'   used in the aggregation. The first row tree is used as default.
#' @param whichColTree A integer scalar or string indicating which row tree is
#'   used in the aggregation. The first row tree is used as default.
#' @param whichRowTree A integer scalar or string indicating which row tree is
#'   used in the aggregation. The first row tree is used as default.
#' @param rowDataCols The rowData columns to include.
#' @param colDataCols The colData columns to include.
#' @param rowFirst TRUE or FALSE. If the aggregation is in both dims., it is
#'   performed firstly on the row dim for \code{rowFirst = TRUE} or on the
#'   column dim for \code{rowFirst = FALSE}.
#' @param message A logical value. The default is TRUE. If TRUE, it will print
#'   out the running process.
#' @param BPPARAM Default is \code{NULL} and the computation isn't run in
#'   parallel. To run computation parallelly, an optional
#'   \code{\link[BiocParallel:BiocParallelParam-class]{BiocParallelParam}}
#'   instance determining the parallel back-end to be used during evaluation, or
#'   a list of BiocParallelParam instances, to be applied in sequence for nested
#'   calls to \strong{BiocParallel} functions.
#' @import SingleCellExperiment
#' @importFrom utils flush.console
#' @importFrom BiocParallel bplapply
#' @include allClass.R
#' @export
#' @author Ruizhu HUANG
#' @return A \code{\link{TreeSummarizedExperiment}} object 
#' @examples
#'
#' # assays data
#' set.seed(1)
#' toyTable <- matrix(rnbinom(20, size = 1, mu = 10), nrow = 5)
#' colnames(toyTable) <- paste(rep(LETTERS[1:2], each = 2),
#'                             rep(1:2, 2), sep = "_")
#' rownames(toyTable) <- paste("entity", seq_len(5), sep = "")
#'
#' toyTable
#'
#' # the column data
#' colInf <- DataFrame(gg = c(1, 2, 3, 3),
#'                     group = rep(LETTERS[1:2], each = 2),
#'                     row.names = colnames(toyTable))
#' colInf
#'
#' # the toy tree
#' library(ape)
#' set.seed(4)
#' treeC <- rtree(4)
#' treeC$node.label <- c("All", "GroupA", "GroupB")
#'
#' library(ggtree)
#' ggtree(treeC, size = 2) +
#'    geom_text2(aes(label = node), color = "darkblue",
#'            hjust = -0.5, vjust = 0.7, size = 6) +
#'     geom_text2(aes(label = label), color = "darkorange",
#'                hjust = -0.1, vjust = -0.7, size = 6)
#'
#'
#' tse <- TreeSummarizedExperiment(assays = list(toyTable),
#'                                 colData = colInf,
#'                                 colTree = treeC,
#'                                 colNodeLab = treeC$tip.label,
#'                                 metadata = list(test = 1:4))
#'
#' aggCol <- aggTSE(x = tse, colLevel = c("GroupA", "GroupB"),
#'                  colFun = sum)
#'
#' assays(aggCol)[[1]]
#'
aggTSE <- function(x, 
                   rowLevel = NULL, rowBlock = NULL, 
                   colLevel = NULL, colBlock = NULL, 
                   rowFun = sum, colFun = sum,
                   whichRowTree = 1, whichColTree = 1,
                   whichAssay = NULL,
                   message = FALSE,
                   rowDataCols,
                   colDataCols,
                   rowFirst = TRUE, BPPARAM = NULL) {
    ## --------------------- check input before run ---------------------------
    ## x is a TreeSummarizedExperiment
    if (!is(x, "TreeSummarizedExperiment")) {
        stop("x should be a TreeSummarizedExperiment", call. = FALSE)
    }
    x <- updateObject(x)
    
    ## The provided rowLevel or colLevel should be a numeric or character vector
    isR <- (is.character(rowLevel) | is.numeric(rowLevel) |
                is.null(rowLevel))
    isC <- (is.character(colLevel) | is.numeric(colLevel) |
                is.null(colLevel))
    if (!isR) {
        stop("rowLevel should be a numeric or character vector. \n",
             call. = FALSE)
    }
    if (!isC) {
        stop("colLevel should be a numeric or character vector. \n",
             call. = FALSE)
    }
    
    ## ---------------------- get all data ready ------------------------------
    if (message) {message("Preparing data... ")}
    
    ## The trees
    rTree <- rowTree(x, whichTree = whichRowTree)
    cTree <- colTree(x, whichTree = whichColTree)
    
    ## subset x by trees
    rtn <- rowTreeNames(x)[whichRowTree]
    ctn <- colTreeNames(x)[whichColTree]
    
    ## Indicate whether aggregation should be on rows or columns
    if (is.null(rowLevel)) {
        onRow <- FALSE
    } else {
        if (is.null(rTree)) {stop("The tree on rows doesn't exist.",
                                  call. = FALSE)}
        # subset x by rows that are mapped to the specified tree
        ii <- rowLinks(x)$whichTree == rtn
        x <- x[ii, ]
        si <- sum(ii) < nrow(x)
        if (message & si) {
            message("Subset x by tree: ", sum(ii), " rows are left.")
        }
        onRow <- TRUE
        if (message) {
            message("Perform aggregation on the row dimension... ")
        }
    }
    
    if (is.null(colLevel)) {
        onCol <- FALSE
    } else {
        if (is.null(cTree)) {stop("The tree on columns doesn't exist.",
                                  call. = FALSE)}
        
        # subset x by rows that are mapped to the specified tree
        jj <- colLinks(x)$whichTree == ctn
        x <- x[, jj]
        sj <- sum(jj) < ncol(x)
        if (message & sj) {
            message("Subset x by tree: ", sum(jj), " cols are left.")
        }
        onCol <- TRUE
        if (message) {
            message("Perform aggregation on the column dimension... ")
        }
    }
    
    if (missing(rowDataCols)) {
        rowDataCols <- colnames(rowData(x))
    }
    if (missing(colDataCols)) {
        colDataCols <- colnames(colData(x))
    }
    
    ## The assay tables
    mat <- assays(x)
    if (!is.null(whichAssay)) {mat <- mat[whichAssay]}
    
    ## -------------------- aggregation on row dimension -------------------
    if (rowFirst) {
        x <- .agg_row(x = x, tree = rTree, assayTab = mat,
                      level = unique(rowLevel),
                      rowDataCols = rowDataCols,
                      block = rowBlock, FUN = rowFun, 
                      message = message, onRow = onRow,
                      BPPARAM = BPPARAM)
        ## Update the assay tables for the aggregation on the other dim.
        mat <- assays(x)
    }
    ## -------------------- aggregation on column dimension ----------------
    x <- .agg_col(x = x, tree = cTree, assayTab = mat,
                  level = unique(colLevel),
                  colDataCols = colDataCols,
                  block = colBlock, FUN = colFun, 
                  message = message, onCol = onCol,
                  BPPARAM = BPPARAM)
    
    if (!rowFirst) {
        ## Update the assay tables
        mat <- assays(x)
        x <- .agg_row(x = x, tree = rTree, assayTab = mat,
                      level = unique(rowLevel),
                      rowDataCols =rowDataCols,
                      block = rowBlock, FUN = rowFun, 
                      message = message, onRow = onRow,
                      BPPARAM = BPPARAM)
    }
    
    updateObject(x)
    return(x)
}


.agg_row <- function(x, tree, assayTab, level,
                     rowDataCols,
                     block, FUN, message, onRow, BPPARAM) {
    
    if (onRow) {
        if (message) {
            message("The row aggregation is using ", deparse(substitute(FUN)))
        }
        
        rD <- rowData(x)
        rL <- rowLinks(x)
        outR <- .aggFun(tree = tree,
                        assayTab = assayTab,
                        dimData = rD,
                        linkData = rL,
                        cols = rowDataCols,
                        level = level,
                        block = block,
                        FUN = FUN,
                        message = message,
                        BPPARAM = BPPARAM)
        nrD <- outR$newDD
        nrD <- nrD[, setdiff(colnames(nrD), "nodeLab"), drop = FALSE]
        nLab <- outR$newDD$nodeLab
        mat <- outR$dataTab
    } else {
        mat <- assayTab
        nrD <- rowData(x)[, rowDataCols, drop = FALSE]
        if (!is.null(tree)) {
            nLab <- rowLinks(x)$nodeLab
        } else {
            nLab <- NULL
        }
    }
    
    # new TSE: 
    xx <- TreeSummarizedExperiment(assays = mat,
                                   rowData = nrD,
                                   rowTree = tree,
                                   rowNodeLab = nLab,
                                   referenceSeq = NULL,
                                   colData = colData(x),
                                   metadata = metadata(x))
    xx <- BiocGenerics:::replaceSlots(object = xx, 
                                      colTree = colTree(x, whichTree = NULL),
                                      colLinks = colLinks(x),
                                      check = FALSE)
    return(xx)
}



.agg_col <- function(x, tree, assayTab, level,
                     colDataCols,
                     block, FUN, message, onCol,
                     BPPARAM) {
    
    if (onCol) {
        if (message) {
            message("The column aggregation is using ",
                    deparse(substitute(FUN)))
        }
        cD <- colData(x)
        cL <- colLinks(x)
        outC <- .aggFun(tree = tree,
                        assayTab = lapply(assayTab, t),
                        dimData = cD,
                        linkData = cL,
                        cols = colDataCols,
                        level = level,
                        block = block,
                        FUN = FUN, 
                        message = message,
                        BPPARAM = BPPARAM)
        ncD <- outC$newDD
        ncD <- ncD[, setdiff(colnames(ncD), "nodeLab"), drop = FALSE]
        nLab <- outC$newDD$nodeLab
        mat <- lapply(outC$dataTab, t)
    } else {
        mat <- assayTab
        ncD <- colData(x)[, colDataCols, drop = FALSE]
        if (!is.null(tree)) {
            nLab <- colLinks(x)$nodeLab
        } else {nLab <- NULL}
        
    }
    
    xx <- TreeSummarizedExperiment(assays = mat,
                                   colData = ncD,
                                   colTree = tree,
                                   colNodeLab = nLab,
                                   referenceSeq = referenceSeq(x),
                                   rowData = rowData(x),
                                   metadata = metadata(x))
    xx <- BiocGenerics:::replaceSlots(object = xx, 
                                      rowTree = rowTree(x, whichTree = NULL),
                                      rowLinks = rowLinks(x),
                                      check = FALSE)
    return(xx)
}

.aggFun <- function(tree, assayTab, dimData, linkData,
                    cols, 
                    level = NULL, block = NULL, FUN, 
                    message = FALSE, BPPARAM) {
    
    # nodeNum & block
    numR <- linkData$nodeNum
    if (!is.null(block)) {
        bk <- dimData[[block]]  
    } else {
        bk <- rep(1, length(numR))
    }
    
    nodeBk <- data.frame(numR, bk, stringsAsFactors = FALSE)
    
    # dimData
    dimData <- dimData[, cols, drop = FALSE]
    
    # All node numbers on the tree
    ed <- tree$edge
    numAR <- unique(as.vector(ed))
    
    # The aggregation level
    if (is.character(level)) {
        level <- convertNode(tree = tree, node = level,
                             use.alias = FALSE, message = FALSE)
    }
    
    # The descendants of the aggregation level
    desR <- findDescendant(tree = tree, node = level,
                           only.leaf = TRUE, self.include = TRUE)
    names(desR) <- convertNode(tree = tree, node = level,
                               use.alias = TRUE, message = FALSE)
    
    
    # Find the rows of the descendants
    miR <- setdiff(unique(unlist(desR)), numR)
    if (length(miR)) {
        warning(length(miR), 
                " leaves couldn't be found from the assay table.\n")
        miR <- convertNode(tree = tree, node = miR,
                           use.alias = FALSE, message = FALSE)
        warning("Missing leaves: ", paste(head(miR), collapse = " "), " ...")
    }
    
    ## Perform the aggregation
    # on the assay tables
    
    if (message) {
        message("Working on the assays table... ")}
    
    # aggregate all assay tables together
    nc <- ncol(assayTab[[1]])
    ncn <- colnames(assayTab[[1]])
    mtab <- do.call(cbind, assayTab)
    
    if (is.null(BPPARAM)) {
        # The computation is not run in parallel
        # lapply is in some case much faster than `bplapply` 
        # (https://gist.github.com/fionarhuang/c59c0d1eabd36d8b6fbfda61d06cb951)
        
        res <- lapply(seq_along(desR), FUN = function(x) {
            if (message) {
                message(x, " out of ", length(desR),
                        " finished", "\r", appendLF = FALSE)
                flush.console()
            }
            .agg_assay(desd = desR[[x]], nodeRow = numR, 
                       nodeBlock = nodeBk, assayTab = mtab,
                       dimData = dimData, FUN = FUN)})
    } else {
        # The computation is run in parallel
        res <- bplapply(desR, FUN = function(x) {
            .agg_assay(desd = x, nodeRow = numR, 
                       nodeBlock = nodeBk, assayTab = mtab,
                       dimData = dimData, FUN = FUN)},
            BPPARAM = BPPARAM)
    }
    
    
    # separate the results into the original number of assays tables as input
    if (message) {
        message("unwrap data ... ")}
    
    assayL <- do.call(rbind, lapply(res, FUN = function(x) {x$new_assays}))
    ll <- lapply(res, FUN = function(x) {x$new_n})
    ll <- unlist(ll)
    annL <- lapply(res, FUN = function(x) {x$new_dimData})
    
    outR <- vector("list", length(assayTab))
    names(outR) <- names(assayTab)
    for (i in seq_along(outR)) {
        ii <- seq(from = (i-1)*nc + 1, to = i*nc, by = 1)
        rii <- assayL[, ii, drop = FALSE]
        colnames(rii) <- ncn
        outR[[i]] <- rii
    }
    
    # use the same row names as outR
    if (ncol(dimData)) {
        newDD <- do.call(rbind, annL)
        colnames(newDD) <- cols
    } else {
        newDD <- dimData[rep(1, sum(ll)), , drop = FALSE]
    }
    
    newDD$nodeLab <- rep(names(desR), ll)
    newDD <- DataFrame(newDD)
    rownames(newDD) <- rep(names(desR), ll)
    
    out <- list(dataTab = outR, newDD = newDD)
    return(out)
}

.agg_assay <- function(desd, nodeRow, nodeBlock, assayTab,
                       dimData, FUN) {
    # assay table
    ri <- which(nodeRow %in% desd)
    sri <- split(ri, nodeBlock[ri, "bk"])
    
    ax <- lapply(sri, FUN = function(x) {
        xx <- assayTab[x, , drop = FALSE]
        fx <- apply(xx, 2, FUN = FUN)
        fx <- rbind(fx)
        rownames(fx) <- NULL
        fx
    })
    rax <- do.call(rbind, ax)
    
    
    li <- lapply(ax, nrow)
    sli <- sum(unlist(li))
    
    if (ncol(dimData)) {
        dl <- lapply(sri, FUN = function(x) {
            if (!length(x)) {
                xx <- dimData[1, , drop = FALSE]
                xx[] <- NA
                xx
            } else {
                xx <- as.list(dimData[x, , drop = FALSE])
                ux <- lapply(xx, .unique_or_na)
                do.call(cbind.data.frame, ux)
            }
        })
        ru <- mapply(.rep_df, df = dl, n=li, SIMPLIFY = FALSE)
        dimData <- do.call(rbind, ru)
    }
    
    out <- list(new_assays = rax,
                new_n = sli,
                new_dimData = dimData)
    return(out)
}


.unique_or_na <- function(x) {
    xx <- unique(x)
    if (length(xx) > 1) {
        NA
    } else {
        xx
    }
}

.rep_df <- function(df, n){
    dff <- df[rep(seq_len(nrow(df)), each = n), ]
    data.frame(dff)
}

#' Translate a data frame to a phylo object
#'
#' \code{toTree} translates a data frame to a phylo object
#'
#' @param data A data frame or matrix.
#' @param column_order A vector that includes the column names of data to
#'   reorder columns of \code{data}. Default is NULL, the original order of
#'   \code{data} is kept.
#' @details The last column is used as the leaf nodes
#' @importFrom S4Vectors head tail
#' @importFrom dplyr arrange_all
#' @importFrom rlang .data
#' @importFrom ape reorder.phylo
#' @importFrom stats reorder
#' @return a phylo object
#' @author Ruizhu HUANG
#' @export
#' @examples
#' 
#' library(ggtree)
#' # Example 1:
#' taxTab <- data.frame(R1 = rep("A", 5),
#'                      R2 = c("B1", rep("B2", 4)),
#'                      R3 = paste0("C", 1:5))
#' # Internal nodes: their labels are prefixed with colnames of taxTab
#' #  e.g., R2:B2
#' tree <- toTree(data = taxTab)
#' # viz the tree           
#'  ggtree(tree) + 
#'  geom_text2(aes(label = label), color = "red", vjust = 1) + 
#'  geom_nodepoint()
#' 
#' # Example 2: duplicated rows in the 3rd and 4th rows
#' taxTab <- data.frame(R1 = rep("A", 5),
#'                      R2 = c("B1", rep("B2", 4)),
#'                      R3 = c("C1", "C2", "C3", "C3", "C4"))
#' # duplicated rows are removed with warnings
#' tree <- toTree(data = taxTab)
#' 
#' # Example 3: NA values in R2 column 
#' # results: the internal node with the label 'R2:'
#' taxTab <- data.frame(R1 = rep("A", 5),
#'                      R2 = c("B1", rep("B2", 2), NA, "B2"),
#'                      R3 = c("C1", "C2", "C3", NA, "C4"))
#' tree <- toTree(data = taxTab)
#' # viz the tree           
#'  ggtree(tree) + 
#'  geom_text2(aes(label = label), color = "red", vjust = 1) + 
#'  geom_nodepoint()
#' 
#' # Example 4: duplicated values in the leaf column (R4)
#' # Not allowed and give errors
#' # taxTab <- data.frame(R1 = rep("A", 5),
#' #                      R2 = c("B1", rep("B2", 3), "B3"),
#' #                      R3 = c("C1", "C2", "C3", "C3",NA),
#' #                      R4 = c("D1", "D2", "D3", NA, NA))
#' 
#' # Example 5: loops caused by missing values in B2-C4, B3-C4
#' taxTab <- data.frame(R1 = rep("A", 6),
#'                      R2 = c("B1", rep("B2", 4), "B3"),
#'                      R3 = c("C1", "C2", "C3", "C3", "C4", "C4"),
#'                      R4 = c("D1", "D2", "D3", "D3", "D4" , "D4"),
#'                      R5 = paste0("E", 1:6))
#'  # resolove loops before run to Tree
#'  # Suffix are adding to C4
#'  taxNew <- resolveLoop(taxTab)           
#'  tree <- toTree(data = taxNew)
#'  
#'  # viz the tree           
#'  ggtree(tree) + 
#'  geom_text2(aes(label = label), color = "red", vjust = 1) + 
#'  geom_nodepoint()


toTree <- function(data, column_order = NULL) {
    
    data <- data %>% data.frame() %>%
        mutate_if(is.factor, as.character) 
    
    data <- replace(data, is.na(data), "NA")
    
    # remove duplicated rows
    isDup <- duplicated(data)
    if (any(isDup)) {
       warning(sum(isDup), " duplicated rows are removed")
        data <- data[!isDup, , drop = FALSE]
    }
    
    # check duplicated leaves
    vleaf <- data[, ncol(data)]
    if (anyDuplicated(vleaf)) {
        stop("Not allowed to have duplicated values in the leaf column: ", 
             colnames(data)[ncol(data)])
    }
    
    # the column order 
    if (!is.null(column_order)) {
        data <- data[, column_order, drop = FALSE]
    }
    column_order <- colnames(data)
    
    # The column should start from high level to low level (the root has the
    # highest level)
    ncat <- apply(data, 2, FUN = function(x) {
        length(unique(x))
    })
    if (is.unsorted(ncat)) {
        stop("The current column order: ", 
             paste(column_order, collapse = " "), ";
             Please order columns from high to low. 
             (High: the root; Low: leaves)")
    }
    
    data <- arrange_all(data.frame(data, stringsAsFactors = FALSE))
    if (ncat[[1]] !=1) {
        warning("The root is added with label 'ALL'")
        data <- cbind(root = rep("ALL", nrow(data)), data)
    }
    
    # decide leaf nodes
    vleaf <- data[, ncol(data)]
    numL <- seq_along(vleaf)
    names(numL) <- vleaf
    
    
    # decide internal nodes
    nc <- ncol(data) - 1
    
    datL1 <- lapply(seq_len(nc), FUN = function(x) {
        xx <- data[, x]
        nam <- colnames(data)[x]
        paste(nam, xx, sep = ":")
    })
    datL2 <- do.call(cbind, datL1)
    
    nodeI <- as.vector(t(datL2))
    nodeI <- setdiff(nodeI, vleaf)
    numI <- length(numL) + seq_along(nodeI)
    names(numI) <- nodeI
    
    # all nodes
    numN <- c(numL, numI)
    
    # create edges
    datL3 <- cbind(datL2, vleaf)
    mat1 <- apply(datL3, 2, FUN = function(x) {
        numN[x]})
    
    nr <- nrow(datL3)
    lx <- lapply(seq_len(nr), FUN = function(x) {
        mx <- mat1[x, ]
        mx <- mx[!is.na(mx)]
        cx <- cbind(head(mx, -1), tail(mx, -1))
        cx})
    
    mat2 <- do.call(rbind, lx)
    mat3 <- mat2[!duplicated(mat2), ]
    
    tt <- table(mat3[, 2])
    if (any(tt > 1)) {
        bt <- tt[tt>1]
        st <- as.numeric(names(bt))
        lt <- gsub(pattern = ".*:",  replacement = "",
                   names(numN[st]))
        ct <- gsub(pattern = ":.*",  replacement = "",
                   names(numN[st]))
        dt <- data.frame(node = st,
                         Freq = as.vector(bt),
                         column = ct,
                         value = lt)
        stop("The tree can't be built; loops detected in the tree.
             Try 'resolveLoop' to remove loops. ")
    }
    
    # sort node number
    numL <- sort(numL)
    numI <- sort(numI)
    
    # tree
    treeList <- vector("list", 5)
    names(treeList) <- c("edge", "tip.label", "node.label",
                         "edge.length", "Nnode")
    treeList$edge <- matrix(mat3, ncol = 2)
    treeList$tip.label <- names(numL)
    treeList$node.label <- names(numI)
    treeList$edge.length <- rep(0.1, nrow(mat3))
    treeList$Nnode <- length(numI)
    class(treeList) <- "phylo"
    treeList <- reorder(treeList)
    
    treeList
}

#' The \code{TreeSummarizedExperiment} package
#'
#' \code{TreeSummarizedExperiment} implement a class of the same name, which
#' extends SingleCellExperiment to include hierarchical information on the rows
#' or columns of the rectangular data.
#'
#' It also includes an additional slot for storing reference sequences per
#' feature.
#'
#' @name TreeeSummarizedExperiment-package
#' @docType package
#' @seealso
#' \link[=TreeSummarizedExperiment-class]{TreeSummarizedExperiment} class
NULL

#' @import methods
NULL

#' TreeSummarizedExperiment internals
#'
#' Internal functions which should only be used in TreeSummarizedExperiment
#'
#' @keywords internal
#'
#' @name TreeSummarizedExperiment-internal
NULL

#' @import SingleCellExperiment S4Vectors
setValidity2("TreeSummarizedExperiment", function(object) {

    errors <- character()
    # -------------------------------------------------------------------------
    # If provided, the row tree should be a phylo object; otherwise, NULL
    rTree <- rowTree(object)

    if (!is.null(rTree)) {
        if (!is(rTree, "phylo")) {
        msg <- "The row tree is not a phylo object. \n"
        errors <- c(errors, msg)
        }
     }

    # If provided, the column tree should be a phylo object; otherwise, NULL
    cTree <- colTree(object)
    if (!is.null(cTree)) {
        if (!is(cTree, "phylo")) {
            msg <- "The column tree is not a phylo object. \n"
            errors <- c(errors, msg)
        }
    }

    # -------------------------------------------------------------------------
    # The labels of the tree leaves should be unique
    if (!is.null(rTree)) {
        # The leaf nodes should have unique label.
        tipLab <- rTree$tip.label
        anyDp <- any(duplicated(tipLab))

        if (anyDp) {
            msg <- "rowTree: Duplicated labels are not allowed for leaves. \n"
            errors <- c(errors, msg)
        }
    }

    if (!is.null(cTree)) {
        # The leaf nodes should have unique label.
        tipLab <- cTree$tip.label
        anyDp <- any(duplicated(tipLab))

        if (anyDp) {
            msg <- "colTree: Duplicated labels are not allowed for leaves. \n"
            errors <- c(errors, msg)
        }
    }

    # -------------------------------------------------------------------------
    # check the dimension is correct for rowLinks and colLinks
    if (!is.null(rTree)) {
        rowEq <- nrow(object@rowLinks) == nrow(object)

        if (!rowEq) {
            msg <- sprintf("rowLinks: %d rows are expected",
                           nrow(object))
            errors <- c(errors, msg)
        }
        if (!all(rownames(object@rowLinks) == rownames(object))) {
            msg <- "rowLinks: rownames do not match rownames of experiment"
            errors <- c(errors, msg)
        }
    }

    if (!is.null(cTree)) {
        colEq <- nrow(object@colLinks) == ncol(object)

        if (!colEq) {
            msg <- sprintf("colLinks: %d cols are expected",
                           ncol(object))
            errors <- c(errors, msg)
        }
        if (!all(rownames(object@colLinks) == colnames(object))) {
            msg <- "colLinks: rownames do not match colnames of experiment"
            errors <- c(errors, msg)
        }
    }

    # -------------------------------------------------------------------------
    # if rowTree doesn't exist, rowLinks should have 0 rows
    if (is.null(rTree)) {
        if (!is.null(object@rowLinks)) {
            msg <- "rowLinks should be NULL when rowTree doesn't exist \n"
            errors <- c(errors, msg)
        }
    }

    if (is.null(cTree)) {
        if (!is.null(object@colLinks)) {
            msg <- "colLinks should be NULL when colTree doesn't exist \n"
            errors <- c(errors, msg)
        }
    }

    object_nrow <- length(object)
    if(!is.null(object@referenceSeq)){
        if(is(object@referenceSeq, "DNAStringSet")){
            referenceSeq_len <- length(object@referenceSeq)
        } else if(is(object@referenceSeq, "DNAStringSetList")){
            referenceSeq_len <- lengths(object@referenceSeq)
            referenceSeq_len <- unique(referenceSeq_len)
        }
        if (length(referenceSeq_len) != 1L) {
            msg <- "lengths of 'referenceSeq' must all be equal."
            errors <- c(errors, msg)
        }
        if (any(referenceSeq_len != object_nrow)) {
            msg <- sprintf(
                paste0("length(s) of 'referenceSeq' (%d) must equal nb of ",
                       "rows in 'x' (%d)"),
                referenceSeq_len, object_nrow)
            errors <- c(errors, msg)
        }
    }

    # -------------------------------------------------------------------------
    # Note : duplicated value in nodeLab column is allowed because we might
    # have multiple rows corresponding to a same leaf.
    if (length(errors)) {stop("\n", errors)} else {TRUE}
})



#' @import SingleCellExperiment S4Vectors
setValidity2("LinkDataFrame", function(object) {

    errors <- character()
    # -------------------------------------------------------------------------
    # it must be a subclass of DataFrame
    if (!is(object, "DataFrame")) {
        msg <- "The object is not a subclass of DataFrame \n"
        errors <- c(errors, msg)
    }

    # -------------------------------------------------------------------------
    # it should at least include nodeLab, nodeLab_alias, nodeNum, isLeaf
    colNam <- colnames(object)
    rqNam <- c("nodeLab", "nodeLab_alias", "nodeNum", "isLeaf")
    isNam <- all(rqNam %in% colNam)
    if (!isNam) {
        msg <- "The object should include at least 4 columns:
                nodeLab, nodeLab_alias, nodeNum, isLeaf \n"
        errors <- c(errors, msg)
    }

    # -------------------------------------------------------------------------
    # nodeLab: a character column (allows NA)
    nodeLab <- object$nodeLab
    isC1 <- is(nodeLab, "character") | all(is.na(nodeLab))
    if (!isC1) {
        msg <- "The nodeLab column should be character \n"
        errors <- c(errors, msg)
    }

    # nodeLab_alias: a character column
    nodeLab_alias <- object$nodeLab_alias
    isC2 <- is(nodeLab_alias, "character")
    if (!isC2) {
        msg <- "The nodeLab_alias column should be character \n"
        errors <- c(errors, msg)
    }

    # nodeNum: a numeric column
    nodeNum <- object$nodeNum
    isC3 <- is(nodeNum, "numeric")
    if (!isC3) {
        msg <- "The nodeNum column should be numeric \n"
        errors <- c(errors, msg)
    }

    # isLeaf: a logical column
    isLeaf <- object$isLeaf
    isC4 <- is(isLeaf, "logical")
    if (!isC4) {
        msg <- "The isLeaf column should be logical \n"
        errors <- c(errors, msg)
    }

    if (length(errors)) {
        stop("\n", errors)
    } else { TRUE }

})

#' Transfer between node number and node label
#'
#' \code{convertNode} does the transformation between the number and the label of
#' a node on a tree
#'
#' @param tree A phylo object
#' @param node A character or numeric vector representing tree node label(s) or
#'   tree node number(s)
#' @param use.alias A logical value, TRUE or FALSE. This is an optional argument
#'   that only requried when the input \code{node} is a numeric vector. The
#'   default is FALSE, and the node label would be returned; otherwise, the
#'   alias of node label would be output. The alias of node label is created by
#'   adding a prefix \code{"alias_"} to the node number.
#' @param message A logical value, TRUE or FALSE. The default is FALSE. If TRUE,
#'   message will show when a tree have duplicated labels for some internal
#'   nodes.
#'
#' @export
#' @return a vector
#' @author Ruizhu Huang
#'
#' @examples
#' library(ggtree)
#'
#' data(tinyTree)
#'
#' ggtree(tinyTree, branch.length = 'none') +
#' geom_text2(aes(label = label), hjust = -0.3) +
#' geom_text2(aes(label = node), vjust = -0.8,
#' hjust = -0.3, color = 'blue')
#'
#' #check whether the node number and node label are matched
#' convertNode(tinyTree, node = c(11, 2, 4, 15))
#'
#' convertNode(tree = tinyTree, node = c("Node_16", "Node_11"))
#' convertNode(tree = tinyTree, node = c("alias_16", "alias_11"))

convertNode <- function(tree, node, use.alias = FALSE,
                      message = FALSE) {

    if (!inherits(tree, "phylo")) {
        stop("tree: should be a phylo object. \n")
    }

    if (is.factor(node)) {
        node <- as.character(node)
        warning("node: factor is converted to character", call. = FALSE)
        warning("The input 'node' is considered as labels of nodes.", 
                call. = FALSE)
    }
    # node number & tip number
    mat <- tree$edge
    nodI <- sort(unique(mat[, 1]))
    tip <- sort(setdiff(mat[, 2], mat[, 1]))
    nodeA <- c(tip, nodI)

    # if node labels are given, check whether the length could match with the
    # length of internal nodes.
    if (!is.null(tree$node.label)) {
        if (length(tree$node.label) != length(nodI)) {
            stop("The length of internal node label isn't equal to
                 the length of the internal nodes. \n", call. = FALSE)
        }
        }

    # node labels
    nodeLab <- c(tree$tip.label, tree$node.label)
    nodeLab_alias <- paste("alias_", c(tip, nodI), sep = "")
    
    if (any(duplicated(nodeLab)) & message) {
        # use message instead of warning to avoid 
        # multiple warnings in TSE construction.
        message("Multiple nodes use the same label or
                have no label.\n")
        }
        

    # check whether the input node number exists in the provided tree
    if (is.numeric(node)) {
        if (!all(node %in% nodeA)) {
            stop("The node number ", node[!node %in% nodeA],
                 " can't be found in the ",
                 deparse(substitute(tree)), call. = FALSE)
        }
    }
    # check whether the input label exists in the provided tree
    # (allow nodeLab_alias)
    inLab <- all(node %in% nodeLab)
    inAlias <- all(node %in% nodeLab_alias)
    if (is.character(node)) {
        if (!any(inLab, inAlias)) {
            wrongNode <- setdiff(node, nodeLab)
            if (any(startsWith(wrongNode, "alias_"))) {
                message("Not allowed to mix using node labels and alias labels",
                        call. = FALSE)
            }
            stop(length(wrongNode), " nodes mismatch with the tree: ",
                    head(wrongNode), " ...", call. = FALSE)
            }
    }

    if (inLab) {
        nhit <- sum(nodeLab %in% node)
        if (nhit != length(node)) {
            warning("Multiple nodes are found to have the same label.")
        }
    }
    
    if (inAlias) {
        nhit <- sum(nodeLab_alias %in% node)
        if (length(nhit) != length(node)) {
            warnings("Multiple nodes are found to have the same label.")
        }
    }
    # =============== Transformation ======================
    # transfer from the label to the number
    if (is.character(node)) {
        if (inLab) {
            names(nodeA) <- nodeLab
            final <- nodeA[node]
        } else {
            names(nodeA) <- nodeLab_alias
            final <- nodeA[node]
        }
    }

    # transfer from the number to the label
    if (is.numeric(node)) {
        if (use.alias) {
            sel <- match(node, nodeA)
            final <- nodeLab_alias[sel]
        } else {
            sel <- match(node, nodeA)
            final <- nodeLab[sel]
        }}

    # output
    return(final)

    }

context("convertNode")

data("tinyTree")
newTree <- tinyTree
newTree$node.label <- c(LETTERS[1:4], LETTERS[1:5])


test_that("convertNode could return correct results", {
    expect_convertNode_equal <- function(test, truth){
        expect_equal(convertNode(tree = tinyTree, node = test), truth)
    }
    expect_convertNode_equal(17, "Node_17")
    expect_convertNode_equal("Node_16", c(Node_16 = 16))
    expect_convertNode_equal(c(2, 4, 5), c("t7", "t9", "t4"))
    expect_convertNode_equal(2, "t7")
    expect_error(convertNode(tree = 2, node = 2))
    expect_error(convertNode(tree = tinyTree, node = 20))
    
    expect_warning(convertNode(tree = newTree, node = "B"))
})

#' Find nodes on the tree
#'
#' \code{showNode} is to get nodes from the tree.
#'
#' @param tree A  phylo object.
#' @param only.leaf A logical value, TRUE or FALSE. The default is FALSE, all
#'   nodes are output; otherwise, leaves are output
#' @param use.alias A logical value, TRUE or FALSE. The default is FALSE, and
#'   the node label would be used to name the output; otherwise, the alias of
#'   node label would be used to name the output. The alias of node label is
#'   created by adding a prefix \code{"alias_"} to the node number.
#' @export
#' @importFrom methods is
#' @return A vector of nodes. The numeric value is the node number, and the
#'   vector name is the corresponding node label. If a node has no label, it
#'   would have NA as name when \code{use.alias = FALSE}, and have the alias of
#'   node label as name when \code{use.alias = TRUE}.
#' @author Ruizhu Huang
#'
#' @examples
#' library(ggtree)
#' data(tinyTree)
#'
#' # PLOT tree
#' ggtree(tinyTree, branch.length = 'none') +
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#'
#'
#' ## find the node shared by provided node labels
#' showNode(tree = tinyTree, only.leaf = TRUE,
#'           use.alias = FALSE)
#'
#' showNode(tree = tinyTree, only.leaf = FALSE,
#'           use.alias = FALSE)

showNode <- function(tree, only.leaf = FALSE,
                      use.alias = FALSE) {
    
    if (!is(tree, "phylo")) {
        stop("tree is not a phylo object.")
    }
    
    # edges
    ed <- tree$edge
    
    # leaves
    leaf <- setdiff(ed[, 2], ed[, 1])
    leaf <- unique(leaf)
    leaf <- sort(leaf)
    
    # nodes
    all <- as.vector(ed)
    all <- unique(all)
    all <- sort(all)
    
    # output
    if (only.leaf) {
        out <- leaf
    } else {
        out <- all
    }
    
    # final output
    names(out) <- convertNode(tree = tree, node = out,
                            use.alias = use.alias,
                            message = FALSE)
    return(out)
}

#' count the number of nodes
#'
#' \code{countNode} calculates the number of nodes on a \code{phylo} tree.
#'
#' @param tree A phylo object
#'
#' @export
#' @return a numeric value
#' @author Ruizhu Huang
#'
#' @examples
#' library(ggtree)
#'
#' data(tinyTree)
#'
#' ggtree(tinyTree, branch.length = 'none') +
#'        geom_text2(aes(label = label), hjust = -0.3) +
#'        geom_text2(aes(label = node), vjust = -0.8,
#'        hjust = -0.3, color = 'blue')
#'
#'
#' (n <- countNode(tinyTree))
#'


countNode <- function(tree) {

    if (!inherits(tree, "phylo")) {
        stop("tree: should be a phylo object. \n")
    }


    # all nodes
    mat <- tree$edge
    node <- as.vector(mat)
    unode <- unique(node)

    len <- length(unode)

    return(len)

}

context("asLeaf")

test_that("asLeaf", {
    data("tinyTree")
    
    expect_error(asLeaf(tinyTree),
                 'argument "node" is missing')
    expect_error(asLeaf(tree = tinyTree, node = "t2"),
                 "Leaf node\\(s\\) found")
    expect_error(asLeaf(tree = tinyTree, node = FALSE),
                 "The input node should be a character or numeric vector")
    expect_error(asLeaf(tree = tinyTree, node = "Node_11"),
                 "Selected root node of tree")
    
    expect_asLeaf_equal <- function(test, truth, truth2, truth3){
        actual <- asLeaf(tree = tinyTree, node = test)
        expect_equal(nrow(actual$edge), truth)
        expect_equal(countLeaf(actual), truth2)
        expect_equal(countNode(actual), truth3)
    }
    expect_asLeaf_equal("Node_12", 2L, 2L, 3L)
    expect_asLeaf_equal("Node_13", 14L, 8L, 15L)
    expect_asLeaf_equal("Node_14", 16L, 9L, 17L)
    expect_asLeaf_equal("Node_15", 8L, 5L, 9L)
    expect_asLeaf_equal("Node_16", 10L, 6L, 11L)
    expect_asLeaf_equal("Node_17", 14L, 8L, 15L)
    expect_asLeaf_equal("Node_18", 16L, 9L, 17L)
    expect_asLeaf_equal("Node_19", 16L, 9L, 17L)
    expect_asLeaf_equal(c("Node_12","Node_15"), 2L, 2L, 3L)
    expect_asLeaf_equal(c("Node_13","Node_15"), 4L, 3L, 5L)
    expect_asLeaf_equal(c("Node_14","Node_15"), 6L, 4L, 7L)
    expect_equal(asLeaf(tree = tinyTree, node = c("Node_12","Node_15")),
                 asLeaf(tree = tinyTree, node = c("Node_15","Node_12")))
    expect_error(asLeaf(tree = tinyTree, node = "Node_20"),
                 "1 nodes mismatch with the tree")
})

#' Find the share node
#'
#' \code{shareNode} is to find the node where the specified nodes first meet.
#'
#' @param tree A  phylo object.
#' @param node A vector of node numbers or node labels.
#' @param use.alias A logical value, TRUE or FALSE. The default is FALSE, and
#'   the node label would be used to name the output; otherwise, the alias of
#'   node label would be used to name the output. The alias of node label is
#'   created by adding a prefix \code{"alias_"} to the node number.
#'
#' @export
#' @return A vector of nodes. The numeric value is the node number, and the
#'   vector name is the corresponding node label. If a node has no label, it
#'   would have NA as name when \code{use.alias = FALSE}, and have the alias of
#'   node label as name when \code{use.alias = TRUE}.
#' @author Ruizhu Huang
#'
#' @examples
#' library(ggtree)
#' data(tinyTree)
#'
#' # PLOT tree
#' ggtree(tinyTree, branch.length = 'none') +
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#'
#'
#' ## find the node shared by provided node labels
#' shareNode(node = c('t4','t9'), tree = tinyTree,
#'           use.alias = FALSE)
#'
#' shareNode(node = c('t10','Node_17'), tree = tinyTree,
#'           use.alias = FALSE)
#'
#' ## find the node shared by provided node numbers
#' shareNode(node = c(2, 3), tree = tinyTree)

shareNode <- function(tree, node,
                      use.alias = FALSE) {

    if (!inherits(tree, "phylo")) {
        stop("tree is not a phylo object.")
    }

    if (!is.atomic(node)) {
        stop("node should be a vector")
    }

    if (!length(node)) {
        stop("node: at least one node should be given.")
    }
    # transfer node label to node number
    if (is.character(node)) {
        node <- convertNode(tree, node = node,
                          message = FALSE)
    } else {
        node <- node
    }

    # path matrix
    mat <- matTree(tree)
    ind <- apply(mat, 1, FUN = function(x) {
        any(x %in% node)
    })
    matN <- mat[ind, ,drop = FALSE]
    path <- lapply(seq_len(nrow(matN)), FUN = function(x) {
        xx <- matN[x, ]
        xx[!is.na(xx)]
    })
    # ancestors
    loc <- Reduce(intersect, path)

    # the ancestor on the lowest level (the root has the highest level)
    vec <- as.vector(mat)
    count <- table(vec, useNA = "no")[loc]
    if (length(count) == 1) {
        af <- as.data.frame(count, stringsAsFactors = FALSE)
        df <- data.frame(vec = as.numeric(rownames(af)),
                         Freq = af$count)
    } else {
        df <- as.data.frame(count, stringsAsFactors = FALSE)
    }


    # select the node with the lowest frequency.  closest to the leaf level.
    out <- as.numeric(df[df$Freq == min(df$Freq), "vec"])

    # final output
    names(out) <- convertNode(tree = tree, node = out,
                            use.alias = use.alias,
                            message = FALSE)
    return(out)
   }

#' Update a \code{TreeSummarizedExperiment} object
#' 
#' Update \code{TreeSummarizedExperiment} objects to the latest version of the 
#' class structure. This is usually called by methods in the 
#' \code{TreeSummarizedExperiment} package rather than by users or downstream 
#' packages.
#' 
#' @param object A \code{TreeSummarizedExperiment} object
#' 
#' @param ... additional arguments, for use in specific \code{updateObject}
#'   methods.
#'   
#' @param verbose \code{TRUE} or \code{FALSE}, indicating whether information 
#'   about the update should be reported.
#'   
#' @export
#'   
#' @return An updated \code{TreeSummarizedExperiment} object
setMethod("updateObject", "TreeSummarizedExperiment",
    function(object, ..., verbose = FALSE){
        old <- S4Vectors:::disableValidity()
        if (!isTRUE(old)) {
            S4Vectors:::disableValidity(TRUE)
            on.exit(S4Vectors:::disableValidity(old))
        }
        object <- callNextMethod()
        if(!.hasSlot(object,"referenceSeq")){
            if(verbose){
                message("Updating ", class(object)[1], " object ...\n",
                        appendLF = FALSE)
            }
            object@referenceSeq <- NULL
        }
        
        # the row links
        if (.lack_whichTree(object, "rowLinks")) {
            lk <- DataFrame(rowLinks(object))
            nam <- rowTreeNames(object)
            if (length(nam) > 1) {
                stop("Multiple trees are detected.",
                     " Don't know how to update the TSE object",
                     call. = FALSE)
            }
            lk$whichTree <- nam
            nlk <- as(lk, "LinkDataFrame")
           object <- BiocGenerics:::replaceSlots(object,
                                                 rowLinks = nlk) 
        }
        
        # the col links
        if (.lack_whichTree(object, "colLinks")) {
            lk <- DataFrame(colLinks(object))
            nam <- colTreeNames(object)
            if (length(nam) > 1) {
                stop("Multiple trees are detected.",
                     " Don't know how to update the TSE object",
                     call. = FALSE)
            }
            lk$whichTree <- nam
            nlk <- as(lk, "LinkDataFrame")
            object <- BiocGenerics:::replaceSlots(object,
                                                  colLinks = nlk) 
        }
        
        object
    }
)

#' @rdname findDescendant
#' @export
findOS <- function(tree,
                   node,
                   only.leaf = TRUE,
                   self.include = FALSE,
                   use.alias = FALSE){
    .Deprecated("findDescendant")
    findDescendant(tree = tree,
                   node = node,
                   only.leaf = only.leaf,
                   self.include = self.include,
                   use.alias = use.alias)
}

#' @rdname convertNode
#' @export
transNode <- function(tree, node, use.alias = FALSE,
                      message = FALSE){
    .Deprecated("convertNode")
    convertNode(tree = tree, node = node, use.alias = use.alias,
                message = message)
}

#' @rdname joinNode
#' @export
signalNode <- function(tree, node, use.alias = FALSE){
    .Deprecated("joinNode")
    joinNode(tree = tree, node = node, use.alias = use.alias)
}

#' Perform data aggregations based on the available tree structures
#'
#' \code{aggValue} aggregates values on the leaf nodes of a tree to a specific
#' arbitrary level of the tree. The level is specified via the nodes of the
#' tree. Users could decide on which dimension (row or column) and how should
#' the aggregation be performed.
#'
#' @param x A \code{TreeSummarizedExperiment} object.
#' @param rowLevel A numeric (node numbers) or character (node labels) vector.
#'   It provides the level on the tree that data is aggregated to. The
#'   aggregation is on the row dimension. The default is \code{rowLevel = NULL},
#'   and no aggregation is performed.
#' @param rowBlock A column name in the \code{rowData} to separate the
#'   aggregation.
#' @param colLevel A numeric (node numbers) or character (node labels) vector.
#'   It provides the level on the tree that data is aggregated to. The
#'   aggregation is on the column dimension. The default is \code{colLevel =
#'   NULL}, and no aggregation is performed.
#' @param colBlock A column name in the \code{colData} to separate the
#'   aggregation.
#' @param FUN A function to be applied on the aggregation. It's similar to the
#'   \code{FUN} in \code{\link[base]{apply}}.
#' @param assay A integer scalar or string indicating which assay of \code{x} to
#'   use in the aggregation. If NULL, all assay tables are used in aggregation.
#' @param message A logical value. The default is TRUE. If TRUE, it will print
#'   out the running process.
#' @return A \code{TreeSummarizedExperiment} object or a
#'   \code{matrix}. The output has the same class of the input \code{x}.
#' @export
#'
#' @author Ruizhu HUANG
#' @seealso \code{\link{aggTSE}}
aggValue <- function(x, rowLevel = NULL, rowBlock = NULL, 
                     colLevel = NULL, colBlock = NULL, 
                     FUN = sum, assay = NULL,
                     message = FALSE){
    .Deprecated("aggTSE")
    aggTSE(x = x, 
           rowLevel = rowLevel, rowBlock = rowBlock, 
           colLevel = colLevel, colBlock = colBlock, 
           rowFun = FUN, colFun = FUN, 
           rowDataCols = colnames(rowData(x)),
           colDataCols = colnames(colData(x)),
           whichAssay = assay,
           message = message,
           whichRowTree = 1, whichColTree = 1,
           rowFirst = TRUE)
}

#' Detect loops 
#' \code{detectLoop} detects loops
#' 
#' @param tax_tab a data frame where columns store hierarchical levels. The
#'   columns from the left to the right correspond nodes from the root to the
#'   leaf.
#' @importFrom dplyr '%>%' mutate_if
#' @export
#' @author Ruizhu Huang
#' @return a data frame
#' @examples 
#' 
#' df <- data.frame(A = rep("a", 8),
#'                  B = rep (c("b1", "b2", "b3", "b4"), each = 2),
#'                  C = paste0("c", c(1, 2, 2, 3:7)),
#'                  D = paste0("d", 1:8))
#'  
#' # The result means that a loop is caused by 'b1' and 'b2' in column 'B' and
#' # 'c2' in column 'C' (a-b1-c2; a-b2-c2)
#' detectLoop(tax_tab = df)
#' 
#' df <- data.frame(R1 = rep("A", 6),
#'                      R2 = c("B1", rep("B2", 4), "B3"),
#'                      R3 = c("C1", "C2", "C3", NA, NA, NA),
#'                      R4 = c("D1", "D2", "D3", NA, NA, NA),
#'                      R5 = paste0("E", 1:6))
#' detectLoop(tax_tab = df)
#' 
#' df <- data.frame(R1 = rep("A", 7),
#'                      R2 = c("B1", rep("B2", 4), "B3", "B3"),
#'                      R3 = c("C1", "C2", "C3", "", "", "", ""),
#'                      R4 = c("D1", "D2", "D3", "", "", "", ""),
#'                      R5 = paste0("E", 1:7))
#' detectLoop(tax_tab = df)
#' 
#' df <- data.frame(R1 = rep("A", 7),
#'                      R2 = c("B1", rep("B2", 4), "B3", "B3"),
#'                      R3 = c("C1", "C2", "C3", NA, NA, NA, NA),
#'                      R4 = c("D1", "D2", "D3", NA, NA, NA, NA),
#'                      R5 = paste0("E", 1:7))
#' detectLoop(tax_tab = df) 

detectLoop <- function(tax_tab){
    
    tax_tab <- tax_tab %>%
        mutate_if(is.factor, as.character) 

    nc <- ncol(tax_tab)
    cnam <- colnames(tax_tab)
    
    tab_list <- lapply(seq_len(nc-1), function(x){
        xx <- table(tax_tab[, x], tax_tab[, x+1], useNA = "always")
        sx <- colSums(xx > 0)
        nx <- names(sx)[sx > 1]
        if (length(nx)) {
            warning("Detected ", cnam[x+1], " from different ",
                    cnam[x], " : ", paste(nx, collapse = " "))
            
            ssx <- xx[, sx>1, drop = FALSE]
            ssx <- ssx[rowSums(ssx) > 0, , drop = FALSE]
            ind <- which(ssx > 0, arr.ind = TRUE)
            
            data.frame(parent = rownames(ssx)[ind[, "row"]],
                       child = colnames(ssx)[ind[, "col"]],
                       parent_column = cnam[x],
                       child_column = cnam[x+1])
        } else {
            NULL
        }
        
    })
    
    out <- do.call(rbind, tab_list)
    data.frame(lapply(out, as.character), stringsAsFactors = FALSE)
}




#' Resolve loops 
#' \code{resolveLoop} resolve loops by adding suffix to the child node. The
#' suffix is "_i" where 'i' is a number. Please see examples.
#' 
#' @param tax_tab a data frame where columns store hierarchical levels. The
#'   columns from the left to the right correspond nodes from the root to the
#'   leaf.
#' @importFrom dplyr '%>%' mutate_if group_by mutate row_number
#' @importFrom rlang .data
#' @export
#' @author Ruizhu Huang
#' @return a data frame
#' @examples 
#' # example 1
#' df <- data.frame(A = rep("a", 8),
#'                  B = rep (c("b1", "b2", "b3", "b4"), each = 2),
#'                  C = paste0("c", c(1, 2, 2, 3:7)),
#'                  D = paste0("d", 1:8))
#'  
#' # The result means that a loop is caused by 'b1' and 'b2' in column 'B' and
#' # 'c2' in column 'C' (a-b1-c2; a-b2-c2)
#' resolveLoop(tax_tab = df)
#' 
#' # example 2
#' taxTab <- data.frame(R1 = rep("A", 5),
#'                      R2 = c("B1", rep("B2", 3), ""),
#'                      R3 = c("C1", "C2", "C3", "", ""),
#'                      R4 = c("D1", "D2", "D3", "", ""),
#'                      R5 = paste0("E", 1:5))
#' 
#' resolveLoop(tax_tab = taxTab)
#' # example 3
#' taxTab <- data.frame(R1 = rep("A", 6),
#'                      R2 = c("B1", rep("B2", 4), ""),
#'                      R3 = c("C1", "C2", "C3", "", "", ""),
#'                      R4 = c("D1", "D2", "D3", "", "", ""),
#'                      R5 = paste0("E", 1:6))
#' 
#' resolveLoop(tax_tab = taxTab)
#' 
#'  # example 3
#' taxTab <- data.frame(
#'             R1 = rep("A", 5),
#'             R2 = c("B1", rep("B2", 3), "B3"),
#'             R3 = c("C1", "C2", "C3", NA, NA),
#'             R4 = c("D1", "D2", "D3", NA, NA),
#'             R5 = paste0("E", 1:5))
#' resolveLoop(tax_tab = taxTab)
#' 
#' 
resolveLoop <- function(tax_tab) {
    # solve the loop by adding suffix
    tax_s <- .solveLoop(tax_tab)
    
    # test whether all loops are solved
    loop_s <- detectLoop(tax_tab = tax_s)
    while (nrow(loop_s)) {
        tax_s <- .solveLoop(tax_s)
        loop_s <- detectLoop(tax_tab = tax_s)
    }
    return(tax_s)
}

.solveLoop <- function(tax_tab){
    # change factor to character
    tax_tab <- tax_tab %>%
        mutate_if(is.factor, as.character) 
    
    df <- detectLoop(tax_tab = tax_tab) 
    if (nrow(df)) {
        df <- df %>% group_by(.data$child) %>% mutate(count = row_number())
        df_list <- split(df, seq(nrow(df)))
        
        tax_x <- tax_tab
        for (i in seq_along(df_list)){
            df_i <- df_list[[i]]
            ind_c <- tax_x[[df_i$child_column]] %in% df_i$child
            ind_p <- tax_x[[df_i$parent_column]] == df_i$parent
            ind <- which(ind_p & ind_c)
            tax_x[ind, df_i$child_column] <- paste(tax_x[ind, df_i$child_column], 
                                                   df_i$count, sep = "_")
        }
        tax_x
    } else {
        tax_tab
    }
    

}

context("toTree")

df <- data.frame(R1 = rep("A", 9),
                 R2 = c("B1", rep(c("B2", ""), each =4)),
                 R3 = c("C1", "C2", "C3", "C4", "C5", rep("", 4)),
                 R4 = c(rep(NA, 5), paste0("D", 1:4)))

test_that("toTree could convert a data frame to a phylo", {
    df_complete <- df[1:5, 1:3]
    expect_phylo_output <- function(df, truth) {
        out <- toTree(data = df)
        expect_setequal(class(out), truth)
        lab <- showNode(tree = out, only.leaf = FALSE)
        out <- addLabel(tree = out, label = as.character(lab), on = "all")
        expect_equal(out$tip.label,as.character(seq_len(length(out))))
        expect_equal(out,addLabel(out,as.character(seq_len(length(out) + length(out$node.label)))))
    }
    expect_phylo_nodes <- function(df, truth, use_leaf) {
        out <- toTree(data = df)
        if (use_leaf) {
            nod <- out$tip.label
        } else {
            nod <- out$node.label
        }
        
        expect_setequal(nod, truth)
    }
    
    expect_phylo_output(df_complete, "phylo")
    expect_phylo_nodes(df_complete, 
                       c("C1", "C2", "C3", "C4", "C5"), 
                       use_leaf = TRUE)
    expect_phylo_nodes(df_complete, 
                       c("R1:A",  "R2:B1", "R2:B2"), 
                       use_leaf = FALSE)
    
    expect_phylo_nodes(df[5:9, ], 
                       c("R1:A", "R2:", "R3:", "R2:B2", "R3:C5"), 
                       use_leaf = FALSE)
    expect_phylo_nodes(df[5:9, ], 
                       c("NA", "D1", "D2", "D3", "D4"), 
                       use_leaf = TRUE)
})

test_that("toTree give warnings", {
    
    expect_error(toTree(data = df))
    expect_warning(toTree(data = df[, 1:2]))
    
})


test_that("toTree loop resolving", {
    actual <- expect_warning(detectLoop(tax_tab = df),
                             "Detected R4 from different R3")
    expect_s3_class(actual,"data.frame")
    expect_equal(nrow(actual),5L)
    expect_true(all(is.na(actual$child)))
    
    df <- data.frame(A = rep("a", 8),
                     B = rep (c("b1", "b2", "b3", "b4"), each = 2),
                     C = paste0("c", c(1, 2, 2, 3:7)),
                     D = paste0("d", 1:8))
    actual <- expect_warning(detectLoop(tax_tab = df),
                             "Detected C from different B")
    expect_s3_class(actual,"data.frame")
    expect_equal(nrow(actual),2L)
    expect_true(all(actual$child == "c2"))
    
    actual <- expect_warning(resolveLoop(tax_tab = df),
                             "Detected C from different B")
    expect_equal(nrow(df),nrow(actual))
    expect_equal(actual$C[2L],"c2_1")
    expect_equal(actual$C[3L],"c2_2")
})

#' track the nodes of a phylo tree
#'
#' \code{trackNode} track nodes of a phylo tree by adding the alias labels to
#' them
#'
#' @param tree A phylo object
#'
#' @export
#' @return a phylo object
#' @author Ruizhu Huang
#'
#' @examples
#' library(ggtree)
#'
#' data(tinyTree)
#'
#' ggtree(tinyTree, branch.length = 'none') +
#'     geom_text2(aes(label = label), hjust = -0.3) +
#'     geom_text2(aes(label = node), vjust = -0.8,
#'                hjust = -0.3, color = 'blue')
#'
#' #check whether the node number and node label are matched
#' trackTree <- trackNode(tinyTree)
#' ggtree(trackTree, branch.length = 'none') +
#'     geom_text2(aes(label = label), hjust = -0.3) +
#'     geom_text2(aes(label = node), vjust = -0.8,
#'                hjust = -0.3, color = 'blue')

trackNode <- function(tree) {
    
    # ===========check inputs =================
    if (!is(tree, "phylo")) {
        stop("tree should be a phylo object")
    }
    
    # The node number of all nodes
    ed <- tree$edge
    leaf <- setdiff(ed[, 2], ed[, 1])
    leaf <- sort(leaf)
    inNode <- unique(sort(ed[, 1]))


    # prefix node number with 'alias_' to create the alias label
    tree$tip.label <- paste0("alias_", leaf)
    tree$node.label <- paste0("alias_", inNode)
    return(tree)
}

#' A toy TreeSummarizedExperiment object
#' 
#' \code{makeTSE} creates a toy TreeSummarizedExperiment object. 
#' 
#' @param include.rowTree TRUE or FALSE. Default is TRUE, so the output
#'   \code{TreeSummarizedExperiment} has a \code{phylo} object in
#'   \code{rowTree}.
#' @param include.colTree TRUE or FALSE. Default is TRUE, so the output
#'   \code{TreeSummarizedExperiment} has a \code{phylo} object in
#'   \code{colTree}.
#' @param nrow a numeric value to specify the number of rows of
#'   \code{TreeSummarizedExperiment}
#' @param ncol a numeric value to specify the number of columns of
#'   \code{TreeSummarizedExperiment}
#' @importFrom ape rtree
#' @export
#' @return A TreeSummarizedExperiment object
#' @details The \code{assays} contains a matrix with values from
#'   \code{1:(nrow*ncol)}. The \code{rowData} has two columns, \code{var1} and
#'   \code{var2}. \code{var1} is created with \code{rep_len(letters, nrow)}.
#'   \code{var2} is created with \code{rep_len(c(TRUE, FALSE), nrow)}. The
#'   \code{colData} has two columns, \code{ID} and \code{group}. \code{ID} is
#'   created with \code{seq_len(ncol)}. \code{group} is created with
#'   \code{rep_len(LETTERS[1:2], ncol)}. The row/col tree is generated with
#'   \code{ape::rtree()}. So, to generate reproducible trees, \code{set.seed()}
#'   is required.
#' @author Ruizhu Huang
#' @examples 
#' 
#' set.seed(1)
#' makeTSE()

makeTSE <- function(nrow = 10, ncol = 4, 
                    include.rowTree = TRUE,
                    include.colTree = TRUE) {
    
    # the assays table
    tab <- matrix(seq_len(nrow*ncol), nrow = nrow)
    colnames(tab) <- paste0("sample", seq_len(ncol))
    rownames(tab) <- paste0("entity", seq_len(nrow))

    # the row data
    rD <- data.frame(var1 = rep_len(letters, nrow),
                     var2 = rep_len(c(TRUE, FALSE), nrow),
                     row.names = rownames(tab))
    # the column data
    cD <- data.frame(ID = seq_len(ncol),
                     group = rep_len(LETTERS[1:2], ncol),
                     row.names = colnames(tab))
    
    # the row & column tree
    rT <- rtree(nrow)
    rT$tip.label <- rownames(tab)
    cT <- rtree(ncol)
    cT$tip.label <- colnames(tab)
    
    if (!include.rowTree) {rT <- NULL}
    if (!include.colTree) {cT <- NULL}
    
    # conctruct TSE
    out <- TreeSummarizedExperiment(assays = list(tab),
                                    rowData = rD,
                                    colData = cD,
                                    rowTree = rT,
                                    colTree = cT)
    return(out)
}

context("setter: rowTree & colTree")

set.seed(1)
n <- 10
tse_a <- makeTSE(nrow = n, include.colTree = FALSE)
tse_b <- makeTSE(nrow = n, include.colTree = FALSE)
tse_ab <- rbind(tse_a, tse_b)


new_tree1 <- ape::rtree(n)
new_tree1$tip.label <- rownames(tse_a)

new_tree2 <- ape::rtree(n/2)
new_tree2$tip.label <- rownames(tse_a)[seq_len(n/2)]


tse_o <- makeTSE(nrow = n, include.colTree = FALSE, include.rowTree = FALSE)
tree_o <- ape::rtree(n+2)
tree_o$tip.label[seq_len(n/2)] <- rownames(tse_o)[seq_len(n/2)]


test_that("Repace the row tree successfully", {
    # no tree in the slot rowTree
    # rownames & tip.label partially matched
    expect_warning(rowTree(tse_o) <- tree_o)
    
    # Only one tree in the slot rowTree
    tse_x <- tse_a
    rowTree(x = tse_x, whichTree = 1) <- new_tree1
    expect_equal(rowTree(tse_x, whichTree = 1), new_tree1)
    expect_false(identical(rowTree(tse_x, whichTree = 1),
                           rowTree(tse_a, whichTree = 1)))
    expect_warning(rowTree(x = tse_x, whichTree = 1) <- new_tree2)
    
    
    # Two trees in the slot rowTree: replace the first tree.
    # Entity10 - 1(node), Entity9 - 2 (node), ... , Entity1 - 10(node)
    new_tree1$tip.label <- paste0("entity", 10:1)
    rtn <- rowTreeNames(tse_ab)
    rowTree(x = tse_ab, whichTree = rtn[1]) <- new_tree1
    rt <- rowTree(tse_ab, whichTree = NULL)
    rl <- rowLinks(tse_ab)
    
    
    expect_equal(length(rt), 2)
    expect_equal(rt[[1]], new_tree1)
    expect_equal(rl$nodeLab[rl$whichTree == rtn[1] & rl$nodeNum == 10],
                 "entity1")
    
    # Two trees in the slot rowTree: replace all tree with 'value'.
    rowTree(x = tse_ab, whichTree = NULL) <- new_tree1
    rt <- rowTree(tse_ab, whichTree = NULL)
    rl <- rowLinks(tse_ab)
    sub_rl <- rl[rl$nodeNum == 10, ]
    
    expect_equal(length(rt), 1)
    expect_equal(rt[[1]], new_tree1)
    expect_equal(nrow(sub_rl), 2)
    
    })


set.seed(1)
n <- 10
tse_a <- makeTSE(ncol = n, include.rowTree = FALSE)
tse_b <- makeTSE(ncol = n, include.rowTree = FALSE)
tse_ab <- cbind(tse_a, tse_b)


new_tree1 <- ape::rtree(n)
new_tree1$tip.label <- colnames(tse_a)

new_tree2 <- ape::rtree(n/2)
new_tree2$tip.label <- colnames(tse_a)[seq_len(n/2)]


tse_o <- makeTSE(ncol = n, include.colTree = FALSE, include.rowTree = FALSE)
tree_o <- ape::rtree(n+2)
tree_o$tip.label[seq_len(n/2)] <- colnames(tse_o)[seq_len(n/2)]

test_that("Repace the column tree successfully", {
    # no tree in the slot colTree
    # colnames & tip.label partially matched
    expect_warning(colTree(tse_o) <- tree_o)
    
    # Only one tree in the slot colTree
    tse_x <- tse_a
    colTree(x = tse_x, whichTree = 1) <- new_tree1
    expect_equal(colTree(tse_x, whichTree = 1), new_tree1)
    expect_false(identical(colTree(tse_x, whichTree = 1),
                           colTree(tse_a, whichTree = 1)))
    
    expect_warning(colTree(x = tse_x, whichTree = 1) <- new_tree2)
    
    
    # Two trees in the slot colTree: replace the first tree.
    # Sample10 - 1(node), Sample9 - 2 (node), ... , Sample1 - 10(node)
    new_tree1$tip.label <- paste0("sample", 10:1)
    ctn <- colTreeNames(tse_ab)
    colTree(x = tse_ab, whichTree = ctn[1]) <- new_tree1
    ct <- colTree(tse_ab, whichTree = NULL)
    cl <- colLinks(tse_ab)
    
    
    expect_equal(length(ct), 2)
    expect_equal(ct[[1]], new_tree1)
    expect_equal(cl$nodeLab[cl$whichTree == ctn[1] & cl$nodeNum == 10],
                 "sample1")
    
    # Two trees in the slot rowTree: replace all tree with 'value'.
    colTree(x = tse_ab, whichTree = NULL) <- new_tree1
    ct <- colTree(tse_ab, whichTree = NULL)
    cl <- colLinks(tse_ab)
    sub_cl <- cl[cl$nodeNum == 10, ]
    
    expect_equal(length(ct), 1)
    expect_equal(ct[[1]], new_tree1)
    expect_equal(nrow(sub_cl), 2)
    
})

context("subsetByNode")

set.seed(1)
tse_a <- makeTSE(include.rowTree = FALSE)
tse_b <- makeTSE(include.rowTree = FALSE)
tse_ab <- cbind(tse_a, tse_b)

   
test_that("subsetByNode works properly", {
    
    # the row dim.
    expect_warning(subsetByNode(x = tse_ab, colNode = 2:3,
                                whichRowTree = "phylo"),
                   "The row tree is not available")
    
    # get data linked to the tree 'phylo'
    sse_ab <- subsetByNode(x = tse_ab, colNode = 2:3,
                           whichColTree = "phylo")
    expect_equal(unique(colLinks(sse_ab)$whichTree), "phylo")
    
    # get the data linked nodes (2:3) of all trees
    sse_ab <- subsetByNode(x = tse_ab, colNode = 2:3)
    expect_equal(unique(colLinks(sse_ab)$whichTree), c("phylo", "phylo.1"))
    
    # by row & col trees
    tree2 <- ape::rtree(10)
    tree2$tip.label <- rownames(tse_ab)
    rowTree(tse_ab, whichTree = NULL) <- tree2
    
    sse <- subsetByNode(x = tse_ab, whichRowTree = 1, whichColTree = 1)
    expect_equal(dim(sse), c(10, 4))
    
    sse <- subsetByNode(x = tse_ab, rowNode = 1:5, colNode = 1:2,
                        whichRowTree = 1, whichColTree = 1)
    expect_equal(dim(sse), c(5, 2))
    
})

context("rowTree & colTree")

set.seed(2)
tse_a <- makeTSE(include.colTree = FALSE)
tse_b <- makeTSE(include.colTree = FALSE)
tse_ab <- rbind(tse_a, tse_b)

tree2 <- ape::rtree(ncol(tse_a))
tree2$tip.label <- colnames(tse_a)

tree3 <- ape::rtree(nrow(tse_a))
tree3$tip.label <- rownames(tse_a)

tse_c <- makeTSE()
tse_d <- makeTSE()
tse_cd <- cbind(tse_c, tse_d)

test_that("rowTree/colTree works properly as a getter", {
    ## export one of trees
    # by the numeric index
    rt_a <- rowTree(tse_a)
    rt_b <- rowTree(tse_b)
    expect_equal(rowTree(tse_ab), rt_a) 
    expect_equal(rowTree(tse_ab, whichTree = 2), rt_b)
    
    expect_equal(colTree(tse_cd, whichTree = 1), colTree(tse_c))
    expect_equal(colTree(tse_cd, whichTree = 2), colTree(tse_d))
    ct <- colTree(tse_cd, whichTree = NULL)
    expect_equal(length(ct), 2)
    
    
    # by the name
    rnam <- rowTreeNames(tse_ab)
    expect_equal(rowTree(tse_ab, whichTree = rnam[1]), rt_a) 
    expect_equal(rowTree(tse_ab, whichTree = rnam[2]), rt_b) 
    
    
    cnam <- colTreeNames(tse_cd)
    expect_equal(colTree(tse_cd, whichTree = cnam[1]), colTree(tse_c)) 
    expect_equal(colTree(tse_cd, whichTree = cnam[2]), colTree(tse_d)) 
    
    
    ## export all trees
    rt <- rowTree(tse_ab, whichTree = NULL)
    expect_equal(length(rt), 2L)
    expect_equal(rowTree(tse_ab, whichTree = 1:2), rt)
    expect_equal(rowTree(tse_ab, whichTree = rnam), rt)
    
    ct <- colTree(tse_cd, whichTree = NULL)
    expect_equal(length(ct), 2L)
    expect_equal(colTree(tse_cd, whichTree = 1:2), ct)
    expect_equal(colTree(tse_cd, whichTree = cnam), ct)
    
 })


test_that("rowTree/colTree works properly as a setter", {
    colTree(tse_a) <- tree2
    expect_equal(colTree(tse_a), tree2)
    
    rowTree(tse_ab, whichTree = 2) <- tree3
    expect_equal(rowTree(tse_ab, whichTree = 2), tree3)
    
    
    rowTree(tse_ab, whichTree = 1) <- tree3
    expect_equal(rowTree(tse_ab, whichTree = 1), tree3)
    
    rowTree(tse_ab, whichTree = NULL) <- tree3
    expect_equal(rowTree(tse_ab, whichTree = 1), tree3)
    expect_equal(length(rowTree(tse_ab, whichTree = NULL)), 1)
})

context("TreeSummarizedExperiment subset methods")

test_that("Subsetting", {
    counts <- matrix(rbinom(20, 5, .5), ncol = 4)
    rowData <- DataFrame()
    expect_error(TreeSummarizedExperiment(SimpleList(counts = counts), rowData = rowData))
    rowData <- DataFrame(test = seq.int(1,5))
    refSeq <- DNAStringSetList(one = DNAStringSet(c("A","G","A","A","A")),
                               two = DNAStringSet(c("A","G","A","A","A")))
    tse <- TreeSummarizedExperiment(SimpleList(counts = counts), 
                                    rowData = rowData,
                                    referenceSeq = refSeq)
    
    expect_identical(tse[], tse)
    expect_identical(tse[,], tse)
    expect_identical(tse[TRUE, ], tse)
    expect_identical(tse[, TRUE], tse)
    expect_identical(tse[TRUE, TRUE], tse)
    expect_identical(nrow(tse[-1, ]), 4L)
    actual <- tse[1,]
    expect_equal(nrow(actual), 1L)
    tse[1,] <- tse[2,]
    expect_equal(as.character(referenceSeq(tse)[[1L]][[2L]]), "G")
    tse[c(1,2),] <- tse[c(3,4),]
    expect_equal(as.character(referenceSeq(tse)[[1L]][[1L]]), "A")
    tse2 <- tse
    referenceSeq(tse2) <- referenceSeq(tse2)[1L]
    expect_error(tse2[c(1,2),] <- tse[c(3,4),],
                 paste0("DNAStringSetList as 'referenceSeq' must have the ",
                        "same length to be merged"))
    referenceSeq(tse2) <- NULL
    expect_error(tse2[c(1,2),] <- tse[c(3,4),],
                 "'x' and 'value' must have the same type of referenceSeq")
})


set.seed(1)
tse_a <- makeTSE(include.colTree = FALSE)
tse_b <- makeTSE(include.colTree = FALSE)
tse_c <- makeTSE(include.colTree = FALSE)
test_that("Subset & replace works successfully in the row dim.", {
   # 'value' and 'x' has the same row tree
    tse1 <- tse_a
    tse1[1, ] <- tse1[2, ]
    expect_equal(nrow(tse1), nrow(tse_a))
    expect_equal(length(rowTree(tse1, whichTree = NULL)), 1)
    
    # 'value' and 'x' has different row trees
    nr <- nrow(tse_a)
    tse_a[1:2, ] <- tse_b[1:2, ]
    rt <- rowTree(tse_a, whichTree = NULL)
    rl <- rowLinks(tse_a)
    expect_equal(nrow(tse_a), nr)
    expect_equal(length(rt), 2)
    expect_equal(length(unique(rl$whichTree)), 2)
    
    # 'x' has multiple row trees
    tse_ab <- rbind(tse_a, tse_b)
    nr <- nrow(tse_ab)
    tse_ab[1:3, ] <- tse_c[1:3, ] 
    rt <- rowTree(tse_ab, whichTree = NULL)
    rl <- rowLinks(tse_ab)
    expect_equal(nrow(tse_ab), nr)
    expect_equal(length(rt), 3)
    expect_equal(length(unique(rl$whichTree)), 3)
    
})


set.seed(1)
tse_a <- makeTSE(include.colTree = FALSE)
tse_b <- makeTSE(include.colTree = FALSE)
tse_c <- makeTSE(include.colTree = FALSE)
test_that("Subset & replace works successfully in the row dim.", {
    # 'value' and 'x' has the same row tree
    tse1 <- tse_a
    tse1[1, ] <- tse1[2, ]
    expect_equal(nrow(tse1), nrow(tse_a))
    expect_equal(length(rowTree(tse1, whichTree = NULL)), 1)
    
    # 'value' and 'x' has different row trees
    nr <- nrow(tse_a)
    tse_a[1:2, ] <- tse_b[1:2, ]
    rt <- rowTree(tse_a, whichTree = NULL)
    rl <- rowLinks(tse_a)
    expect_equal(nrow(tse_a), nr)
    expect_equal(length(rt), 2)
    expect_equal(length(unique(rl$whichTree)), 2)
    
    # 'x' has multiple row trees
    tse_ab <- rbind(tse_a, tse_b)
    nr <- nrow(tse_ab)
    tse_ab[1:3, ] <- tse_c[1:3, ] 
    rt <- rowTree(tse_ab, whichTree = NULL)
    rl <- rowLinks(tse_ab)
    expect_equal(nrow(tse_ab), nr)
    expect_equal(length(rt), 3)
    expect_equal(length(unique(rl$whichTree)), 3)
    expect_equal(unique(rl$whichTree), rowTreeNames(tse_ab))
})



set.seed(1)
tse_a <- makeTSE(include.rowTree = FALSE)
tse_b <- makeTSE(include.rowTree = FALSE)
tse_c <- makeTSE(include.rowTree = FALSE)
tse_F <- makeTSE(nrow = 20, include.rowTree = FALSE)
test_that("Subset & replace works successfully in the col dim.", {
    # 'value' and 'x' has the same row tree
    tse1 <- tse_a
    tse1[, 1] <- tse1[, 2]
    expect_equal(ncol(tse1), ncol(tse_a))
    expect_equal(length(colTree(tse1, whichTree = NULL)), 1)
    
    # 'value' and 'x' has different col trees
    nr <- ncol(tse_a)
    tse_a[, 1:2] <- tse_b[, 1:2]
    rt <- colTree(tse_a, whichTree = NULL)
    rl <- colLinks(tse_a)
    expect_equal(ncol(tse_a), nr)
    expect_equal(length(rt), 2)
    expect_equal(length(unique(rl$whichTree)), 2)
    
    # 'x' has multiple col trees
    tse_ab <- cbind(tse_a, tse_b)
    nr <- ncol(tse_ab)
    tse_ab[, 1:3] <- tse_c[, 1:3] 
    rt <- colTree(tse_ab, whichTree = NULL)
    rl <- colLinks(tse_ab)
    expect_equal(ncol(tse_ab), nr)
    expect_equal(length(rt), 3)
    expect_equal(length(unique(rl$whichTree)), 3)
    expect_equal(unique(rl$whichTree), colTreeNames(tse_ab))
    
    
    expect_error(tse_a[, 2] <- tse_F[, 3], "number of items to replace")
})


set.seed(1)
tse_a <- makeTSE()
tse_b <- makeTSE()

test_that("Subset & replace works successfully in both row & col dim.", {
    # 'value' and 'x' has the same row & col trees 
    tse1 <- tse_a
    tse1[1, 2] <- tse_a[3, 2]
    expect_equal(dim(tse1), dim(tse_a))
    expect_equal(length(colTree(tse1, whichTree = NULL)), 1)
    expect_equal(length(rowTree(tse1, whichTree = NULL)), 1)
    expect_equal(rownames(tse1), c(rownames(tse_a)[3], rownames(tse1)[-1]))
    cname <- c(colnames(tse1)[1], colnames(tse_a)[2], colnames(tse1)[-(1:2)])
    expect_equal(colnames(tse1), cname)
    
    # 'value' and 'x' has different row trees & col trees 
    tse1 <- tse_a
    tse1[1, 2] <- tse_b[3, 2]
    expect_equal(dim(tse1), dim(tse_a))
    expect_equal(length(colTree(tse1, whichTree = NULL)), 2)
    expect_equal(length(rowTree(tse1, whichTree = NULL)), 2)
    expect_equal(rownames(tse1), c(rownames(tse_b)[3], rownames(tse1)[-1]))
    cname <- c(colnames(tse1)[1], colnames(tse_b)[2], colnames(tse1)[-(1:2)])
    expect_equal(colnames(tse1), cname)
    
    namRx <- rowLinks(tse1)$whichTree[1]
    namCx <- colLinks(tse1)$whichTree[2]
    namRv <- rowLinks(tse_b)$whichTree[3]
    namCv <- colLinks(tse_b)$whichTree[2]
    expect_identical(rowTree(tse1, whichTree = namRx),
                     rowTree(tse_b, whichTree = namRv))
    expect_identical(colTree(tse1, whichTree = namCx),
                     colTree(tse_b, whichTree = namCv))
    
    
    
})

context("rbind-cbind")

# rbind works :
# a) TSE without rowTree and without colTree
# b) TSE with rowTree but without colTree
# c) TSE without rowTree but with colTree
# d) TSE with rowTree & colTree
# e) TSE with rowTree but without colTree (but has a different rowTree as b)
# f) TSE without rowTree but with colTree (but has a different colTree as c)

set.seed(1)
# a)
(tse_a <- makeTSE(include.rowTree = FALSE, include.colTree = FALSE))

# b)
(tse_b <- makeTSE(include.colTree = FALSE))
(tse_e <- makeTSE(include.colTree = FALSE))

# c)
(tse_c <- makeTSE(include.rowTree = FALSE))
(tse_f <- makeTSE(include.rowTree = FALSE))

# d)
(tse_d <- makeTSE())


test_that("cbind TreeSummarizedExperiment successfully", {
    # TreeSummarizedExperiment
    expect_s4_class(cbind(tse_c, tse_f),
                    "TreeSummarizedExperiment")
    
    # drop colTree when some TSEs have NULL and others have non-NULL colTree
    expect_warning(cbind(tse_a, tse_c), 
                   "colTree should be all NULL or non-NULL")
    
    # drop rowTree & rowLinks when rowTree are different in TSEs
    expect_warning(cbind(tse_b, tse_e), 
                   "rowTree & rowLinks differ in the provided TSEs")
    expect_warning(cbind(tse_b, tse_c), 
                   "rowTree & rowLinks differ in the provided TSEs")
    expect_warning(cbind(tse_b, tse_c), 
                   "colTree should be all NULL or non-NULL in TSEs")
    
    # cbind TSEs with different colTree end up with two phylo objects in colTree
    # of the new TSE
    tse_cf <- cbind(tse_c, tse_f)
    expect_equal(length(colTree(tse_cf, whichTree = NULL)), 2)
    
    # rbind TSEs with multiple phylo in the rowTree
    tse_cfc <- cbind(tse_cf, tse_c)
    expect_equal(length(colTree(tse_cfc, whichTree = NULL)), 2)
    expect_equal(nrow(tse_cfc), 10)
    expect_equal(ncol(tse_cfc), 12)
    
    # cbind multiple TSEs
    tse_CFC <- cbind(tse_c, tse_f, tse_c)
    expect_equal(tse_CFC, tse_cfc)
    
    # duplicated colTree are removed
    tse_cc <- cbind(tse_c, tse_c)
    expect_equal(length(colTree(tse_cc, whichTree = NULL)), 1)
})




test_that("rbind TreeSummarizedExperiment successfully", {
    # TreeSummarizedExperiment
    expect_s4_class(rbind(tse_b, tse_e),
                    "TreeSummarizedExperiment")
    
    # drop rowTree when some of TSEs have NULL and others have non-NULL rowTree
    expect_warning(rbind(tse_a, tse_b), 
                   "rowTree should be all NULL or non-NULL")
    
    # drop colTree & colLinks when colTree are different in TSEs
    expect_warning(rbind(tse_a, tse_c), 
                   "colTree & colLinks differ in the provided TSEs")
    expect_warning(rbind(tse_a, tse_d), 
                   "colTree & colLinks differ in the provided TSEs")
    expect_warning(rbind(tse_a, tse_d), 
                   "rowTree should be all NULL or non-NULL in TSEs")
    
    # rbind TSEs with different rowTree end up with two phylo objects in rowTree
    # of the new TSE
    tse_be <- rbind(tse_b, tse_e)
    expect_equal(length(rowTree(tse_be, whichTree = NULL)), 2)
    
    # rbind TSEs with multiple phylo in the rowTree
    tse_bbe <- rbind(tse_be, tse_b)
    expect_equal(length(rowTree(tse_bbe, whichTree = NULL)), 2)
    expect_equal(nrow(tse_bbe), 30)
    expect_equal(ncol(tse_bbe), 4)
    expect_equal(rowLinks(tse_bbe)$whichTree[1], "phylo")
    expect_equal(rowLinks(tse_bbe)$whichTree[11], "phylo.1")
    expect_equal(rowLinks(tse_bbe)$whichTree[21], "phylo")
    
    # rbind multiple TSEs
    tse_BBE <- rbind(tse_b, tse_e, tse_b)
    expect_equal(tse_BBE, tse_bbe)
    
    # duplicated rowTree are removed
    tse_bb <- rbind(tse_b, tse_b)
    expect_equal(length(rowTree(tse_bb, whichTree = NULL)), 1)
})

test_that("rbind TreeSummarizedExperiment with referenceSeq successfully", {
    library(BiocGenerics)
    refSeq1 <- DNAStringSetList(one = DNAStringSet(rep("A", 10)),
                                two = DNAStringSet(rep("B", 10)))
    refSeq2 <- DNAStringSetList(one = DNAStringSet(rep("C", 10)),
                                two = DNAStringSet(rep("D", 10)))
    refSeq3 <- DNAStringSet(rep("C", 10))
    
    referenceSeq(tse_b) <- refSeq1
    referenceSeq(tse_e) <- refSeq2
    
    # rbind TSEs with DNAStringSetList in the  referenceSeq slot
    tse_be <- rbind(tse_b, tse_e)
    expect_equal(lengths(referenceSeq(tse_be)), c(one = 20, two = 20))
    
    # Error: one TSE with DNAStringSetList & the other with DNAStringSet
    referenceSeq(tse_e) <- refSeq3
    expect_error(rbind(tse_b, tse_e),
                 "all TSEs should have the same class in the referenceSeq")
    
    # Error: one TSE with DNAStringSetList & the other with NULL
    referenceSeq(tse_e) <- NULL
    expect_error(rbind(tse_b, tse_e),
                 "all TSEs should have the same class in the referenceSeq")
})

.sce_to_tse <- function(sce){
    tse <- new("TreeSummarizedExperiment",
               sce,
               rowTree = NULL,
               colTree = NULL,
               rowLinks = NULL,
               colLinks = NULL,
               referenceSeq = NULL)
    tse
}

#' @importClassesFrom SingleCellExperiment SingleCellExperiment
setAs("SingleCellExperiment", "TreeSummarizedExperiment",function(from) {
    .sce_to_tse(from)
})

#' @importClassesFrom SummarizedExperiment SummarizedExperiment
setAs("SummarizedExperiment", "TreeSummarizedExperiment",function(from) {
    .sce_to_tse(as(from,"SingleCellExperiment"))
})

#' @importClassesFrom SummarizedExperiment RangedSummarizedExperiment
setAs("RangedSummarizedExperiment", "TreeSummarizedExperiment",function(from) {
    .sce_to_tse(as(from,"SingleCellExperiment"))
})

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE, message = FALSE, warning = FALSE)

## ----strTSE, echo=FALSE, fig.width= 12, fig.cap= "The structure of the TreeSummarizedExperiment class."----
knitr::include_graphics("tse2.png")

## -----------------------------------------------------------------------------
library(TreeSummarizedExperiment)

# assays data (typically, representing observed data from an experiment)
assay_data <- rbind(rep(0, 4), matrix(1:20, nrow = 5))
colnames(assay_data) <- paste0("sample", 1:4)
rownames(assay_data) <- paste("entity", seq_len(6), sep = "")
assay_data

## -----------------------------------------------------------------------------
# row data (feature annotations)
row_data <- data.frame(Kingdom = "A",
                       Phylum = rep(c("B1", "B2"), c(2, 4)),
                       Class = rep(c("C1", "C2", "C3"), each = 2),
                       OTU = paste0("D", 1:6),
                       row.names = rownames(assay_data),
                       stringsAsFactors = FALSE)

row_data
# column data (sample annotations)
col_data <- data.frame(gg = c(1, 2, 3, 3),
                       group = rep(LETTERS[1:2], each = 2), 
                       row.names = colnames(assay_data),
                       stringsAsFactors = FALSE)
col_data

## -----------------------------------------------------------------------------
library(ape)

# The first toy tree 
set.seed(12)
row_tree <- rtree(5)

# The second toy tree 
set.seed(12)
col_tree <- rtree(4)

# change node labels
col_tree$tip.label <- colnames(assay_data)
col_tree$node.label <- c("All", "GroupA", "GroupB")

## ----plot-rtree, fig.cap="\\label{plot-rtree} The structure of the row tree. The node labels and the node numbers are in orange and blue text, respectively.", out.width="90%"----
library(ggtree)
library(ggplot2)

# Visualize the row tree
ggtree(row_tree, size = 2, branch.length = "none") +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7, size = 5.5) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7, size = 5.5) 

## ----plot-ctree, fig.cap="\\label{plot-ctree} The structure of the column tree. The node labels and the node numbers are in orange and blue text, respectively.", out.width="90%"----
# Visualize the column tree
ggtree(col_tree, size = 2, branch.length = "none") +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7, size = 5.5) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7, size = 5.5)+
    ylim(c(0.8, 4.5)) +
    xlim(c(0, 2.2))

## -----------------------------------------------------------------------------
# all column names could be found in the node labels of the column tree
all(colnames(assay_data) %in% c(col_tree$tip.label, col_tree$node.label))

# provide the node labels in rowNodeLab
tip_lab <- row_tree$tip.label
row_lab <- tip_lab[c(1, 1:5)]
row_lab

both_tse <- TreeSummarizedExperiment(assays = list(Count = assay_data),
                                     rowData = row_data,
                                     colData = col_data,
                                     rowTree = row_tree,
                                     rowNodeLab = row_lab,
                                     colTree = col_tree)

## -----------------------------------------------------------------------------
both_tse

## -----------------------------------------------------------------------------
# to get the first table in the assays
(count <- assays(both_tse)[[1]])

## -----------------------------------------------------------------------------
# to get row data
rowData(both_tse)

## -----------------------------------------------------------------------------
# to get column data
colData(both_tse)

## -----------------------------------------------------------------------------
# to get metadata: it's empty here
metadata(both_tse)

## -----------------------------------------------------------------------------
# get trees
rowTree(both_tse)
colTree(both_tse)

## -----------------------------------------------------------------------------
new_tse <- both_tse

# a new tree
new_tree <- rtree(nrow(new_tse))
new_tree$tip.label <- rownames(new_tse)

# the original row tree is replaced with the new tree
rowTree(new_tse) <- new_tree
identical(rowTree(new_tse), rowTree(both_tse))
identical(rowTree(new_tse), new_tree)


## -----------------------------------------------------------------------------
# access the link data
(r_link <- rowLinks(both_tse))
(c_link <- colLinks(both_tse))

## -----------------------------------------------------------------------------
class(r_link)
showClass("LinkDataFrame")

## -----------------------------------------------------------------------------
refSeq <- DNAStringSet(rep("AGCT", nrow(both_tse)))

## -----------------------------------------------------------------------------
referenceSeq(both_tse) <- refSeq
referenceSeq(both_tse)

## -----------------------------------------------------------------------------
both_tse

## -----------------------------------------------------------------------------
sub_tse <- both_tse[1:2, 1]
sub_tse

# The tree stays the same
identical(rowTree(sub_tse), rowTree(both_tse))

## -----------------------------------------------------------------------------
# the row data
rowData(sub_tse)

# the row link data
rowLinks(sub_tse)


## -----------------------------------------------------------------------------
# The first four columns are from colLinks data and the others from colData
cbind(colLinks(sub_tse), colData(sub_tse))

## -----------------------------------------------------------------------------
node_tse <- subsetByNode(x = both_tse, rowNode = "t3")

rowLinks(node_tse)

## -----------------------------------------------------------------------------
node_tse <- subsetByNode(x = both_tse, rowNode = "t3", 
                         colNode = c("sample1", "sample2"))
assays(node_tse)[[1]]

## ----plot-taxa2phylo, fig.cap="\\label{plot-taxa2phylo} The structure of the taxonomic tree that is generated from the taxonomic table.", out.width="90%"----
# The toy taxonomic table
(taxa <- rowData(both_tse))

# convert it to a phylo tree
taxa_tree <- toTree(data = taxa)

# Viz the new tree
ggtree(taxa_tree)+
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7, size = 5.5) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7, size = 5.5) +
    geom_point2()

## -----------------------------------------------------------------------------
taxa_tse <- changeTree(x = both_tse, rowTree = taxa_tree, 
                       rowNodeLab = taxa[["OTU"]])

taxa_tse
rowLinks(taxa_tse)

## -----------------------------------------------------------------------------
# use node labels to specify colLevel
agg_col <- aggTSE(x = taxa_tse,
                  colLevel = c("GroupA", "GroupB"),
                  colFun = sum)

# or use node numbers to specify colLevel
agg_col <- aggTSE(x = taxa_tse, colLevel = c(6, 7), colFun = sum)

## -----------------------------------------------------------------------------
assays(agg_col)[[1]]

## -----------------------------------------------------------------------------
# before aggregation
colData(taxa_tse)
# after aggregation
colData(agg_col)

## -----------------------------------------------------------------------------
agg_col <- aggTSE(x = taxa_tse, colLevel = c(6, 7),
                  colFun = sum, colDataCols = "group")
colData(agg_col)

## -----------------------------------------------------------------------------
# the link data is updated
colLinks(agg_col)

## -----------------------------------------------------------------------------
# the phylum level
taxa <- c(taxa_tree$tip.label, taxa_tree$node.label)
(taxa_one <- taxa[startsWith(taxa, "Phylum:")])

# aggregation
agg_taxa <- aggTSE(x = taxa_tse, rowLevel = taxa_one, rowFun = sum)
assays(agg_taxa)[[1]]

## -----------------------------------------------------------------------------
# A mixed level
taxa_mix <- c("Class:C3", "Phylum:B1")
agg_any <- aggTSE(x = taxa_tse, rowLevel = taxa_mix, rowFun = sum)
rowData(agg_any)

## -----------------------------------------------------------------------------
agg_both <- aggTSE(x = both_tse, colLevel = c(6, 7), 
                   rowLevel = 7:9, rowFun = sum,
                   colFun = mean, rowFirst = FALSE)

## -----------------------------------------------------------------------------
assays(agg_both)[[1]]

## ----plot-exTree, fig.cap= "\\label{plot-exTree} An example tree with node labels and numbers in black and orange texts, respectively.", out.width="90%"----
data("tinyTree")
ggtree(tinyTree, branch.length = "none") +
    geom_text2(aes(label = label), hjust = -0.1, size = 5.5) +
    geom_text2(aes(label = node), vjust = -0.8,
               hjust = -0.2, color = 'orange', size = 5.5) 

## -----------------------------------------------------------------------------
convertNode(tree = tinyTree, node = c(12, 1, 4))

## -----------------------------------------------------------------------------
convertNode(tree = tinyTree, node = c("t4", "Node_18"))

## -----------------------------------------------------------------------------
# only the leaf nodes
findDescendant(tree = tinyTree, node = 17, only.leaf = TRUE)

## -----------------------------------------------------------------------------
# all descendant nodes
findDescendant(tree = tinyTree, node = 17, only.leaf = FALSE)

## -----------------------------------------------------------------------------
# tse: a TreeSummarizedExperiment object
# rowLeaf: specific leaves
subsetByLeaf <- function(tse, rowLeaf) {
  # if rowLeaf is provided as node labels, convert them to node numbers
  if (is.character(rowLeaf)) {
    rowLeaf <- convertNode(tree = rowTree(tse), node = rowLeaf)
  }
  
  # subset data by leaves
  sse <- subsetByNode(tse, rowNode = rowLeaf)
  
  # update the row tree
    ## -------------- new tree: drop leaves ----------
    oldTree <- rowTree(sse)
    newTree <- ape::keep.tip(phy = oldTree, tip = rowLeaf)
    
    ## -------------- update the row link ----------
    # track the tree
    track <- trackNode(oldTree)
    track <- ape::keep.tip(phy = track, tip = rowLeaf)
    
    # row links
    rowL <- rowLinks(sse)
    rowL <- DataFrame(rowL)
    
    # update the row links: 
    #   1. use the alias label to track and updates the nodeNum
    #   2. the nodeLab should be updated based on the new tree using the new
    #      nodeNum
    #   3. lastly, update the nodeLab_alias
    rowL$nodeNum <- convertNode(tree = track, node = rowL$nodeLab_alias,
                              message = FALSE)
    rowL$nodeLab <- convertNode(tree = newTree, node = rowL$nodeNum, 
                              use.alias = FALSE, message = FALSE)
    rowL$nodeLab_alias <- convertNode(tree = newTree, node = rowL$nodeNum, 
                                    use.alias = TRUE, message = FALSE)
    rowL$isLeaf <- isLeaf(tree = newTree, node = rowL$nodeNum)

    rowNL <- new("LinkDataFrame", rowL)
    
    ## update the row tree and links
    BiocGenerics:::replaceSlots(sse,
                              rowLinks = rowNL,
                              rowTree = list(phylo = newTree))
}


## -----------------------------------------------------------------------------
(both_sse <- subsetByLeaf(tse = both_tse, rowLeaf = c("t2", "t3")))
rowLinks(both_sse)

## -----------------------------------------------------------------------------
sessionInfo()

#' To test whether the specified nodes are leaf nodes
#'
#' \code{isLeaf} is to test wheter some specified nodes are leaf nodes of a
#' tree.
#'
#' @param tree A phylo object.
#' @param node A numeric or character vector. Node labels or node numbers.
#'
#' @export
#' @author Ruizhu HUANG
#' @return a logical vector with the same length as the input \code{node}.
#' @examples
#' data(tinyTree)
#' library(ggtree)
#'
#' # PLOT tree
#' # The node labels are in orange texts and the node numbers are in blue
#' ggtree(tinyTree,branch.length = 'none')+
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#'
#' isLeaf(tree = tinyTree, node = c(5, 4, 18))
#' isLeaf(tree = tinyTree, node = c("t4", "t9", "Node_18" ))
#'
isLeaf <- function(tree, node){

    edge <- tree$edge
    leaf <- setdiff(edge[, 2], edge[, 1])

    # the input node
    if (is.character(node)) {
        node <- convertNode(tree, node = node,
                           message = FALSE)
    } else {
        if (is.numeric(node)) {
            node <- node
        } else {
            stop("The input node should be a character or numeric vector. \n")
        }
    }

    # check whether the specified node exists on the tree
    if (any(!node %in% as.vector(edge))) {
        stop("Node", node[!node %in% as.vector(edge)],
             " can't be matched to any node of the tree. \n")
    }


    # is it a leaf node
    isLeaf <- node %in% leaf
    return(isLeaf)
}

context("isLeaf")

test_that("shareNode could find correct information", {
    data("tinyTree")
    expect_error(isLeaf(tree = tinyTree),
                 'argument "node" is missing')
    
    expect_isLeaf_equal <- function(test, truth){
        expect_equal(isLeaf(tree = tinyTree, node = test), truth)
    }
    expect_isLeaf_equal(5, TRUE)
    expect_isLeaf_equal(4, TRUE)
    expect_isLeaf_equal(18, FALSE)
    expect_isLeaf_equal(c(5,4,18), c(TRUE,TRUE,FALSE))
    expect_isLeaf_equal(c(5,18,4), c(TRUE,FALSE,TRUE))
    expect_error(isLeaf(tree = tinyTree, node = 20),
                 "Node20 can't be matched to any node of the tree")
    expect_error(isLeaf(tree = tinyTree, input = 20),
                 "unused argument \\(input = 20\\)")
})

#' A simulated phylogenetic tree with 10 tips and 9 internal nodes
#'
#' A random phylo object created using the function \code{\link[ape:rtree]{rtree}}
#' @importFrom ape rtree
#' @format A phylo object with 10 tips and 9 internal nodes:
#' \describe{
#'   \item{Tip labels}{t1, t2, ..., t10.}
#'   \item{Node labels}{Node_11, Node_12, ..., Node_19}
#' }
#'
#'
"tinyTree"

# ======================
### class
# ======================

#-------------------------------------------------------------------------------
#' phylo: A S3 class for the phylogenetic tree
#-------------------------------------------------------------------------------
#'
#' The \pkg{ape} package does not export its phylo class, probably because it
#' is not really defined formally anywhere. Technically, it is an S3 class
#' extended from the class list. Any exported definitions from the \pkg{ape}
#' package would be preferred to use if available.
#' @importFrom methods setOldClass
#' @keywords internal
phylo <- structure(list(), class = "phylo")
setOldClass("phylo")

setClassUnion("list_Or_NULL", c("list", "NULL"))
#-------------------------------------------------------------------------------
#' LinkDataFrame: A S4 class extended from DataFrame
#-------------------------------------------------------------------------------
#' An S4 class LinkDataFrame
#'
#' The \strong{LinkDataFrame} is extended from the class \strong{DataFrame} to
#' include at least four columns \code{nodeLab}, \code{nodeLab_alias},
#' \code{nodeNum}, and \code{isLeaf}.
#'
#' @importClassesFrom S4Vectors DataFrame
#' @exportClass LinkDataFrame
#'
#' @section Constructor:
#' See \code{\link{LinkDataFrame-constructor}} for constructor
#' functions.
#'
setClass("LinkDataFrame",
         contains = "DFrame")

setClassUnion("LinkDataFrame_Or_NULL", c("LinkDataFrame", "NULL"))
#-------------------------------------------------------------------------------
#' Construct a LinkDataFrame
#-------------------------------------------------------------------------------
#' Construct a LinkDataFrame object
#' @param nodeLab A character vector
#' @param nodeLab_alias A character vector
#' @param nodeNum A numeric vector
#' @param isLeaf A logical vector
#' @param whichTree A character vector
#' @param ... All arguments accepted by
#'   \code{\link[S4Vectors:DataFrame-class]{DataFrame-class}}.
#'
#' @importFrom S4Vectors DataFrame
#' @name LinkDataFrame-constructor
#' @export
#' @return A LinkDataFrame object
#' @seealso \code{\link[=LinkDataFrame-class]{LinkDataFrame}}
#'   \code{\link[S4Vectors:DataFrame-class]{DataFrame}}
#' @examples
#'
#'
#' (ld <- LinkDataFrame(nodeLab = letters[1:5],
#'                      nodeLab_alias = LETTERS[1:5],
#'                      nodeNum = 1:5,
#'                      isLeaf = TRUE,
#'                      whichTree = LETTERS[1:5],
#'                      right = 1:5))
LinkDataFrame <- function(nodeLab, nodeLab_alias, nodeNum,
                          isLeaf, whichTree, ...) {
    df <- DataFrame(nodeLab, nodeLab_alias, nodeNum,
                    isLeaf, whichTree, ...)

    new("LinkDataFrame", df)
}

#-------------------------------------------------------------------------------
# TreeSummarizedExperiment
#-------------------------------------------------------------------------------
#' An S4 class TreeSummarizedExperiment
#'
#' The class \strong{TreeSummarizedExperiment} is an extension class of standard
#' \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}} class. It has
#' four more slots that are not in
#' \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}} class:
#' \code{rowTree}, \code{rowLinks} \code{colTree} and \code{colLinks}. The
#' hierarchical information of rows (columns) is stored in \code{rowTree}
#' (\code{colTree}) and the link between the rows (columns) of \code{assays}
#' tables and nodes of the tree is given in \code{rowLinks} (\code{colLinks}).
#'
#' @slot rowTree A phylo object or NULL. It gives information about the
#'   hiearchical structure of rows of \code{assays} tables.
#' @slot colTree A phylo object or NULL. It gives information about the
#'   hiearchical structure of columns of \code{assays} tables.
#' @slot rowLinks A LinkDataFrame. It gives information about the link between
#'   the nodes of the \code{rowTree} and the rows of \code{assays} tables.
#' @slot colLinks A LinkDataFrame. It gives information about the link between
#'   the nodes of the \code{colTree} and the columns of \code{assays} tables.
#' @slot referenceSeq A \code{DNAStringSet}/\code{DNAStringSetList} object or
#'   some object coercible to a \code{DNAStringSet}/\code{DNAStringSetList}
#'   object. See \code{\link[Biostrings:XStringSet-class]{DNAStringSet}} for
#'   more details.
#' @slot ... Other slots from
#'   \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
#'
#' @section Constructor:
#' See \code{\link{TreeSummarizedExperiment-constructor}} for constructor
#' functions.
#'
#' @section Accessor:
#' See \code{\link{TreeSummarizedExperiment-accessor}} for accessor functions.
#'
#' @details The class \strong{TreeSummarizedExperiment} is designed to store
#'   rectangular data for entities (e.g., microbes or cell types)
#'   (\code{assays}), information about the hiearchical structure
#'   (\code{rowTree} on rows; \code{colTree} on columns), and the mapping
#'   information between the tree nodes and the rows or the columns of the
#'   rectangular data. Users could provide the hiearchical structure of the
#'   rows, columns or both) of the \code{assays} tables, and the link data will
#'   be automatically generated in \code{rowLinks}, \code{colData} or both,
#'   respectively. It's required that the object in \code{rowLinks} or
#'   \code{colLinks} has the \code{LinkDataFrame} class. Please see the page
#'   \code{\link{LinkDataFrame}} for more details.
#'
#' @importFrom methods setClass
#' @importClassesFrom SingleCellExperiment SingleCellExperiment
#' @importClassesFrom S4Vectors DataFrame
#' @name TreeSummarizedExperiment-class
#' @seealso \code{\link{TreeSummarizedExperiment}}
#'   \code{\link{TreeSummarizedExperiment-accessor}}
#'   \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
NULL

#' @importFrom Biostrings DNAStringSet DNAStringSetList
setClassUnion("DNAStringSetList_OR_DNAStringSet_OR_NULL",
              c("DNAStringSetList", "DNAStringSet","NULL"))

#' @name TreeSummarizedExperiment-class
#' @exportClass TreeSummarizedExperiment
setClass("TreeSummarizedExperiment",
         contains = "SingleCellExperiment",
         slots = c(rowTree = "list_Or_NULL",
                   colTree = "list_Or_NULL",
                   rowLinks = "LinkDataFrame_Or_NULL",
                   colLinks = "LinkDataFrame_Or_NULL",
                   referenceSeq = "DNAStringSetList_OR_DNAStringSet_OR_NULL"),
         prototype = list(referenceSeq = NULL))

#' @rdname TreeSummarizedExperiment-internal
#' @export
setMethod("vertical_slot_names", "TreeSummarizedExperiment",
          function(x) c("referenceSeq", callNextMethod())
)



# ==========================================================================
### Constructor
# ==========================================================================

#' Construct a TreeSummarizedExperiment object
#'
#' \code{TreeSummarizedExperiment} constructs a TreeSummarizedExperiment object.
#'
#' @inheritParams SingleCellExperiment::SingleCellExperiment
#' @param rowTree A phylo object that provides hiearchical information of rows
#'   of assay tables.
#' @param colTree A phylo object that provides hiearchical information of
#'   columns of assay tables.
#' @param rowNodeLab A character string. It provides the labels of nodes that
#'   the rows of \code{assays} tables corresponding to. If NULL (default), the
#'   row names of the \code{assays} tables are used.
#' @param colNodeLab A character string. It provides the labels of nodes that
#'   the columns of \code{assays} tables corresponding to. If NULL (default),
#'   the column names of the \code{assays} tables are used.
#' @param referenceSeq A \code{DNAStringSet}/\code{DNAStringSetList} object or
#'   some object coercible to a \code{DNAStringSet}/\code{DNAStringSetList}
#'   object. See \code{\link[Biostrings:XStringSet-class]{DNAStringSet}} for
#'   more details.
#'
#' @details The output TreeSummarizedExperiment object has very similar
#'   structure as the
#'   \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}. The
#'   differences are summarized be as below.
#'   \itemize{
#'   \item \strong{rowTree} A slot exists in \code{TreeSummarizedExperiment}
#'   but not in \code{SingleCellExperiment}. It stores the tree structure(s)
#'   that provide(s) hierarchical information of \code{assays} rows or columns
#'   or both.
#'   \item \strong{rowData} If a \code{phylo} object is available in the slot
#'   \code{treeData} to provide the hiearchical information about the rows of
#'   the \code{assays} table, the \code{rowData} would be a
#'   \code{\link{LinkDataFrame-class}} instead of
#'   \code{\link[S4Vectors:DataFrame-class]{DataFrame}}. The data on the right side of the
#'   vertical line provides the link information between the \code{assays} rows
#'   and the tree \code{phylo} object, and could be accessed via
#'   \code{linkData}; The data on the left side is the original \code{rowData}
#'   like \code{SingleCellExperiment} object.
#'   \item \strong{colData} Similar to the explanaition for \strong{rowData} as
#'   above.
#'  }
#'  More details about the \code{LinkDataFrame} in the \code{rowData} or
#'  \code{colData}.
#'  \itemize{
#'  \item nodeLab The labels of nodes on the tree.
#'  \item nodeLab\_alias The alias of node labels on the tree.
#'  \item nodeNum The numbers of nodes on the tree.
#'  \item isLeaf It indicates whether the node is a leaf node or internal node.
#'  }
#'
#' @importFrom SummarizedExperiment assays colData<- rowData<-
#' @importFrom S4Vectors DataFrame
#' @importFrom methods new is as
#' @export
# #' @include classValid.R
#' @return a TreeSummarizedExperiment object
#' @name TreeSummarizedExperiment-constructor
#' @author Ruizhu HUANG
#' @seealso \code{\link[=TreeSummarizedExperiment-class]{TreeSummarizedExperiment}}
#'   \code{\link[=TreeSummarizedExperiment-accessor]{TreeSummarizedExperiment-accessor}}
#'   \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
#' @examples
#'
#' data("tinyTree")
#'
#' # the count table
#' count <- matrix(rpois(100, 50), nrow = 10)
#' rownames(count) <- c(tinyTree$tip.label)
#' colnames(count) <- paste("C_", 1:10, sep = "_")
#'
#' # The sample information
#' sampC <- data.frame(condition = rep(c("control", "trt"), each = 5),
#'                     gender = sample(x = 1:2, size = 10, replace = TRUE))
#' rownames(sampC) <- colnames(count)
#'
#' # build a TreeSummarizedExperiment object
#' tse <- TreeSummarizedExperiment(assays = list(count),
#'                                 colData = sampC,
#'                                 rowTree = tinyTree)
#'
TreeSummarizedExperiment <- function(..., rowTree = NULL, colTree = NULL,
                                     rowNodeLab = NULL, colNodeLab = NULL,
                                     referenceSeq = NULL) {

    if (!is.null(rowNodeLab)) {
        if (!is.character(rowNodeLab)) {
            stop("rowNodeLab should be a character vector", call. = FALSE)
        }
        if (is.null(rowTree)) {
            stop("rowTree is not available", call. = FALSE)
        }
    }

    if (!is.null(colNodeLab)) {
        if (!is.character(colNodeLab)) {
            stop("colNodeLab should be a character vector", call. = FALSE)
        }
        if (is.null(colTree)) {
            stop("colTree is not available", call. = FALSE)
        }
    }


    # -------------------------------------------------------------------------
    ## create a SummarizedExperiment object
    sce <- SingleCellExperiment(...)

    # -------------------------------------------------------------------------
    ## Indicate whether hiearchical information is available for rows and
    ## columns of assay tables
    isRow <- !is.null(rowTree)
    isCol <- !is.null(colTree)

    # # if not tree information are given, return a SingleCellExperiment
    # if(!isRow && !isCol){
    #     return(sce)
    # }

    # -------------------------------------------------------------------------
    ## check whether the input tree has the correct form
    if (isRow) {
        # the tree should be a phylo object
        if(!is(rowTree, "phylo")) {
            stop("A phylo object is required for the rowTree", "\n",
                 call. = FALSE)
        }

        # the tree should have unique leaf labels
        tipLab <- rowTree$tip.label
        anyDp <- any(duplicated(tipLab))
        if (anyDp) {
            stop("rowTree should have unique leaf labels. \n",
                 call. = FALSE)
        }
    }

    if (isCol) {
        # the tree should be a phylo object
        if(!is(colTree, "phylo")) {
            stop("A phylo object is required for the colTree", "\n",
                 call. = FALSE)
        }

        # the tree should have unique leaf labels
        tipLab <- colTree$tip.label
        anyDp <- any(duplicated(tipLab))
        if (anyDp) {
            stop("colTree should have unique leaf labels. \n",
                 call. = FALSE)
        }
    }

    # -------------------------------------------------------------------------
    ## create the link data
    tse <- new("TreeSummarizedExperiment",
               sce,
               referenceSeq = referenceSeq)

    # the rows:
    if (isRow) {
        rowData(tse) <- rowData(sce)
        out <- .linkFun(tree = rowTree, sce = sce,
                                 nodeLab = rowNodeLab, onRow = TRUE)
        tse <- tse[out$isKeep, ]
        tse@rowTree <- list(phylo = rowTree)
        tse@rowLinks <- out$link

    } else {
        tse@rowLinks <- NULL
    }


    # the columns:
    if (isCol) {
        colData(tse) <- colData(sce)
        out <- .linkFun(tree = colTree, sce = sce,
                        nodeLab = colNodeLab, onRow = FALSE)
        tse <- tse[, out$isKeep]
        tse@colTree <- list(phylo = colTree)
        tse@colLinks <- out$link

    } else {
        tse@colLinks <- NULL
    }


    return(tse)
}

# An internal function to create the link data 
.linkFun <- function(tree, sce, nodeLab, onRow = TRUE) {
    if (onRow) {
        annDat <- rowData(sce)
    } else {
        annDat <- colData(sce)
    }

    kw <- ifelse(onRow, "row", "column")

    # ------------------ labels from the tree ---------------------------------
    # the labels and the alias of the labels
    treeLab <- c(tree$tip.label, tree$node.label)
    nodeA <- unique(as.vector(tree$edge))
    treeLab_alias <- convertNode(tree = tree, node = nodeA,
                               use.alias = TRUE, message = FALSE)

    # ------------------ labels from the assays table -------------------------
    # The order to be used:nodeLab > the row names
    lab <- nodeLab

    # if nodeLab is not available, use the row names
    if (is.null(lab)) {
        lab <- rownames(annDat)
        if (is.null(lab)) {
            stop(kw, "NodeLab should be provided. \n", call. = FALSE)}
        }

    # decide whether treeLab or treeLab_alias should be used
    sw <- startsWith(lab, "alias_")
    sw <- all(sw)

    sw2 <- startsWith(treeLab, "alias_")
    notALL <- !all(sw2)
    if (any(sw2, na.rm = TRUE) & notALL) {
        warning("The tree has some node labels starting with 'alias_'. ",
                call. = FALSE)
    }

    # Match lab with the alias of the node labels on the tree
    # Unless all node labels start with 'alias_'
    if (sw & notALL) {
        isIn <- lab %in% treeLab_alias
    } else {
        isIn <- lab %in% treeLab
    }

    # Those with labels that don't match with the node labels of the tree are
    # excluded
    isOut <- !isIn
    if (sum(isOut) > 0) {
        warning(sum(isOut), " ", kw,
                "(s) couldn't be matched to the tree and are/is removed. \n",
                call. = FALSE)}

    if (onRow) {
        sce <- sce[isIn, ]
        rn <- rownames(sce)
    } else {
        sce <- sce[, isIn]
        rn <- colnames(sce)
    }


    # create the link data
    labN <- lab[isIn]
    nd <- convertNode(tree = tree, node = labN, use.alias = FALSE,
                    message = FALSE)
    fLab <- convertNode(tree = tree, node = nd, use.alias = FALSE,
                      message = FALSE)
    faLab <- convertNode(tree = tree, node = nd, use.alias = TRUE,
                       message = FALSE)
    leaf <- unique(setdiff(tree$edge[, 2], tree$edge[, 1]))

    if (sum(isIn)) {
        ind_tree <- "phylo"
    } else {
        ind_tree <- character(0)
    }
    linkD <- LinkDataFrame(nodeLab = fLab,
                           nodeLab_alias = faLab,
                           nodeNum = nd,
                           isLeaf = nd %in% leaf,
                           whichTree = ind_tree)

    rownames(linkD) <- rn

    out <- list(link = linkD, isKeep = isIn)
    return(out)
}

context("accessor_constructor")

# assays data
toyTable <- matrix(1:40, nrow = 10)
colnames(toyTable) <- paste(rep(LETTERS[1:2], each = 2), rep(1:2, 2), sep = "_")
rownames(toyTable) <- paste("entity", seq_len(10), sep = "")

data("tinyTree")

# row data
rowInf <- DataFrame(var1 = sample(letters[1:2], 10, replace = TRUE),
                    var2 = sample(c(TRUE, FALSE), 10, replace = TRUE),
                    row.names = rownames(toyTable))
# column data
colInf <- DataFrame(gg = c(1, 2, 3, 3),
                    group = rep(LETTERS[1:2], each = 2),
                    row.names = colnames(toyTable))
colTree <- rtree(4)
colTree$tip.label <- colnames(toyTable)
colTree$node.label <- c("All", "GroupA", "GroupB")

refSeq <- DNAStringSetList(one = DNAStringSet(rep("A",nrow(toyTable))),
                           two = DNAStringSet(rep("B",nrow(toyTable))))

tse <- TreeSummarizedExperiment(assays = list(toyTable),
                                rowData = rowInf,
                                rowNodeLab = tinyTree$tip.label,
                                colData = colInf,
                                rowTree = tinyTree,
                                colTree = colTree,
                                referenceSeq = refSeq)
test_that("TreeSummarizedExperiment constuctor works", {
    # TreeSummarizedExperiment
    expect_s4_class(tse,
                    "TreeSummarizedExperiment")
    
    # without tree and refseq
    expect_s4_class(TreeSummarizedExperiment(assays = list(toyTable),
                                             rowData = rowInf,
                                             colData = colInf),
                    "TreeSummarizedExperiment")
    
    # without tree
    expect_s4_class(TreeSummarizedExperiment(assays = list(toyTable),
                                             rowData = rowInf,
                                             colData = colInf,
                                             referenceSeq = refSeq),
                    "TreeSummarizedExperiment")

    expect_warning(TreeSummarizedExperiment(assays = list(toyTable),
                                            rowData = rowInf,
                                            colData = colInf,
                                            colTree = tinyTree))
})
test_that("TreeSummarizedExperiment coercion works", {
    # SummarizedExperiment
    se <- SummarizedExperiment(assays = list(toyTable),
                               rowData = rowInf,
                               colData = colInf)
    expect_s4_class(as(se,"TreeSummarizedExperiment"),
                    "TreeSummarizedExperiment")
    # RangedSummarizedExperiment
    expect_s4_class(as(as(se,"RangedSummarizedExperiment"),
                       "TreeSummarizedExperiment"),
                    "TreeSummarizedExperiment")
    # RangedSummarizedExperiment
    expect_s4_class(as(as(se,"SingleCellExperiment"),
                       "TreeSummarizedExperiment"),
                    "TreeSummarizedExperiment")
})

test_that("assays could extract table successfully", {
    expect_equal(assays(tse)[[1]], toyTable)
})

test_that("assays could be written successfully", {
    assays(tse)[[2]] <- 2*toyTable
    expect_equal(assays(tse)[[2]], 2*toyTable)
})

test_that("row data could be extracted successfully", {
    expect_equal(colnames(rowData(tse)), colnames(rowInf))
    expect_setequal(colnames(rowLinks(tse)), c("nodeLab", "nodeLab_alias",
                                         "nodeNum", "isLeaf", "whichTree"))
    expect_equal(rowTree(tse), tinyTree)

})

test_that("row data could be written successfully", {
    tse1 <- tse
    rowData(tse1)$test <- rep(1, nrow(tse))
    expect_equal(rowData(tse1)$test, rep(1, nrow(tse)))
})


test_that("column data could be extracted successfully", {
    expect_equal(colData(tse), colInf)
})


test_that("row data could be subset successfully", {
    expect_equal(nrow(tse[1,]),1L)
    expect_equal(nrow(tse[rownames(tse)[1],]),1L)
})
test_that("column data could be subset successfully", {
    expect_equal(ncol(tse[,1]),1L)
    expect_equal(ncol(tse[,colnames(tse)[1]]),1L)
})
test_that("subsetting by node successfully", {
    expect_equal(nrow(subsetByNode(tse,"t2")),1L)
    expect_equal(subsetByNode(tse,"t2"),
                 subsetByNode(tse,1))

    expect_equal(ncol(subsetByNode(tse, colNode = "A_1")),1L)
    expect_equal(subsetByNode(tse, colNode = "A_1"),
                 subsetByNode(tse, colNode = 1))
})

test_that("other accessors/setters work", {
    # rowTreeNames & colTreeNames
    expect_equal(rowTreeNames(tse), "phylo")
    rowTreeNames(tse) <- "first_tree"
    expect_equal(rowTreeNames(tse), "first_tree")
    expect_equal(unique(rowLinks(tse)$whichTree), "first_tree")
    
    expect_equal(colTreeNames(tse), "phylo")
    colTreeNames(tse) <- "second_tree"
    expect_equal(colTreeNames(tse), "second_tree")
    expect_equal(unique(colLinks(tse)$whichTree), "second_tree")
    
    # check [
    expect_error(tse["entity11",],
                 "specified rows can't be found")
    expect_error(tse[,"C_1"],
                 "specified cols can't be found")
    
    # check show
    expect_output(show(tse),
                  "rowLinks: a LinkDataFrame")
    expect_output(show(tse),
                  "rowTree:")
    expect_output(show(tse),
                  "colLinks: a LinkDataFrame")
    expect_output(show(tse),
                  "colTree:")
    
    
    x <- TreeSummarizedExperiment(assays = list(toyTable),
                                  rowData = rowInf,
                                  colData = colInf)
    expect_output(show(x),
                  "rowLinks: NULL")
    expect_output(show(x),
                  "rowTree: NULL")
    expect_output(show(x),
                  "colLinks: NULL")
    expect_output(show(x),
                  "colTree: NULL")
    
    # rownames & colnames
    rn <- paste("entity", seq.int(10L,19L), sep = "")
    expect_true(all(rownames(rowLinks(tse)) != rn))
    rownames(tse) <- rn
    expect_true(all(rownames(rowLinks(tse)) == rn))
    cn <- paste(rep(LETTERS[1:2], each = 2), rep(3:4, 2), sep = "_")
    expect_true(all(rownames(colLinks(tse)) != cn))
    colnames(tse) <- cn
    expect_true(all(rownames(colLinks(tse)) == cn))

    tse <- TreeSummarizedExperiment(assays = list(toyTable),
                                    rowData = rowInf,
                                    colData = colInf)
    rownames(tse) <- rn
    colnames(tse) <- cn
    expect_true(all(rownames(tse) == rn))
    expect_true(all(colnames(tse) == cn))
    
    # reference seq
    expect_error(referenceSeq(tse) <- refSeq[list(1:5,1:4)])
    expect_error(referenceSeq(tse) <- refSeq[list(1:4,1:4)])
    expect_error(referenceSeq(tse) <- refSeq[[1L]][1:4])
    
    referenceSeq(tse) <- refSeq
    expect_s4_class(referenceSeq(tse),"DNAStringSetList")
    referenceSeq(tse) <- as.list(refSeq)
    expect_s4_class(referenceSeq(tse),"DNAStringSetList")
    referenceSeq(tse) <- refSeq[[1L]]
    expect_s4_class(referenceSeq(tse),"DNAStringSet")
    referenceSeq(tse) <- as.character(refSeq[[1L]])
    expect_s4_class(referenceSeq(tse),"DNAStringSet")
    
    expect_true(all(rownames(tse) == names(referenceSeq(tse))))
    rownames(tse) <- NULL
    expect_true(is.null(names(referenceSeq(tse))))
    
})

# ============================================================================
### The documentation of accessor functions
### The corresponding codes are in the file allGenerics.R
# ============================================================================

# -----------------------------------------------------------------------------
### TreeSummarizedExperiment
# -----------------------------------------------------------------------------
#' TreeSummarizedExperiment-accessors
#'
#' All accessor functions that work on
#' \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
#' should work on \strong{TreeSummarizedExperiment}. Additionally, new accessors
#' \code{rowLinks} \code{colLinks}, \code{rowTree} and \code{colTree} accessor
#' function are available for \strong{TreeSummarizedExperiment}.
#' 
#' @param x A TreeSummarizedExperiment object
#' @param i,j The row, column index to subset \code{x}. The arguments of the
#'   subset function \code{[]}
#' @param drop A logical value, TRUE or FALSE. The argument from the subset
#'   function \code{[]}
#' @param value
#' \itemize{
#'   \item{the new rownames or colnames as a \code{character} value. See
#'     \code{\link[BiocGenerics:row_colnames]{BiocGenerics}}.}
#'   \item{A \code{\link[Biostrings:XStringSet-class]{DNAStringSet}}
#'     object or an object coercible to one}
#' }
#' @param whichTree A numeric indicator or name character to specify which tree
#'   in the \code{rowTree} or \code{colTree} to be extracted. The default is to
#'   extract the first tree. If \code{whichTree = NULL}, a list of all trees is
#'   extracted.
#' @param ... The argument from the subset function \code{[]}
#' @param rowLeaf A vector of leaves that are used to subset rows. One could use
#'   the leaf number, or the leaf label to specify nodes, but not a mixture of
#'   them.
#' @param colLeaf A vector of leaves that are used to subset columns. One could
#'   use the leaf number, or the leaf label to specify nodes, but not a mixture
#'   of them.
#' @param rowNode A vector of nodes that are used to subset rows. One could use
#'   the node number, the node label or the node alias to specify nodes, but not
#'   a mixture of them.
#' @param colNode A vector of nodes that are used to subset columns. One could
#'   use the node number, the node label or the node alias to specify nodes, but
#'   not a mixture of them.
#' @param whichRowTree A numeric indicator or name character to specify which tree
#'   in the \code{rowTree}.
#' @param whichColTree A numeric indicator or name character to specify which tree
#'   in the \code{colTree}.
#' @param updateTree TRUE or FALSE. Default is TRUE, which updates tree
#'   structures after subsetting.
#' @name TreeSummarizedExperiment-accessor
#' @return Elements from \code{TreeSummarizedExperiment}.
#' @seealso \code{\link{TreeSummarizedExperiment}}
#'   \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
#'
#' @author Ruizhu HUANG
#' @examples
#'
#' # the assay table
#' set.seed(1)
#' y <- matrix(rnbinom(300,size=1,mu=10),nrow=10)
#' colnames(y) <- paste(rep(LETTERS[1:3], each = 10), rep(1:10,3), sep = "_")
#' rownames(y) <- tinyTree$tip.label
#'
#' # the row data
#' rowInf <- DataFrame(var1 = sample(letters[1:3], 10, replace = TRUE),
#'                     var2 = sample(c(TRUE, FALSE), 10, replace = TRUE))
#' # the column data
#' colInf <- DataFrame(gg = factor(sample(1:3, 30, replace = TRUE)),
#'                     group = rep(LETTERS[1:3], each = 10))
#'
#' # the tree structure on the rows of assay tables
#' data("tinyTree")
#'
#' # the tree structure on the columns of assay tables
#' sampTree <- ape::rtree(30)
#' sampTree$tip.label <- colnames(y)
#'
#' # create the TreeSummarizedExperiment object
#' toy_tse <- TreeSummarizedExperiment(assays = list(y),
#'                                     rowData = rowInf,
#'                                     colData = colInf,
#'                                     rowTree = tinyTree,
#'                                     colTree = sampTree)
#'
#' ## extract the rowData
#' (rowD <- rowData(x = toy_tse))
#'
#' ## extract the colData
#' (colD <- colData(x = toy_tse))
#'
#' ## extract the linkData
#' # on rows
#' (rowL <- rowLinks(x = toy_tse))
#' # on columns
#' (colL <- colLinks(x = toy_tse))
#'
#'  ## extract the treeData
#' # on rows
#' (rowT <- rowTree(x = toy_tse))
#' # on columns
#' (colT <- colTree(x = toy_tse))
#'
#' # the referenceSeq data
#' refSeq <- DNAStringSetList(one = DNAStringSet(rep("A",nrow(toy_tse))),
#'                            two = DNAStringSet(rep("B",nrow(toy_tse))))
#' referenceSeq(toy_tse) <- refSeq
#' toy_tse
#' 
#' # subset treeSE by leaves
#' library(ape)
#' set.seed(1)
#' z <- makeTSE(nrow = 5, ncol = 4, include.rowTree = TRUE, include.colTree = FALSE)
#' y <- makeTSE(nrow = 4, ncol = 4, include.rowTree = TRUE, include.colTree = FALSE)
#' tr <- ape::rtree(4)
#' zy <- rbind(z, y)
#' x <- changeTree(x = zy, rowTree = tr, whichRowTree = 2, rowNodeLab = tr$tip.label)
#' rowLinks(zy)
#' rowLinks(x)
#' ## 1) rowLeaf exist only in one of trees
#' rf <- c("t1", "t3")
#' sx <- subsetByLeaf(x = x, rowLeaf = rf)
#' rowLinks(sx)
#' 
#' sx <- subsetByLeaf(x = x, rowLeaf = rf, updateTree = FALSE)
#' rowLinks(sx)
#' 
#' ## 2) rowLeaf exist in all trees
#' rf <- 1:3
#' sxx <- subsetByLeaf(x = x, rowLeaf = rf)
#' rowLinks(sxx)
#' 
#' 
#' 
#' ## 3) rowLeaf exist in all trees, but subset and update only the specified
#' trees
#' rf <- c(3:4)
#' sxx <- subsetByLeaf(x = x, rowLeaf = rf, whichRowTree = "phylo")
#' rowLinks(sxx)
NULL

#' test all elements in a list are equal
#' @keywords internal
#' @examples 
#' \dontrun{
#' l1 <- list(a = 1, b = 2, c = 3)
#' l2 <- list(a = 1, b = 1, c = 1)
#' .all_equal_in_list(l1)
#' .all_equal_in_list(l2)
#' }
.all_equal_in_list <- function(x) {
    ux <- unique(x)
    length(ux) == 1
}

#' all elements in the list are NULL
#' @keywords internal
.all_null_in_list <- function(x) {
    xl <- lapply(x, is.null)
    all(unlist(xl))
}

#' all elements in the list are NULL
#' @keywords internal
.all_nonnull_in_list <- function(x) {
    xl <- lapply(x, is.null)
    xl <- lapply(xl, `!`)
    all(unlist(xl))
}

#' name y with x
#' @keywords internal
#' @examples 
#' \dontrun{
#' x <- letters[1:5]
#' y <- 1:5
#' .name_y_with_x(x, y)
#' }
.name_y_with_x <- function(x, y) {
    names(y) <- x
    return(y)
}


#' update the 'whichTree' column in row/column link data
#' @importFrom stats setNames
#' @keywords internal
#' @examples 
#' \dontrun{
#' (ld <- LinkDataFrame(nodeLab = letters[1:5],
#'                      nodeLab_alias = LETTERS[1:5],
#'                      nodeNum = 1:5,
#'                      isLeaf = TRUE,
#'                      whichTree = LETTERS[1:5],
#'                      right = 1:5))
#' newWhich <- setNames(letters[1:5], LETTERS[1:5])
#' .update_whichTree(ld, y = newWhich)
#' }
.update_whichTree <- function(x, y){
    if (is.null(x)) {
        return(x)
    }
    xx <- DataFrame(x)
    ny <- setNames(y[xx$whichTree], NULL)
    xx$whichTree <- ny
    as(xx, "LinkDataFrame")
}

#' Any element in the list is NULL
#' @keywords internal
.any_null_in_list <- function(x) {
    xl <- lapply(x, is.null)
    any(unlist(xl), na.rm = TRUE)
}


# drop tree & link data
.drop_link <- function(args, drop.colLinks, drop.rowLinks){
    # Decide whether to drop tree & link in the column dimension
    if (drop.colLinks) {
        args <- lapply(args, function(x){
            x@colTree <- NULL
            x@colLinks <- NULL
            return(x)
        })
    }
    
    # Decide whether to drop tree & link in the row dimension
    if (drop.rowLinks) {
        args <- lapply(args, function(x){
            x@rowTree <- NULL
            x@rowLinks <- NULL
            return(x)
        })
    }
    return(args)
}

#' The links & trees in the specified dim are consistent
#' @keywords internal
.is_equal_link <- function(args, dim = "row") {
    if (dim == "col") {
        link <- lapply(args, colLinks)
        tree <- lapply(args, FUN = function(x) {
            xx <- colTree(x, whichTree = NULL)})
    } else {
        link <- lapply(args, rowLinks)
        tree <- lapply(args, FUN = function(x) {
            rowTree(x, whichTree = NULL)})
    }
    
    # a list of phylo
    tree <- unlist(tree, recursive = FALSE)
    
    # all tse in args have the same tree & link in (col/row) dim
    eqL <- .all_equal_in_list(link)
    eqT <- .all_equal_in_list(tree) | is.null(tree)
    isEq <- eqT & eqL
    
    return(isEq)
}


#' rename a list automatically to avoid duplicated names
#' @keywords internal
.auto_rename_list <- function(x) {
    if (is.null(x)) { return(x)}
    names(x) <- make.names(names(x), unique = TRUE, allow_ = TRUE)
    return(x)
}



#' match a phylo to a list of phylo
#' @keywords internal
.match_phylo <- function(phy, phys) {
    ll <- lapply(phys, identical, y = phy)
    ind <- which(unlist(ll))[1]
    return(ind)
}

#' match a list of phylo (x.phys) against to a list of phylo (y.phys)
#' @keywords internal
.match_phylo_list <- function(x.phys, y.phys) {
    ll <- lapply(x.phys, .match_phylo, phys = y.phys)
    ul <- unlist(ll)
    names(ul) <- names(x.phys)
    return(ul)
}


.update_link_tree <- function(link_list, tree_list) {
    
    # new tree_list: unnest & remove duplicated trees & rename tree
    names(tree_list) <- NULL
    ntL <- unlist(tree_list, recursive = FALSE)
    oname <- names(ntL)
    ntL <- ntL[!duplicated(ntL)]
    ntL <- .auto_rename_list(x = ntL)
    
    # pair names of old & new tree_list
    ind <- lapply(tree_list, .match_phylo_list, y.phys = ntL)
    pair <- lapply(ind, FUN = function(x) {
        setNames(names(ntL)[x], names(x))
    })
    
    # update whichTree in the link data corresponding to ntL
    nlL <- mapply(.update_whichTree, link_list, pair)
    
    # new link data and list of trees
    out <- list(new_links = nlL, new_tree = ntL)
    return(out)
}

#' bind links & trees when combine TSE
#' @keywords internal
.bind_link_tree <- function(x, args, 
                            drop.rowLinks, drop.colLinks,
                            bind = "cbind") {
    
    if (bind == "rbind") { dim <- "row" } else { dim <- "col"}
    
    # Decide whether to drop tree & link
    args <- .drop_link(args = args,
                       drop.colLinks = drop.colLinks,
                       drop.rowLinks = drop.rowLinks)
    
    # old trees & links
    if (dim == "row") {
        orL <- lapply(args, rowLinks)
        otL <- lapply(args, rowTree, whichTree = NULL)
    } else {
        orL <- lapply(args, colLinks)
        otL <- lapply(args, colTree, whichTree = NULL)
    }
    
    # new trees & links (duplicated trees are removed)
    if (.all_null_in_list(otL)) {
        nT <- nL <- NULL
    } else {
        out <- .update_link_tree(link_list = orL, tree_list = otL)
        nL <- do.call(rbind, out$new_links)
        nT <- out$new_tree
    }
    
    # update slots
    if (bind == "rbind") {
        BiocGenerics:::replaceSlots(x,
                                    rowLinks = nL,
                                    rowTree = nT)
    } else {
        BiocGenerics:::replaceSlots(x,
                                    colLinks = nL,
                                    colTree = nT)
    }
    
}


#' test all TSEs have DNAStringSet in the referenceSeq slot
#' @keywords internal
.all_have_DNAStringSet <- function(args){
    refSeq <- lapply(args, FUN = function(x) {
        is(x@referenceSeq, "DNAStringSet")
    })
    all(unlist(refSeq))
}

#' test all TSEs have DNAStringSetList in the referenceSeq slot
#' @keywords internal
.all_have_DNAStringSetList <- function(args){
    refSeq <- lapply(args, FUN = function(x) {
        is(x@referenceSeq, "DNAStringSetList")
    })
    all(unlist(refSeq))
}

#' rbind referenceSeq
#' @keywords internal
#' @importFrom methods is
.rbind_refSeq <- function(args) {
    
    # all TSEs have NULL in the referenceSeq slot
    seqList <-  lapply(args, FUN = function(x) {x@referenceSeq})
    isNull <- .all_null_in_list(seqList)
    if (isNull) {return(NULL)}
    
    isDNA <- .all_have_DNAStringSet(args)
    isDNAList <- .all_have_DNAStringSetList(args)
    
    # To run rbind successfually, in the referenceSeq slot:
    #   1) all TSEs have DNAStringSet 
    #   2) all TSEs have DNAStringSetList
    #   3) all TSEs have NULL
    isV <- isNull | isDNA | isDNAList 
    
    if (!isV) {
        stop("all TSEs should have the same class in the referenceSeq slot",
             "NULL/DNAStringSet/DNAStringSetList ")
    }
    
    if (isDNA) {
        out <- do.call(c, seqList)
        return(out)
    } 
    
    if (isDNAList) {
        out <- do.call(pc, seqList)
        return(out)
    }
}

#' convert char. indicator to num. indicator
#' 
#' This differs to \code{match} with that the duplicated values in dy are not
#' ignored.
#' 
#' @param x A vector. The values to be matched.
#' @param dy A vector. The values to be matched agaist. 
#' 
#' @keywords internal
#' @author Ruizhu Huang
.match_x_dupY <- function(x, dy) {
    ul <- lapply(x, FUN = function(x) { which(dy %in% x)})
    unlist(ul)
}

#' convert char. indicator to num. indicator
#' 
#' @param ij A character or numeric indicator on rows/columns of \code{x}
#' @param x It provides row/col names for \code{ij} to be matched against.
#' @param dim "row" or "col" to specify row/col names of \code{x} to be matched
#'   against.
#' @keywords internal
#' @importFrom S4Vectors head
#' @author Ruizhu Huang
.numeric_ij <- function(ij, x, dim = "row") {
    # row/col names
    if (dim == "row") {
        char_name <- rownames(x)
    } else {
        char_name <- colnames(x)
    }
    
    if(!is.character(ij)) {return(ij)}
    
    # convert to numeric indicator
    isA <- all(ij %in% char_name)
    dff <- setdiff(ij, char_name)
    if (!isA) {
        stop(length(dff), " specified ", dim, "s can't be found.",
             call. = FALSE)
    }
    len <- sum(char_name %in% ij, na.rm = TRUE)
    ij <- match(ij, char_name)
    
    if (len > length(ij)) {
        warning("For rows/cols with the same name, only one is output")
    }
    return(ij)
}

#' replace row/col links & trees 
#' @param x A TSE with \code{ij} rows/cols to be replaced by \code{value}
#' @param value A TSE to replace some rows/cols of \code{x}.
#' @param ij A character or numeric vector to specify which rows/cols to be replaced.
#' @param dim "row" or "col" to specify the dimension is in rows or columns
#' @keywords internal
#' @author Ruizhu Huang
#' 
.replace_link_tree_1d <- function(x, value, ij, dim = "row") {
    if (missing(ij)) {
        return(NULL)
    }
    
    # multiple rows in assays might have the same name
    ij <- .numeric_ij(ij = ij, x = x, dim = dim)
    
    tseL <- list(x = x, value = value)
    if (dim == "row") {
        olL <- lapply(tseL, rowLinks)
        otL <- lapply(tseL, rowTree, whichTree = NULL)
        other <- "col"
        msg1 <- " 'rowTree()'"
        msg2 <- " 'colLinks()'"
    } else {
        olL <- lapply(tseL, colLinks)
        otL <- lapply(tseL, colTree, whichTree = NULL)
        other <- "row"
        msg1 <- " 'colTree()'"
        msg2 <- " 'rowLinks()'"
    }
    
    
    # check both w/wo tree(s) in dim
    if (!.all_null_in_list(olL) &
        !.all_nonnull_in_list(olL)) {
        stop("x' and 'value' should have the same types of", msg1,
             call. = FALSE)
    }
    # check both agrees on tree & links in the other dim
    fail_cl <- !.is_equal_link(args = tseL, dim = other)
    if (fail_cl) {
        stop("x' and 'value' differ in", msg2, call. = FALSE)
    }
    
    if (.all_nonnull_in_list(olL)) {
        # update links & trees in 'dim'
        out <- .update_link_tree(link_list = olL, 
                                 tree_list = otL)
        nlL <- out$new_links[["x"]]
        nlL[ij, ] <- out$new_links[["value"]]
        ntL <- out$new_tree[unique(nlL$whichTree)]
    } else {
        nlL <- ntL <- NULL
    }
    
    out <- list(new_links = nlL, new_tree = ntL)
    return(out)
}



.replace_link_tree_2d <- function(x, value, i, j) {
    i <- .numeric_ij(ij = i, x = x, dim = "row")
    j <- .numeric_ij(ij = j, x = x, dim = "col")
    
    tseL <- list(x = x, value = value)
    orlL <- lapply(tseL, rowLinks)
    ortL <- lapply(tseL, rowTree, whichTree = NULL)
    oclL <- lapply(tseL, colLinks)
    octL <- lapply(tseL, colTree, whichTree = NULL)
    
    
    
    # check both w/wo tree(s) in the rowLinks
    if (!.all_null_in_list(orlL) &
        !.all_nonnull_in_list(orlL)) {
        stop("x' and 'value' should have the same types of 'rowLinks()'",
             call. = FALSE)
    }
    # check both w/wo tree(s) in the colLinks
    if (!.all_null_in_list(oclL) &
        !.all_nonnull_in_list(oclL)) {
        stop("x' and 'value' should have the same types of 'colLinks()'",
             call. = FALSE)
    }
    
    # update the row link & tree
    if (.all_nonnull_in_list(orlL)) {
        # update links & trees in 'dim'
        res <- .update_link_tree(link_list = orlL, 
                                 tree_list = ortL)
        nrlL <- res$new_links[["x"]]
        nrlL[i, ] <- res$new_links[["value"]]
        nrtL <- res$new_tree[unique(nrlL$whichTree)]
    } else {
        nrlL <- nrtL <- NULL
    }
    
    
    # update the column link & tree
    if (.all_nonnull_in_list(oclL)) {
        # update links & trees in 'dim'
        res <- .update_link_tree(link_list = oclL, 
                                 tree_list = octL)
        nclL <- res$new_links[["x"]]
        nclL[j, ] <- res$new_links[["value"]]
        nctL <- res$new_tree[unique(nclL$whichTree)]
    } else {
        nclL <- nctL <- NULL
    }
    
    outR <- list(new_links = nrlL, new_tree = nrtL)
    outC <- list(new_links = nclL, new_tree = nctL)
    out <- list(outR = outR, outC = outC)
    return(out)
}

# specify which tree to be replaced In '[' replacement, i or/and j are
# specified. For example, a set of rows ('S') are mapped to a row tree ('T') .
# When 'i' is a subset of 'S', the tree ('T') can't be really removed or replace
# because there are other rows mapped to it. That is why we don't use
# .replace_link_tree_1d for the setters of rowTree/colTree

.replace_tree <- function(x, value, whichTree, 
                          nodeLab = NULL, dim = "row") {
    # Node labels of 'value'
    lab <- c(value$tip.label, value$node.label)
    empty <- c(NA, " ", "", "NA", "na")
    
    # the list of trees
    if (dim == "row") {
        tr <- rowTree(x, whichTree = NULL)
        lk <- rowLinks(x)
        nam <- rownames(x)
    } else {
        tr <- colTree(x, whichTree = NULL)
        lk <- colLinks(x)
        nam <- colnames(x)
    }
    
    # trees to be replaced
    if (!is.null(whichTree)) {
        trRep <- tr[whichTree]  
    } else {trRep <- tr}
    namRep <- names(trRep)
    
    # 'value' takes the place of the first replaced tree
    # the new list of the tree
    if (is.null(namRep[[1]])) {
        if (!is.null(tr)) {
            stop("TSE doesn't support a row/col to be mapped to multiple trees",
                 call. = FALSE)
        }
        tr <- c(tr, list("phylo" = value))
        names(tr) <- make.names(names(tr), unique = TRUE)
    } else {
        tr[[namRep[1]]] <- value
    }
    
    ntr <- tr[!names(tr) %in% namRep[-1]]
    
    # ---------------------------------------------------------------
    # update the link data
    # ---------------------------------------------------------------
    # indicate rows links to the tree to be replaced
    ii <- which(lk$whichTree %in% namRep)
    if (is.null(lk)) {
        if (dim == "row") {
            ii <- seq_len(nrow(x)) 
        } else {
            ii <- seq_len(ncol(x)) 
        }
    }
        
    if (is.null(nodeLab)) {
        olab <- nam[ii]   
    } else {olab <- nodeLab}
    
    
    # indicate rows to be dropped
    iDrop <- ii[!olab %in% lab]
    iRep <- ii[olab %in% lab]
    
    # rows has empty labels and mismatch with nodes of 'value
    mis <- olab %in% empty | !olab %in% lab
    if (sum(mis) == length(olab)) {
        stop(dim, "names of 'x' mismatch with node labels of the tree \n",
             " Try 'changeTree' with 'rowNodeLab' provided.",
             call. = FALSE)
    }
    
    if (length(iDrop)) {
        warning(length(iDrop), " ", dim, 
                "(s) are dropped due to mismatch with nodes of 'value'")
    }
    
    # update columns in the link data:
    nlk <- DataFrame(lk)
    if (!nrow(nlk)) {
        nlk <- DataFrame(
            nodeLab = olab[olab %in% lab],
            nodeNum = convertNode(tree = value, node = olab[olab %in% lab]))
        nlk$nodeLab_alias <- convertNode(tree = value, node = nlk$nodeNum, 
                                         use.alias = TRUE)
        nlk$isLeaf <- isLeaf(tree = value, node = nlk$nodeNum)
        nlk$whichTree <- names(ntr)
    } else {
        nlk$nodeLab[iRep] <- olab[olab %in% lab]
        nlk$nodeNum[iRep] <- convertNode(tree = value, node = nlk$nodeLab[iRep])
        nlk$nodeLab_alias[iRep] <- convertNode(tree = value, 
                                               node = nlk$nodeNum[iRep], 
                                               use.alias = TRUE)
        nlk$isLeaf[iRep] <- isLeaf(tree = value, 
                                   node = nlk$nodeNum[iRep])
        nlk$whichTree[iRep] <- namRep[1]
        if (length(iDrop)) {nlk <- nlk[-iDrop, ]}
    }
    
    
    # drop rows
    nlk <- as(nlk, "LinkDataFrame")
    
    out <- list(new_links = nlk, new_tree = ntr, drop = iDrop)
    
    return(out)
    
}

# This is to update old TSE objects saved using version older than 1.6.3.
# check whether the rowLinks/colLinks has the 'whichTree' column.
.lack_whichTree <- function(object, slot) {
    if (slot == "rowLinks") {lk <- rowLinks(object)}
    if (slot == "colLinks") {lk <- colLinks(object)}
    if (is.null(lk)) {return(FALSE)}
    is.null(lk$whichTree)
}

#' update dimLinks and dimTree (used in subsetByLeaf)
#' @keywords internal
#' @author Ruizhu Huang
.subset_leaf <- function(x, leaf, dim = "row", updateTree = TRUE) {
    if (dim == "row") {
        dimTree <- rowTree(x, whichTree = NULL)
        dimLink <- rowLinks(x)
    } else {
        dimTree <- colTree(x, whichTree = NULL)
        dimLink <- colLinks(x)
    }
    if (!missing(leaf)) {
        df <- lapply(seq_along(dimTree), FUN = function(ii) {
            ti <- dimTree[[ii]]
            nti <- names(dimTree)[ii]
            out <- NULL
            if (!is.numeric(leaf)) {
                lab <- intersect(leaf, c(ti$tip.label, ti$node.label))
                nd <- convertNode(tree = ti, node = lab)
            } else {
                nd <- intersect(leaf, unique(as.vector(ti$edge)))
            }
            if (length(nd)) {
                out <- data.frame(node = nd, whichTree = nti) 
            } 
            
            return(out)
        })
        df <- do.call(rbind, df)
    }
    
    ind <- which(dimLink$nodeNum %in% df$node & dimLink$whichTree %in% df$whichTree)
    if (dim == "row") { 
        x <- x[ind, ] 
        dimLink <- rowLinks(x)
        dimTree <- rowTree(x, whichTree = NULL)
    } else { 
        x <- x[, ind] 
        dimLink <- colLinks(x)
        dimTree <- colTree(x, whichTree = NULL)
    }
    
    if (!updateTree) {
        return(x)
    }
    ## update dimTree
    nam <- names(dimTree)
    new_dimTree <- lapply(nam, FUN = function(tt){
        node <- dimLink$nodeNum[dimLink$whichTree == tt]
        keep.tip(phy = dimTree[[tt]], tip = node)
    })
    names(new_dimTree) <- nam
    for (i in nam) {
        ti <- new_dimTree[[i]]
        link_i <- dimLink[dimLink[["whichTree"]] == i, "nodeLab"]
        if (dim == "row") {
            x <- changeTree(x = x, rowTree = ti, whichRowTree = i,
                            rowNodeLab = link_i)
        } else {
            x <- changeTree(x = x, colTree = ti, whichColTree = i,
                            colNodeLab = link_i)
        }
    }
    
    return(x)
}

# -----------------------------------------------------------------------------
### Accessors for TreeSummarizedExperiment
# -----------------------------------------------------------------------------

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("rowLinks", function(x)
    standardGeneric("rowLinks")
)


#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("rowLinks", signature("TreeSummarizedExperiment"),
          function(x) {
              x@rowLinks
          })

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("colLinks", function(x)
    standardGeneric("colLinks")
)


#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("colLinks", signature("TreeSummarizedExperiment"),
          function(x) {
              x@colLinks
          })

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("rowTree", function(x, whichTree = 1, value)
    standardGeneric("rowTree")
)

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("rowTree", signature("TreeSummarizedExperiment"),
          function(x, whichTree = 1, value) {
              if (is.null(whichTree)) {return(x@rowTree)}
              xx <- x@rowTree[whichTree]
              if (length(xx) == 1) {
                  xx <- xx[[1]]
              }
              return(xx)
          })

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("rowTree<-", function(x, whichTree = 1, value)
    standardGeneric("rowTree<-")
)
#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("rowTree<-", signature("TreeSummarizedExperiment"),
          function(x, whichTree = 1, value) {
              if (is.null(value)) {
                  out <- BiocGenerics:::replaceSlots(x, 
                                                     rowTree = NULL, 
                                                     rowLinks = NULL)
                  return(out)
              }
              
              # 1) replace specified trees (e.g., whichTree = 1) 
              # 2) replace all trees (whichTree = NULL)
              
              out <- .replace_tree(x = x, value = value,
                                   whichTree = whichTree, 
                                   dim = "row")
              
              # new data
              drop <- out$drop
              if (length(drop)) {x <- x[-drop, ]}
              nlk <- out$new_links
              rownames(nlk) <- rownames(x)
              
              # update the row tree & link
              BiocGenerics:::replaceSlots(x, 
                                          rowTree = out$new_tree, 
                                          rowLinks = out$new_links)
          })




#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("colTree", function(x, whichTree = 1)
    standardGeneric("colTree")
)


#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("colTree", signature("TreeSummarizedExperiment"),
          function(x, whichTree = 1) {
              if (is.null(whichTree)) {return(x@colTree)}
              xx <- x@colTree[whichTree]
              if (length(xx) == 1) {
                  xx <- xx[[1]]
              }
              return(xx)
          })

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("colTree<-", function(x, whichTree = 1, value)
    standardGeneric("colTree<-")
)
#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("colTree<-", signature("TreeSummarizedExperiment"),
          function(x, whichTree = 1, value) {
              
              if (is.null(value)) {
                  out <- BiocGenerics:::replaceSlots(x, 
                                                     colTree = NULL, 
                                                     colLinks = NULL)
                  return(out)
              }
              
              # 1) replace specified trees (e.g., whichTree = 1) 
              # 2) replace all trees (whichTree = NULL)
              
              out <- .replace_tree(x = x, value = value,
                                   whichTree = whichTree, 
                                   dim = "col")
              # new data
              drop <- out$drop
              if (length(drop)) {x <- x[, -drop]}
              nlk <- out$new_links
              rownames(nlk) <- colnames(x)
              
              # update the col tree & link
              BiocGenerics:::replaceSlots(x, 
                                          colTree = out$new_tree, 
                                          colLinks = out$new_links)
          })

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("rowTreeNames", function(x, value)
    standardGeneric("rowTreeNames")
)

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("rowTreeNames", signature("TreeSummarizedExperiment"),
          function(x, value) {
              rT <- rowTree(x, whichTree = NULL)
              names(rT)
          })

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("rowTreeNames<-", signature = c("x"),
           function(x, value) standardGeneric("rowTreeNames<-"))

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("rowTreeNames<-", signature("TreeSummarizedExperiment"),
          function(x, value) {
              # the row tree
              rT <- rowTree(x, whichTree = NULL)
              namePair <- setNames(value, names(rT))
              names(rT) <- value
              
              # the row link
              rL <- rowLinks(x)
              
              
              # update the column whichTree in the rowLinks
              nrL <- .update_whichTree(rL, namePair)
              
              # update the row tree & link
              BiocGenerics:::replaceSlots(x, rowTree = rT, rowLinks = nrL)
          })



#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("colTreeNames", function(x, value)
    standardGeneric("colTreeNames")
)

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("colTreeNames", signature("TreeSummarizedExperiment"),
          function(x, value) {
              cT <- colTree(x, whichTree = NULL)
              names(cT)
          })

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("colTreeNames<-", 
           function(x, value) standardGeneric("colTreeNames<-"))

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("colTreeNames<-", signature("TreeSummarizedExperiment"),
          function(x, value) {
              # the column tree
              cT <- colTree(x, whichTree = NULL)
              namePair <- setNames(value, names(cT))
              names(cT) <- value
              
              # the column link
              cL <- colLinks(x)
              
              
              # update the column whichTree in the colLinks
              ncL <- .update_whichTree(cL, namePair)
              
              # update the row tree & link
              BiocGenerics:::replaceSlots(x, colTree = cT, colLinks = ncL)
          })



#' @importFrom methods callNextMethod
#' @importMethodsFrom SummarizedExperiment rbind
#' @rdname TreeSummarizedExperiment-combine
#' @export
setMethod("rbind", signature = "TreeSummarizedExperiment",
          function(..., deparse.level = 1){
              
              old <- S4Vectors:::disableValidity()
              if (!isTRUE(old)) {
                  S4Vectors:::disableValidity(TRUE)
                  on.exit(S4Vectors:::disableValidity(old))
              }
              
              # For slots inherited from SCE & SE
              nx <- callNextMethod()
              
              # For slots only in TSE:
              # ------------------------------------------------------------
              args <- list(...)
              
              # Column tree & link data should be consistent in TSEs
              drop.colLinks  <- drop.rowLinks  <- FALSE
              isEq <- .is_equal_link(args, dim = "col")
              if (!isEq) {
                  warning("colTree & colLinks differ in the provided TSEs.",
                          "\n colTree & colLinks are dropped after 'rbind'", 
                          call. = FALSE)
                  drop.colLinks <- TRUE
              }
              
              # Row tree & link data should be all NULL or all non-NULL
              tList <- lapply(args, rowTree, whichTree = NULL)
              if (.any_null_in_list(tList) & !.all_null_in_list(tList)) {
                  warning("rowTree should be all NULL or non-NULL in TSEs.",
                          "\n rowTree & rowLinks are dropped after 'rbind'",
                          call. = FALSE)
                  drop.rowLinks <- TRUE
              }
              
              nnx <- .bind_link_tree(x = nx, args = args,
                                     drop.rowLinks = drop.rowLinks,
                                     drop.colLinks = drop.colLinks,
                                     bind = "rbind")
              
              # rbind on the referenceSeq slot
              refSeq <- .rbind_refSeq(args)
              BiocGenerics:::replaceSlots(nnx,
                                          referenceSeq = refSeq,
                                          check = FALSE)
          })

#' @importFrom methods callNextMethod
#' @importMethodsFrom SummarizedExperiment rbind
#' @rdname TreeSummarizedExperiment-combine
#' @export
#'
setMethod("cbind", signature = "TreeSummarizedExperiment",
          function(..., deparse.level = 1){
              
              old <- S4Vectors:::disableValidity()
              if (!isTRUE(old)) {
                  S4Vectors:::disableValidity(TRUE)
                  on.exit(S4Vectors:::disableValidity(old))
              }
              
              # For slots inherited from SCE & SE
              nx <- callNextMethod()
              
              # For slots only in TSE:
              # ------------------------------------------------------------
              args <- list(...)
              
              # Row tree & link data should be consistent in TSEs
              drop.colLinks  <- drop.rowLinks  <- FALSE
              isEq <- .is_equal_link(args, dim = "row")
              if (!isEq) {
                  warning("rowTree & rowLinks differ in the provided TSEs.",
                          "\n rowTree & rowLinks are dropped after 'cbind'")
                  drop.rowLinks <- TRUE
              }
              
              # Row tree & link data should be all NULL or all non-NULL
              tList <- lapply(args, colTree, whichTree = NULL)
              if (.any_null_in_list(tList) & !.all_null_in_list(tList)) {
                  warning("colTree should be all NULL or non-NULL in TSEs.",
                          "\n colTree & colLinks are dropped after 'cbind'")
                  drop.colLinks <- TRUE
              }
              
              .bind_link_tree(x = nx, args = args,
                                 drop.rowLinks = drop.rowLinks,
                                 drop.colLinks = drop.colLinks,
                                 bind = "cbind")
              
              
          })

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("referenceSeq", signature = c("x"),
           function(x) standardGeneric("referenceSeq"))

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("referenceSeq", signature = c(x = "TreeSummarizedExperiment"),
    function(x){
        seq <- x@referenceSeq
        if(!is.null(seq)){
            if(is(seq,"DNAStringSetList")){
                seq_u <- unlist(seq)
                names(seq_u) <- unlist(rep(rownames(x),length(seq)))
                seq <- relist(seq_u,seq)
            } else {
                names(seq) <- rownames(x)
            }
        }
        seq
    }
)

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("referenceSeq<-", signature = c("x"),
           function(x, value) standardGeneric("referenceSeq<-"))

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setReplaceMethod("referenceSeq", signature = c(x = "TreeSummarizedExperiment"),
    function(x, value){
        x <- updateObject(x)
        if(is.null(value)){
            value <- value
        } else if(!is(value,"DNAStringSet") &&
               !is.list(value) &&
               !is(value,"DNAStringSetList")){
            value <- as(value,"DNAStringSet")
        } else if(!is(value,"DNAStringSetList") &&
               is.list(value)){
            value <- DNAStringSetList(value)
        }
        x <- .set_referenceSeq(x, value)
        validObject(x)
        x
    }
)

#' @importFrom IRanges relist
.set_referenceSeq <- function(x, value){
    if(is(value,"DNAStringSetList")){
        value <- relist(unname(unlist(value)),value)
    } else {
        value <- unname(value)
    }
    x@referenceSeq <- value
    x
}


#' @importFrom methods callNextMethod
#' @import SingleCellExperiment
#' @importFrom S4Vectors metadata
#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("[", signature(x = "TreeSummarizedExperiment"),
          function(x, i, j, ..., drop = TRUE){
              x <- updateObject(x)
              
              # Subset rowLinks & rowTree & referenceSeq
              nlr <- lr <- rowLinks(x)
              nrt <- rt <- rowTree(x, whichTree = NULL)
              refSeq <- referenceSeq(x)
              
              if (!missing(i)) {
                  i <- .numeric_ij(ij = i, x = x, dim = "row")
                  
                  if(!length(i) | !sum(i)) {
                      refSeq <- nlr <- nrt <- NULL
                  } else {
                      # referenceSeq
                      if(!is.null(refSeq)){
                          if(is(refSeq,"DNAStringSetList")){
                              if (any(i < 0)) {
                                  abs_i <- abs(i)
                                  li <- lapply(lengths(refSeq), seq_len)
                                  ii <- lapply(li, FUN = function(x) {
                                      !x %in% abs_i
                                  })
                              } else {
                                  ii <- rep(list(i),length(refSeq))  
                              }
                              refSeq <- refSeq[ii]
                          } else {refSeq <- refSeq[i]}
                      }
                      # rowLinks & rowTree
                      if (!is.null(rt)) {
                          nlr <- lr[i, , drop = FALSE]
                          nrt <- rt[unique(nlr$whichTree)]
                      }
                  }
              }
              

              # Subset the colLinks & colTree
              nlc <- lc <- colLinks(x)
              nct <- ct <- colTree(x, whichTree = NULL)
              if (!missing(j)) {
                  j <- .numeric_ij(ij = j, x = x, dim = "col")
                  if(!length(j) | !sum(j)) {
                      nlc <- nct <- NULL
                  } else {
                      if (!is.null(ct)) {
                          nlc <- lc[j, , drop = FALSE]
                          nct <- ct[unique(nlc$whichTree)]
                      }
                  }
              }

              # Subset the traditional slots from SummarizedExperiment
              nx <- callNextMethod()

              # update slots
              final <- BiocGenerics:::replaceSlots(nx,
                                                   rowLinks = nlr,
                                                   colLinks = nlc,
                                                   rowTree = nrt,
                                                   colTree = nct,
                                                   referenceSeq = refSeq)
              validObject(final)
              return(final)
          }
)

#' @importFrom methods callNextMethod
#' @import SingleCellExperiment
#' @importFrom S4Vectors metadata
#' @rdname TreeSummarizedExperiment-accessor
#' @export
setReplaceMethod("[",
                 signature(x = "TreeSummarizedExperiment", "ANY", "ANY", 
                           "TreeSummarizedExperiment"),
                 function(x, i, j, ..., value){
                     x <- updateObject(x)
                     value <- updateObject(value)
                     if (missing(i) && missing(j)) {
                         # do callNextMethod because of objects potentially being updated
                         return(callNextMethod())
                     }
                     
                     # TODO rowLinks and rowTree
                     # TODO colLinks
                     if ((sum(missing(i), missing(j)) == 1)) {
                         outR <- .replace_link_tree_1d(x = x, value = value, ij = i,
                                                       dim = "row")
                         outC <- .replace_link_tree_1d(x = x, value = value,
                                                       ij = j, dim = "col")
                     } else {
                         out <- .replace_link_tree_2d(x = x, value = value, 
                                                      i = i, j = j)
                         outR <- out$outR
                         outC <- out$outC
                     }
                     
                     
                     x_refSeq <- referenceSeq(x)
                     if (!missing(i)) {
                         value_refSeq <- referenceSeq(value)
                         if((!is.null(x_refSeq) & is.null(value_refSeq)) ||
                            is.null(x_refSeq) & !is.null(value_refSeq) ||
                            !is(x_refSeq, class(value_refSeq))){
                             stop("'x' and 'value' must have the same type of ",
                                  "referenceSeq()", call. = FALSE)
                         }
                         if(!is.null(x_refSeq)){
                             if(is(x_refSeq,"DNAStringSetList")){
                                 if(length(referenceSeq(value)) != length(x_refSeq)){
                                     stop("DNAStringSetList as 'referenceSeq' must have ",
                                          "the same length to be merged.", call. = FALSE)
                                 }
                                 if (any(i < 0)) {
                                     abs_i <- abs(i)
                                     li <- lapply(lengths(x_refSeq), seq_len)
                                     ii <- lapply(li, FUN = function(x) {
                                         !x %in% abs_i
                                     })
                                 } else {
                                     ii <- rep(list(i),length(x_refSeq))  
                                 }
                                 x_refSeq[ii] <- value_refSeq
                             } else {
                                 x_refSeq[i] <- value_refSeq
                             }
                         }
                     }
                     
                     x <- callNextMethod()
                     x <- BiocGenerics:::replaceSlots(x,
                                                      referenceSeq = x_refSeq,
                                                      check = FALSE)
                     if (!is.null(outR)) {
                         nl <- outR$new_links
                         rownames(nl) <- rownames(x)
                         x <- BiocGenerics:::replaceSlots(x,
                                                          rowTree = outR$new_tree,
                                                          rowLinks = nl,
                                                          check = FALSE)
                     }
                     
                     if (!is.null(outC)) {
                         nl <- outC$new_links
                         rownames(nl) <- colnames(x)
                         x <- BiocGenerics:::replaceSlots(x,
                                                          colTree = outC$new_tree,
                                                          colLinks = nl,
                                                          check = FALSE)
                     }
                     validObject(x)
                     x
                 }
)



#' @importFrom methods callNextMethod
#' @rdname TreeSummarizedExperiment-accessor
#' @export
setReplaceMethod("rownames", signature(x = "TreeSummarizedExperiment"),
                 function(x, value){
                     x <- updateObject(x)
                     x <- callNextMethod()
                     if(!is.null(x@rowLinks)){
                         rownames(x@rowLinks) <- value
                     }
                     x
                 }
)

#' @importFrom methods callNextMethod
#' @rdname TreeSummarizedExperiment-accessor
#' @export
setReplaceMethod("colnames", signature(x = "TreeSummarizedExperiment"),
                 function(x, value){
                     x <- updateObject(x)
                     x <- callNextMethod()
                     if(!is.null(x@colLinks)){
                         rownames(x@colLinks) <- value
                     }
                     x
                 }
)

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("subsetByLeaf", 
           function(x, rowLeaf, colLeaf, whichRowTree, whichColTree,
                    updateTree = TRUE)
    standardGeneric("subsetByLeaf")
)

#' @rdname TreeSummarizedExperiment-accessor
#' @importFrom ape keep.tip
#' @export
setMethod("subsetByLeaf", signature(x = "TreeSummarizedExperiment"),
          function(x, rowLeaf, colLeaf, whichRowTree, whichColTree, 
                   updateTree = TRUE){
              x <- updateObject(x)
              # row link
              rl <- rowLinks(x)
              rt <- rowTree(x, whichTree = NULL)
              if (!missing(whichRowTree)) {
                  rt <- rt[whichRowTree]
                  rnam <- names(rt)
                  x <- x[rl$whichTree %in% rnam,]
                  x <- BiocGenerics:::replaceSlots(object = x, 
                                                   rowTree = rt)
                  rl <- rowLinks(x)
              }
              
              if (!missing(whichRowTree) |
                  !missing(rowLeaf)) {
                  if (!length(rt)) {
                      warning("The row tree is not available.", 
                              call. = FALSE)}
              }
              ## keep rows corresponding to the specified rowLeaf
              if (!missing(rowLeaf)) {
              x <- .subset_leaf(x = x, leaf = rowLeaf, dim = "row", 
                                updateTree = updateTree)
              }
              
              
              # column link
              cl <- colLinks(x)
              ct <- colTree(x, whichTree = NULL)
              if (!missing(whichColTree)) {
                  ct <- ct[whichColTree]
                  cnam <- names(ct)
                  x <- x[, cl$whichTree %in% cnam]
                  x <- BiocGenerics:::replaceSlots(object = x, 
                                                   colTree = ct)
                  cl <- colLinks(x)
              }
              
              if (!missing(whichColTree) |
                  !missing(colLeaf)) {
                  if (!length(ct)) {
                      warning("The column tree is not available.", 
                              call. = FALSE)}
              }
              
              ## keep cols corresponding to the specified colLeaf
              if (!missing(colLeaf)) {
                  x <- .subset_leaf(x = x, leaf = colLeaf, dim = "col", 
                                    updateTree = updateTree)
              }
              return(x)
          }
)

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setGeneric("subsetByNode", function(x, rowNode, colNode,
                                    whichRowTree, whichColTree)
    standardGeneric("subsetByNode")
)

#' @rdname TreeSummarizedExperiment-accessor
#' @export
setMethod("subsetByNode", signature(x = "TreeSummarizedExperiment"),
          function(x, rowNode, colNode, whichRowTree, whichColTree){
              x <- updateObject(x)
              # row link
              rl <- rowLinks(x)
              rt <- rowTree(x, whichTree = NULL)
              if (!missing(whichRowTree)) {
                  rt <- rt[whichRowTree]
                  rnam <- names(rt)
                  x <- x[rl$whichTree %in% rnam,]
                  x <- BiocGenerics:::replaceSlots(object = x, 
                                                   rowTree = rt)
                  rl <- rowLinks(x)
              }
              
              if (!missing(whichRowTree) |
                  !missing(rowNode)) {
                  if (!length(rt)) {
                      warning("The row tree is not available.", 
                              call. = FALSE)}
              }
              
              # if (!missing(rowNode)) {
              #     if (!is.numeric(rowNode)) {
              #         rowNode <- unlist(lapply(rt, convertNode, node = rowNode))
              #     }
              #     x <- x[which(rl$nodeNum %in% rowNode),]
              # }
              if (!missing(rowNode)) {
                  x <- .subset_leaf(x = x, leaf = rowNode, dim = "row", 
                                    updateTree = FALSE)
              }
              
              # column link
              cl <- colLinks(x)
              ct <- colTree(x, whichTree = NULL)
              if (!missing(whichColTree)) {
                  ct <- ct[whichColTree]
                  cnam <- names(ct)
                  x <- x[, cl$whichTree %in% cnam]
                  x <- BiocGenerics:::replaceSlots(object = x, 
                                                   colTree = ct)
                  cl <- colLinks(x)
              }
              
              if (!missing(whichColTree) |
                  !missing(colNode)) {
                  if (!length(ct)) {
                      warning("The column tree is not available.", 
                              call. = FALSE)}
              }
              
              # if (!missing(colNode)) {
              #     if (!is.numeric(colNode)) {
              #         colNode <- unlist(lapply(ct, convertNode, node = colNode))
              #     }
              #     x <- x[, which(cl$nodeNum %in% colNode)]
              # }
              
              if (!missing(colNode)) {
                  x <- .subset_leaf(x = x, leaf = colNode, dim = "col", 
                                    updateTree = FALSE)
              }
             return(x)
          }
)

#' @keywords internal
#' @importFrom methods callNextMethod
#' @importMethodsFrom SingleCellExperiment show
setMethod("show", "TreeSummarizedExperiment", function(object) {
    object <- updateObject(object)
    callNextMethod()

    rt <- rowTree(object, whichTree = NULL)
    ct <- colTree(object, whichTree = NULL)



    rlk <- rowLinks(object)
    clk <- colLinks(object)

    # on row
    if (is.null(rt)) {
        msg1a <- "rowLinks: NULL"
        msg1b <- "rowTree: NULL"
    } else {
        msg1a <- sprintf("rowLinks: a LinkDataFrame (%d %s)",
                         nrow(rlk), "rows")


        # the number of leaf nodes & internal nodes
        nlr <- sum(unlist(lapply(rt, countLeaf)))
        msg1b <- sprintf("rowTree: %d %s tree(s) (%d leaves)",
                         length(rt), class(rt[[1]]), nlr)
    }

    # on column
    if (is.null(ct)) {
        msg2a <- "colLinks: NULL"
        msg2b <- "colTree: NULL"
    } else {
        msg2a <- sprintf("colLinks: a LinkDataFrame (%d %s)", nrow(clk), "rows")

        # the number of leaf nodes & internal nodes
        nlc <- sum(unlist(lapply(ct, countLeaf)))
        msg2b <- sprintf("colTree: %d %s tree(s) (%d leaves)",
                         length(ct), class(ct[[1]]), nlc)

    }

    cat(msg1a, "\n", msg1b, "\n",
        msg2a, "\n", msg2b, "\n",
        sep = "")

    referenceSeq <- object@referenceSeq
    if(!is.null(referenceSeq)){
        if(is(referenceSeq,"DNAStringSetList")){
            msg <- sprintf(paste0("referenceSeq: a ", class(referenceSeq),
                                  " (%s x %s sequences each)\n"),
                           length(referenceSeq),
                           unique(lengths(referenceSeq)))
        } else {
            msg <- sprintf(paste0("referenceSeq: a ", class(referenceSeq),
                                  " (%s sequences)\n"),
                           length(referenceSeq))
        }
        cat(msg)
    }
})

#' find the sibling node
#'
#' \code{findSibling} is to find the sibling node of an \code{node} node.
#'
#' @param tree A phylo object.
#' @param node A numeric or character vector. Node labels or node numbers.
#' @param use.alias A logical value, TRUE or FALSE. The default is FALSE, and
#'   the original node label would be used to name the output; otherwise, the
#'   alias of node label would be used to name the output. The alias of node
#'   label is created by adding a prefix \code{"alias_"} to the node number.
#' @export
#' @return A vector of nodes. The numeric value is the node number, and the
#'   vector name is the corresponding node label. If a node has no label, it
#'   would have NA as name when \code{use.alias = FALSE}, and have the alias of
#'   node label as name when \code{use.alias = TRUE}.
#'
#' @examples
#' library(ggtree)
#' data(tinyTree)
#' ggtree(tinyTree, branch.length = 'none') +
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7)
#'
#'
#'  findSibling(tree = tinyTree, node = 17)
#'  findSibling(tree = tinyTree, node = c(13, 17))
findSibling <- function(tree, node, use.alias = FALSE){

    if (is.character(node)) {
        node <- convertNode(tree = tree, node = node, message = FALSE)
    }
    matT <- matTree(tree = tree)

    # find the parent node of the input node
    pN <- findAncestor(tree = tree, node = node, level = 1)

    # find the siblings
    loc1 <- lapply(pN, FUN = function(x) {
        which(matT == x, arr.ind = TRUE)
    })

    loc2 <- lapply(loc1, FUN = function(x) {
        x1 <- x[, "col"]
        x2 <- x1 - 1

        mc <- cbind(row = x[, "row"],
                    col = x2)
    })

    sib <- lapply(seq_along(loc2), FUN = function(x){
        xx <- matT[loc2[[x]]]
        setdiff(xx, node[x])

        })
    out <- unlist(sib)

    names(out) <- convertNode(tree = tree, node = out,
                            use.alias = use.alias,
                            message = FALSE)
    return(out)
}

#' Calculate the distance between any two nodes on the tree
#'
#' \code{distNode} is to calculate the distance between any two nodes on
#' a \code{phylo} tree
#'
#' @param tree A phylo object.
#' @param node A numeric or character vector of length two.
#' @export
#' @return A numeric value.
#'
#' @examples
#' library(ggtree)
#' data(tinyTree)
#' ggtree(tinyTree) +
#'     geom_text2(aes(label = node), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = branch.length), color = "darkblue",
#'                vjust = 0.7)
#'
#'
#' distNode(tree = tinyTree, node = c(10, 11))
#' distNode(tree = tinyTree, node = c(12, 13))
#' distNode(tree = tinyTree, node = c(13, 15))
#' distNode(tree = tinyTree, node = c(12, 14))

distNode <- function(tree, node) {
    
    if (!inherits(tree, "phylo")) {
        stop("tree: should be a phylo object.", call. = FALSE)
    }
    
    if (is.character(node)) {
        node <- convertNode(tree = tree, node = node)
    }

    mat <- matTree(tree)
    ed <- tree$edge

    oo <- lapply(node, FUN = function(x) {
        xx <- which(mat == x, arr.ind = TRUE)
        return(xx)
    })

    samePath <- intersect(oo[[1]][, "row"], oo[[2]][, "row"])
    if (length(samePath)) {
        dd <- .samePath(tree = tree, node = node)
    } else {
        dd <- .diffPath(tree = tree, node = node)
    }

    return(dd)

    }

.samePath <- function(tree, node) {
    # edges
    ed <- tree$edge

    # edge.length
    len <- tree$edge.length

    # the input nodes are not directly connected but in the same path
    mt <- matTree(tree = tree)
    loc <- lapply(node, FUN = function(x) {
        xx <- which(mt == x, arr.ind = TRUE)
    })

    shareRow <- intersect(loc[[1]][, "row"], loc[[2]][, "row"])
    ush <- unique(shareRow)[1]

    loc <- do.call(rbind, loc)
    tcol <- loc[loc[, "row"] == ush, "col"]
    sel <- seq(from = max(tcol), to = min(tcol), by = -1)
    pn <- mt[ush, sel[-length(sel)]]
    cn <- mt[ush, sel[-1]]
    pir <- cbind(pn, cn)
    fi <- match(data.frame(t(pir)), data.frame(t(ed)))
    dd <- sum(len[fi])

    return(dd)
}

.diffPath <- function(tree, node) {
    # the share node
    sNode <- shareNode(tree = tree, node = node)


    d1 <- .samePath(tree = tree, node = c(node[1], sNode))
    d2 <- .samePath(tree = tree, node = c(node[2], sNode))
    dd <- d1 + d2

    return(dd)
}

#' Find the children
#'
#' \code{findChild} finds children of an internal node.
#'
#' @param node An internal node. It could be the node number or the node
#'   label.
#' @param tree A phylo object.
#' @param use.alias A logical value, TRUE or FALSE. The default is FALSE, and
#'   the node label would be used to name the output; otherwise, the alias of
#'   node label would be used to name the output. The alias of node label is
#'   created by adding a prefix \code{"alias_"} to the node number.
#' @export
#' @return A vector of nodes. The numeric value is the node number, and the
#'   vector name is the corresponding node label. If a node has no label, it
#'   would have NA as name when \code{use.alias = FALSE}, and have the alias of
#'   node label as name when \code{use.alias = TRUE}.
#' @author Ruizhu Huang
#'
#' @examples
#' data(tinyTree)
#'
#' library(ggtree)
#' ggtree(tinyTree) +
#' geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7) +
#' geom_hilight(node = 17, fill = 'steelblue', alpha = 0.5) +
#' geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7)
#'
#' (tips <- findChild(tree = tinyTree, node = 17))
#' 



findChild <- function(tree, node = 11, use.alias = FALSE) {
    
    if (!is(tree, "phylo")) {
        stop("tree requires a phylo object.", call. = FALSE)
    }
    
    if (is.factor(node)) {
        stop("node requires character or numeric.", call. = FALSE)
    }
    
    if (is.character(node)) {
        node <- convertNode(tree = tree, node = node)
    }
    
    mat <- tree$edge
    ind <- which(mat == node, arr.ind = TRUE)
    ind <- ind[ind[,"col"] == 1, , drop = FALSE]
    
    ind[, "col"] <- ind[, "col"] + 1
    child <- mat[ind]
    names(child) <- convertNode(tree = tree, node = child,
                              use.alias = use.alias, message = FALSE)
    return(child)
}

#' change internal nodes to leaf nodes
#'
#' \code{asLeaf} updates a \code{phylo} tree by changing the specified internal
#' nodes to leaf nodes. In other words, the descendant nodes of the specified
#' internal nodes are removed.
#'
#' @param tree A phylo object.
#' @param node A numeric or character vector. It specifies internal nodes that
#'   are changed to leaves via their node labels or numbers.
#' @importFrom methods is
#' @export
#' @return A phylo object.
#'
#' @examples
#' library(ggtree)
#' data(tinyTree)
#' ggtree(tinyTree, ladderize = FALSE) +
#'     geom_text2(aes(label = label), color = "darkorange",
#'            hjust = -0.1, vjust = -0.7) +
#'     geom_text2(aes(label = node), color = "darkblue",
#'                hjust = -0.5, vjust = 0.7) +
#'     geom_hilight(node = 16) +
#'     geom_point2()
#'
#' # remove the blue branch
#' NT1 <- asLeaf(tree = tinyTree, node = 16)
#'
#' ggtree(NT1, ladderize = FALSE) +
#'     geom_text2(aes(label = label), color = "darkorange",
#'                hjust = -0.1, vjust = -0.7) +
#'     geom_point2()
#'
#' # if mergeSingle = TRUE, the node (Node_17) is removed.
#' NT2 <- asLeaf(tree = tinyTree, node = c(15, 13))
#' 
#'
#' ggtree(NT2, ladderize = FALSE) +
#'     geom_text2(aes(label = label), color = "darkorange",
#'                hjust = -0.1, vjust = -0.7) +
#'     geom_point2()
#'
asLeaf <- function(tree, node) {

  # check inputs 
  if (!is(tree, "phylo")) {
    stop("tree should be a phylo object")
  }

  isTip <- isLeaf(tree = tree, node = node)
  if (any(isTip)) {
    stop("Leaf node(s) found:", node[isTip])
  }

  if (!is(node, "numeric") & !is(node, "character")) {
    stop("node should a numeric or character vector")
  }
  # ============remove descendants ============
  # set descendant nodes as NA
  if (is(node, "character")) {
    node <- convertNode(tree = tree, node = node)
  }
  mat <- matTree(tree = tree)

  ind <- lapply(node, FUN = function(x) {
    which(mat == x, arr.ind = TRUE)
  })

  ind <- do.call(rbind, ind)

  rnd <- apply(ind, 1, FUN = function(x) {
    xx <- cbind(row = rep(x["row"], x["col"]-1),
                col = seq_len(x["col"]-1))
    # return data.frame, since matrix can get coerced
    # to vector, if length of results are all equal
    return(data.frame(xx))
  })
  rnd <- do.call(rbind, rnd)
  colnames(rnd) <- NULL
  rownames(rnd) <- NULL
  rnd <- as.matrix(rnd)
  mat[rnd] <- NA

  # move NA to the end for each row
  nat <- apply(mat, 1, FUN = function(x) {
    xx <- x[!is.na(x)]
    c(xx, rep(NA, length(x)-length(xx)))
  })
  nat <- t(nat)

  # remove duplicated rows
  natO <- nat[!duplicated(nat), ,drop=FALSE]

  # update node number
  natN <- natO
  natN[, 1] <- seq_len(nrow(natN))
  uu <- unique(sort(natN))
  od <- cbind(old = uu, new = seq_along(uu)) # the pair (old - new )
  natNN <- apply(natN, 2, FUN = function(x) {
    ind <- match(x, od[, "old"])
    od[ind, "new"]
  })

  # node pair (old - new)
  old <- as.vector(natO)
  new <- as.vector(natNN)
  pair <- cbind(old, new)
  pair <- pair[!duplicated(pair), , drop = FALSE]
  pair <- pair[rowSums(is.na(pair)) != ncol(pair), , drop = FALSE]

  if(nrow(pair) == 1L){
    stop("Selected root node of tree.")
  }
  
  # ==============Update phylo object =============================
  # new edge (edn)
  edo <- lapply(seq_len(nrow(natO)), FUN = function(y) {
    x <- natO[y, ]
    xx <- x[!is.na(x)]
    rx <- rev(xx)
    lx <- length(xx)
    rxx <- cbind(rx[seq_len(lx-1)],
                 rx[setdiff(seq_len(lx), 1)])
    return(rxx)
  })
  edo <- do.call(rbind, edo)
  rownames(edo) <- NULL
  edo <- edo[!duplicated(edo), , drop = FALSE]
  edn <- apply(edo, 2, FUN = function(x) {
    ind <- match(x, pair[, "old"])
    pair[ind, "new"]
  })

  # new edge length
  lenN <- apply(edo, 1, FUN = function(x){
    distNode(tree = tree, node = x)
  })

 # new node labels
  labN <- convertNode(tree = tree, node = pair[, "old"])
  nodeA <- pair[, "new"]
  names(nodeA) <- labN
  nodeA <- sort(nodeA, decreasing = FALSE)

  labTN <- names(nodeA)[nodeA %in% natNN[, 1]]
  labIN <- names(nodeA)[!nodeA %in% natNN[, 1]]


  br <- list(edge = edn, tip.label = labTN,
             edge.length = lenN, Nnode = length(labIN),
             node.label = labIN)
  attr(br, "class") <- attr(tree, "class")
  attr(br, "order") <- attr(tree, "order")

  return(br)


}

#' Combine TSEs by rows or columns
#'
#'  
#' \code{rbind} and \code{cbind} take one or more
#' \code{TreeSummarizedExperiment} objects and combine them by columns or rows,
#' respectively.
#' 
#' @param ... One or more \code{TreeSummarizedExperiment} objects.
#' @param deparse.level See \code{\link[base]{cbind}}
#' @name TreeSummarizedExperiment-combine
#' @return A TreeSummarizedExperiment object
#' 
#' @author Ruizhu Huang
#' @examples 
#' 
#' # rbind works : 
#' # a) TSE without rowTree and without colTree
#' # b) TSE with rowTree but without colTree
#' # c) TSE without rowTree but with colTree
#' # d) TSE with rowTree & colTree
#' 
#' set.seed(1)
#' # a) 
#' (tse_a <- makeTSE(include.colTree = FALSE))
#' (tse_b <- makeTSE(include.colTree = FALSE))
#' 
#' # b) 
#' (tse_c <- makeTSE(include.rowTree = FALSE))
#' (tse_d <- makeTSE(include.rowTree = FALSE))
#' 
#' rbind(tse_a, tse_b)
#' cbind(tse_c, tse_d)

NULL

---
title: "Combine TreeSummarizedExperiment objects"
author: 
- name: Ruizhu HUANG
  affiliation: 
  - Institute of Molecular Life Sciences, University of Zurich.
  - SIB Swiss Institute of Bioinformatics.
- name: Charlotte Soneson
  affiliation: 
  - Institute of Molecular Life Sciences, University of Zurich.
  - SIB Swiss Institute of Bioinformatics.
- name: Mark Robinson
  affiliation: 
  - Institute of Molecular Life Sciences, University of Zurich.
  - SIB Swiss Institute of Bioinformatics.
package: TreeSummarizedExperiment
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{2. Combine TSEs}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
bibliography: TreeSE_vignette.bib
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, message = FALSE, warning = TRUE)
```


# Combine multiple `TreeSummarizedExperiment` objects 

Multiple `TreeSummarizedExperiemnt` objects (**TSE**) can be combined by using
`rbind` or `cbind`. Here, we create a toy `TreeSummarizedExperiment` object
using `makeTSE()` (see `?makeTSE()`). As the tree in the row/column tree slot is
generated randomly using `ape::rtree()`, `set.seed()` is used to create
reproducible results.

```{r}
library(TreeSummarizedExperiment)

set.seed(1)
# TSE: without the column tree
(tse_a <- makeTSE(include.colTree = FALSE))

# combine two TSEs by row
(tse_aa <- rbind(tse_a, tse_a))
```
The generated `tse_aa` has 20 rows, which is two times of that in `tse_a`. The row tree in `tse_aa` is the same as that in `tse_a`.

```{r}
identical(rowTree(tse_aa), rowTree(tse_a))
```

If we `rbind` two TSEs (e.g., `tse_a` and `tse_b`) that have different row trees, the obtained TSE (e.g., `tse_ab`) will have two row trees. 
```{r}
set.seed(2)
tse_b <- makeTSE(include.colTree = FALSE)

# different row trees
identical(rowTree(tse_a), rowTree(tse_b))

# 2 phylo tree(s) in rowTree
(tse_ab <- rbind(tse_a, tse_b))
```

In the row link data, the `whichTree` column gives information about which tree the row is mapped to.
For `tse_aa`, there is only one tree named as `phylo`. However, for `tse_ab`, there are two trees (`phylo` and `phylo.1`).
```{r}
rowLinks(tse_aa)
rowLinks(tse_ab)
```

The name of trees can be accessed using `rowTreeNames`. If the input **TSE**s use the same name for trees, `rbind` will automatically create valid and unique names for trees by using `make.names`. `tse_a` and `tse_b` both use `phylo` as the name of their row trees. In `tse_ab`, the row tree that originates from `tse_b` is named as `phylo.1` instead.
```{r}
rowTreeNames(tse_aa)
rowTreeNames(tse_ab)

# The original tree names in the input TSEs
rowTreeNames(tse_a)
rowTreeNames(tse_b)
```

Once the name of trees is changed, the column `whichTree` in the `rowLinks()` is updated accordingly.
```{r}
rowTreeNames(tse_ab) <- paste0("tree", 1:2)
rowLinks(tse_ab)
```

To run `cbind`, **TSE**s should agree in the row dimension. If **TSE**s only differ in the row tree, the row tree and the row link data are dropped.
```{r}
cbind(tse_a, tse_a)
cbind(tse_a, tse_b)
```


# Subset a **TSE** object

We obtain a subset of `tse_ab` by extracting the data on rows `11:15`. These rows are mapped to the same tree named as `phylo.1`. So, the `rowTree` slot of `sse` has only one tree.
```{r}
(sse <- tse_ab[11:15, ])
rowLinks(sse)
```

`[` works not only as a getter but also a setter to replace a subset of `sse`.
```{r}
set.seed(3)
tse_c <- makeTSE(include.colTree = FALSE)
rowTreeNames(tse_c) <- "new_tree"

# the first two rows are from tse_c, and are mapped to 'new_tree'
sse[1:2, ] <- tse_c[5:6, ]
rowLinks(sse)
```

The **TSE** object can be subset also by nodes or/and trees using `subsetByNodes`
```{r}
# by tree
sse_a <- subsetByNode(x = sse, whichRowTree = "new_tree")
rowLinks(sse_a)

# by node
sse_b <- subsetByNode(x = sse, rowNode = 5)
rowLinks(sse_b)

# by tree and node
sse_c <- subsetByNode(x = sse, rowNode = 5, whichRowTree = "tree2")
rowLinks(sse_c)
```

# Change specific trees of **TSE**

By using `colTree`, we can add a column tree to `sse` that has no column tree before.
```{r}
colTree(sse)

library(ape)
set.seed(1)
col_tree <- rtree(ncol(sse))

# To use 'colTree` as a setter, the input tree should have node labels matching
# with column names of the TSE.
col_tree$tip.label <- colnames(sse)

colTree(sse) <- col_tree
colTree(sse)
```

`sse` has two row trees. We can replace one of them with a new tree by
specifying `whichTree` of the `rowTree`.
```{r}
# the original row links
rowLinks(sse)

# the new row tree
set.seed(1)
row_tree <- rtree(4)
row_tree$tip.label <- paste0("entity", 5:7)

# replace the tree named as the 'new_tree'
nse <- sse
rowTree(nse, whichTree = "new_tree") <- row_tree
rowLinks(nse)
```


In the row links, the first two rows now have new values in `nodeNum` and
`nodeLab_alias`. The name in `whichTree` is not changed but the tree is actually
updated.

```{r}
# FALSE is expected
identical(rowTree(sse, whichTree = "new_tree"),
          rowTree(nse, whichTree = "new_tree"))

# TRUE is expected
identical(rowTree(nse, whichTree = "new_tree"),
          row_tree)
```

If nodes of the input tree and rows of the **TSE** are named differently, users
can match rows with nodes via `changeTree` with `rowNodeLab` provided.


# Session Info

```{r}
sessionInfo()
```

# Reference

---
title: "Introduction to TreeSummarizedExperiment"
author: 
- name: Ruizhu HUANG
  affiliation: 
  - Institute of Molecular Life Sciences, University of Zurich.
  - SIB Swiss Institute of Bioinformatics.
- name: Charlotte Soneson
  affiliation: 
  - Institute of Molecular Life Sciences, University of Zurich.
  - SIB Swiss Institute of Bioinformatics.
- name: Mark Robinson
  affiliation: 
  - Institute of Molecular Life Sciences, University of Zurich.
  - SIB Swiss Institute of Bioinformatics.
package: TreeSummarizedExperiment
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{1. Introduction to TreeSE}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
bibliography: TreeSE_vignette.bib
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, message = FALSE, warning = FALSE)
```


# Introduction 

The `TreeSummarizedExperiment` class is an extension of the
`SingleCellExperiment` class [@LunA2020]. It's used to store rectangular data
of experimental results as in a `SingleCellExperiment`, and also supports the
storage of a hierarchical structure and its link information to the rectangular
data.

# TreeSummarizedExperiment {#tse-class}

## Anatomy of TreeSummarizedExperiment

```{r strTSE, echo=FALSE, fig.width= 12, fig.cap= "The structure of the TreeSummarizedExperiment class."}
knitr::include_graphics("tse2.png")
```
Compared to the `SingleCellExperiment` objects, `TreeSummarizedExperiment` has
five additional slots:
    
* `rowTree`: the hierarchical structure on the rows of the `assays`.
* `rowLinks`: the link information between rows of the `assays` and the `rowTree`.
* `colTree`: the hierarchical structure on the columns of the `assays`.
* `colLinks`: the link information between columns of the `assays` and the
`colTree`.
* `referenceSeq` (optional): the reference sequence data per feature (row). 

The `rowTree` and$/$or `colTree` can be left empty (`NULL`) if no trees are
available; in this case, the `rowLinks` and$/$or `colLinks` are also set to
`NULL`. All other `TreeSummarizedExperiment` slots are inherited from
`SingleCellExperiment`.

The `rowTree` and `colTree` slots require the tree to be an object of the
`phylo` class. If a tree is available in an alternative format, it can often be
converted to a `phylo` object using dedicated R packages (e.g., `r
Biocpkg("treeio")` [@Wang2019]).

The `referenceSeq` slot is optional. It accepts the reference sequence data of
features either as `DNAStringSet` or `DNAStringSetList`. More details are in
\@ref(refSeq).

Functions in the `r Biocpkg("TreeSummarizedExperiment")` package fall in two
main categories: operations on the `TreeSummarizedExperiment` object or
operations on the tree (`phylo`) objects. The former includes constructors and
accessors, and the latter serves as "pieces" to be assembled as accessors or
functions that manipulate the `TreeSummarizedExperiment` object. Given that more
than 200 R packages make use of the `phylo` class, there are many resources
(e.g., `r CRANpkg("ape")`) for users to manipulate the small "pieces" in
addition to those provided in `r Biocpkg("TreeSummarizedExperiment")`.

## Toy data

We generate a toy dataset that has observations of 6 entities collected from 4
samples as an example to show how to construct a `TreeSummarizedExperiment`
object.

```{r}
library(TreeSummarizedExperiment)

# assays data (typically, representing observed data from an experiment)
assay_data <- rbind(rep(0, 4), matrix(1:20, nrow = 5))
colnames(assay_data) <- paste0("sample", 1:4)
rownames(assay_data) <- paste("entity", seq_len(6), sep = "")
assay_data
```

The information of entities and samples are given in the **row_data** and
**col_data**, respectively.
```{r}
# row data (feature annotations)
row_data <- data.frame(Kingdom = "A",
                       Phylum = rep(c("B1", "B2"), c(2, 4)),
                       Class = rep(c("C1", "C2", "C3"), each = 2),
                       OTU = paste0("D", 1:6),
                       row.names = rownames(assay_data),
                       stringsAsFactors = FALSE)

row_data
# column data (sample annotations)
col_data <- data.frame(gg = c(1, 2, 3, 3),
                       group = rep(LETTERS[1:2], each = 2), 
                       row.names = colnames(assay_data),
                       stringsAsFactors = FALSE)
col_data
```

The hierarchical structure of the `r nrow(assay_data)` entities and `r
ncol(assay_data)` samples are denoted as **row_tree** and **col_tree**,
respectively. The two trees are `phylo` objects randomly created with `rtree`
from the package `r CRANpkg("ape")`. Note that the row tree has 5 rather than 6
leaves; this is used later to show that multiple rows in the `assays` are
allowed to map to a single node in the tree.

```{r}
library(ape)

# The first toy tree 
set.seed(12)
row_tree <- rtree(5)

# The second toy tree 
set.seed(12)
col_tree <- rtree(4)

# change node labels
col_tree$tip.label <- colnames(assay_data)
col_tree$node.label <- c("All", "GroupA", "GroupB")
```

We visualize the tree using the package `r Biocpkg("ggtree")` [@Yu2017].  Here,
the internal nodes of the **row_tree** have no labels as shown in Figure
\@ref(fig:plot-rtree).

```{r plot-rtree, fig.cap="\\label{plot-rtree} The structure of the row tree. The node labels and the node numbers are in orange and blue text, respectively.", out.width="90%"}
library(ggtree)
library(ggplot2)

# Visualize the row tree
ggtree(row_tree, size = 2, branch.length = "none") +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7, size = 5.5) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7, size = 5.5) 
```


The **col_tree** has labels for internal nodes.
```{r plot-ctree, fig.cap="\\label{plot-ctree} The structure of the column tree. The node labels and the node numbers are in orange and blue text, respectively.", out.width="90%"}
# Visualize the column tree
ggtree(col_tree, size = 2, branch.length = "none") +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7, size = 5.5) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7, size = 5.5)+
    ylim(c(0.8, 4.5)) +
    xlim(c(0, 2.2))
```

## The construction of `TreeSummarizedExperiment`

The `TreeSummarizedExperiment` class is used to store the toy data generated in the previous section:
    **assay_data**, **row_data**, **col_data**, **col_tree** and **row_tree**. To
correctly store data, the link information between the rows (or columns) of
**assay_data** and the nodes of the **row_tree** (or **col_tree**) can be provided via a character vector `rowNodeLab` (or `colNodeLab`), with length equal to the number of rows (or columns) of the `assays`; otherwise the row (or column) names are used. Those columns
or rows with labels that are not present among the node labels of the tree are removed with
warnings. The link data between the `assays` tables and the tree data is
automatically generated in the construction.

The row and column trees can be included simultaneously in the construction.
Here, the column names of **assay_data** can be found in the node labels of the
column tree, which enables the link to be created between the column dimension
of **assay_data** and the column tree **col_tree**. If the row names of
**assay_data** are not in the node labels of **row_tree**, we would need to
provide their corresponding node labels (**row_lab**) to `rowNodeLab` in the
construction of the object. It is allowed to have multiple rows or/and columns
mapped to a node, for example, the same leaf label is used for the first two
rows in **row_lab**.

```{r}
# all column names could be found in the node labels of the column tree
all(colnames(assay_data) %in% c(col_tree$tip.label, col_tree$node.label))

# provide the node labels in rowNodeLab
tip_lab <- row_tree$tip.label
row_lab <- tip_lab[c(1, 1:5)]
row_lab

both_tse <- TreeSummarizedExperiment(assays = list(Count = assay_data),
                                     rowData = row_data,
                                     colData = col_data,
                                     rowTree = row_tree,
                                     rowNodeLab = row_lab,
                                     colTree = col_tree)
```


```{r}
both_tse
```
When printing out **both_tse**, we see a similar message as
`SingleCellExperiment` with four additional lines for `rowLinks`, `rowTree`,
`colLinks` and `colTree`. 

## The accessor functions
### Assays, rowData, colData, and metadata

For slots inherited from the `SingleCellExperiment` class, the accessors are
exactly the same as shown in `r Biocpkg("SingleCellExperiment")`. These
accessors are both setters and getters.

```{r}
# to get the first table in the assays
(count <- assays(both_tse)[[1]])
```

```{r}
# to get row data
rowData(both_tse)
```

```{r}
# to get column data
colData(both_tse)
```

```{r}
# to get metadata: it's empty here
metadata(both_tse)
```

### rowTree, colTree, rowLinks, colLinks {#linkData}

For new slots, we provide `rowTree` (and `colTree`) to retrieve the row (column)
trees, and `rowLinks` (and `colLinks`) to retrieve the link information between
`assays` and nodes of the row (column) tree. If the tree is not available, the
corresponding link data is `NULL`. 

```{r}
# get trees
rowTree(both_tse)
colTree(both_tse)
```

`rowTree` and `colTree` can work not only as getters but also as setters. The
replacement requires that the row/col names of the **TSE** object can be matched
to node labels of the new row/col tree; otherwise `changeTree` should be used
with `rowNodeLab` or `colNodeLab` available \@ref(change-tree).
```{r}
new_tse <- both_tse

# a new tree
new_tree <- rtree(nrow(new_tse))
new_tree$tip.label <- rownames(new_tse)

# the original row tree is replaced with the new tree
rowTree(new_tse) <- new_tree
identical(rowTree(new_tse), rowTree(both_tse))
identical(rowTree(new_tse), new_tree)

```

`rowLinks` and `colLinks` only work as getters.
```{r}
# access the link data
(r_link <- rowLinks(both_tse))
(c_link <- colLinks(both_tse))
```

The link data objects are of the `LinkDataFrame` class, which extends the `DataFrame` class with the restriction that it has at least four columns:
    
* `nodeLab`: the labels of nodes on the tree
* `nodeLab_alias`: the alias labels of nodes on the tree
* `nodeNum`: the numbers of nodes on the tree
* `isLeaf`: whether the node is a leaf node
* `whichTree`: the name of the tree that is mapped to (See vignette 2).

More details about
the `DataFrame` class could be found in the `r Biocpkg("S4Vectors")` R/Bioconductor package.

```{r}
class(r_link)
showClass("LinkDataFrame")
```

The link data is automatically generated when constructing the
`TreeSummarizedExperiment` object. We highly recommend users not to modify it
manually; otherwise the link might be broken. For R packages developers, we show
in the Section \@ref(modifyLink) about how to update the link.

### Reference sequence data {#refSeq}

In addition to tree data, reference sequence data can be stored per feature in 
a `TreeSummarizedExperiment` object. 

```{r}
refSeq <- DNAStringSet(rep("AGCT", nrow(both_tse)))
```

The data must match the number of rows in the object and can either be added to
the object upon creation or later on with the accessor function `referenceSeq`.

```{r}
referenceSeq(both_tse) <- refSeq
referenceSeq(both_tse)
```

Both `DNAStringSet` or `DNAStringSetList` can be used, so that a single or 
multiple sequences can be stored per feature.

Now, one new line in the message is shown for the `referenceSeq` slot.
```{r}
both_tse
```
## The subseting function

A `TreeSummarizedExperiment` object can be subset in two different ways: `[` to
subset by rows or columns, and `subsetByNode` to subset by nodes of a tree. As
the numeric ID of a node changes with the cut of a `phylo` tree, to keep track
of the original data, we do not update the tree structure in the subsetting. 

```{r}
sub_tse <- both_tse[1:2, 1]
sub_tse

# The tree stays the same
identical(rowTree(sub_tse), rowTree(both_tse))
```

`rowData`, `rowLinks`, `colData`, and `colLinks` are updated accordingly.
```{r}
# the row data
rowData(sub_tse)

# the row link data
rowLinks(sub_tse)

```

```{r}
# The first four columns are from colLinks data and the others from colData
cbind(colLinks(sub_tse), colData(sub_tse))
```

To subset by nodes, we specify the node by its node label or node number. Here,
*entity1* and *entity2* are both mapped to the same node `t3`, so both of them
are retained.

```{r}
node_tse <- subsetByNode(x = both_tse, rowNode = "t3")

rowLinks(node_tse)
```

Subsetting simultaneously in both dimensions is also allowed.

```{r}
node_tse <- subsetByNode(x = both_tse, rowNode = "t3", 
                         colNode = c("sample1", "sample2"))
assays(node_tse)[[1]]
```


## Changing the tree {#change-tree}

The current tree can be replaced by a new one using `changeTree`. If the
hierarchical information is available as a `data.frame` with each column
representing a taxonomic level (e.g., *row_data*), we provide `toTree` to
convert it into a `phylo` object.

```{r plot-taxa2phylo, fig.cap="\\label{plot-taxa2phylo} The structure of the taxonomic tree that is generated from the taxonomic table.", out.width="90%"}
# The toy taxonomic table
(taxa <- rowData(both_tse))

# convert it to a phylo tree
taxa_tree <- toTree(data = taxa)

# Viz the new tree
ggtree(taxa_tree)+
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7, size = 5.5) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7, size = 5.5) +
    geom_point2()
```

A mapping to match nodes of the two trees is required if nodes are labeled differently. 
```{r}
taxa_tse <- changeTree(x = both_tse, rowTree = taxa_tree, 
                       rowNodeLab = taxa[["OTU"]])

taxa_tse
rowLinks(taxa_tse)
```


## Aggregation

Since it may be of interest to report or analyze observed data on multiple
resolutions based on the provided tree, the `TreeSummarizedExperiment` package
offers functionionality to flexibly aggregate data to different levels of a
tree.

### The column dimension {#aggCol}

Here, we show the aggregation along the column dimension. The desired
aggregation level is given in the `colLevel` argument, which can be specified
via the node label (orange text in Figure \@ref(fig:plot-ctree)) or the node
number (blue text in Figure \@ref(fig:plot-ctree)). We could further specify how
to aggregate via the argument `colFun`.

```{r}
# use node labels to specify colLevel
agg_col <- aggTSE(x = taxa_tse,
                  colLevel = c("GroupA", "GroupB"),
                  colFun = sum)

# or use node numbers to specify colLevel
agg_col <- aggTSE(x = taxa_tse, colLevel = c(6, 7), colFun = sum)
```


```{r}
assays(agg_col)[[1]]
```

The `rowData` does not change, but the `colData` adjusts with the change of the
`assays` table. For example, the column **group** has the `A` value for
`GroupA` because the descendant nodes of `GroupA` all have the value `A`; the
column **gg** has the `NA` value for `GroupA` because the descendant nodes of
`GroupA` have different values, (1 and 2).

```{r}
# before aggregation
colData(taxa_tse)
# after aggregation
colData(agg_col)
```

We can decide which columns of `colData` to keep in the final output using
`colDataCols`. In situation with big data, this can speed up the aggregation by
dropping data that is not relevant. More arguments for `aggTSE` (e.g.,
`whichAssay`, `BPPARAM`) are available to customize the aggregation or to provide
parallel computation (`?aggTSE`).
```{r}
agg_col <- aggTSE(x = taxa_tse, colLevel = c(6, 7),
                  colFun = sum, colDataCols = "group")
colData(agg_col)
```

The `colLinks` is updated to link the new rows of `assays` tables and the column
tree.
```{r}
# the link data is updated
colLinks(agg_col)
```
From Figure \@ref(fig:plot-ctree), nodes 6 and 7 are
labeled with `GroupA` and `GroupB`, respectively, which agrees with the
column link data.


### The row dimension {#aggRow}

Similarly, we could aggregate the data to the phylum level by providing the
names of the internal nodes that represent the phylum level (see `taxa_one`
below).

```{r}
# the phylum level
taxa <- c(taxa_tree$tip.label, taxa_tree$node.label)
(taxa_one <- taxa[startsWith(taxa, "Phylum:")])

# aggregation
agg_taxa <- aggTSE(x = taxa_tse, rowLevel = taxa_one, rowFun = sum)
assays(agg_taxa)[[1]]
```

The user is nonetheless free to choose nodes from different taxonomic ranks. Note that not all rows in the original table are included in one of the aggregated rows. Similarly, it is possible for a row to contribute to multiple aggregated rows

```{r}
# A mixed level
taxa_mix <- c("Class:C3", "Phylum:B1")
agg_any <- aggTSE(x = taxa_tse, rowLevel = taxa_mix, rowFun = sum)
rowData(agg_any)
```


### Both dimensions

The aggregation on both dimensions could be performed in one step using
`aggTSE`. The aggregate functions for the row and the column are specificed via
`rowFun` and `colFun`, respectively. The aggregation order is determined using
`rowFirst`. Here, we set `rowFirst = FALSE` to firstly aggregate on the column
dimension, and then on the row dimension.

```{r}
agg_both <- aggTSE(x = both_tse, colLevel = c(6, 7), 
                   rowLevel = 7:9, rowFun = sum,
                   colFun = mean, rowFirst = FALSE)
```

As expected, we obtain a table with 3 rows (`rowLevel = 7:9`) and 2 columns
(`colLevel = c(6, 7)`). 

```{r}
assays(agg_both)[[1]]
```

## Functions operating on the `phylo` object.

Next, we highlight some functions to manipulate and/or to extract information
from the `phylo` object. Further operations can be found in other packages, such
as `r CRANpkg("ape")` [@ape2019], `r CRANpkg("tidytree")`[@R-tidytree]. These
functions are useful when users want to customize functions for the
`TreeSummarizedExperiment` class.

To show these functions, we use the tree shown in Figure \@ref(fig:plot-exTree).

```{r plot-exTree, fig.cap= "\\label{plot-exTree} An example tree with node labels and numbers in black and orange texts, respectively.", out.width="90%"}
data("tinyTree")
ggtree(tinyTree, branch.length = "none") +
    geom_text2(aes(label = label), hjust = -0.1, size = 5.5) +
    geom_text2(aes(label = node), vjust = -0.8,
               hjust = -0.2, color = 'orange', size = 5.5) 
```


### Conversion of the node label and the node number

The translation between the node labels and node numbers can be achieved by the function `convertNode`. 
```{r}
convertNode(tree = tinyTree, node = c(12, 1, 4))
```

```{r}
convertNode(tree = tinyTree, node = c("t4", "Node_18"))
```

### Find the descendants 

To get descendants that are at the leaf level, we could set the argument
`only.leaf = TRUE` for the function `findDescendant`.
```{r}
# only the leaf nodes
findDescendant(tree = tinyTree, node = 17, only.leaf = TRUE)
```

When `only.leaf = FALSE`, all descendants are returned. 
```{r}
# all descendant nodes
findDescendant(tree = tinyTree, node = 17, only.leaf = FALSE)
```

### More functions

We list some functions that might also be useful in Table \@ref(tab:phyloFun).
More are available in the package, and we encourage users to contribute their
functions that might be helpful for others.

| Functions   | Goal                                                         |
| ----------- | ------------------------------------------------------------ |
| printNode   | print out the information of nodes                           |
| countNode   | count the number of nodes                                    |
| distNode    | give the distance between a pair of nodes                    |
| matTree     | list paths of a tree                                         |
| findAncestor| find ancestor nodes                                          |
| findChild   | find child nodes                                             |
| findSibling | find sibling nodes                                           |
| shareNode   | find the first node shared in the paths of nodes to the root |
| unionLeaf   | find the union of descendant leaves                          |
| trackNode   | track nodes by adding alias labels to a phylo object         |
| isLeaf      | test whether a node is a leaf node                           |
: (\#tab:phyloFun) A table lists some functions operating on the `phylo` object that are available in the `TreeSummarizedExperiment`.
        
## Custom functions for the `TreeSummarizedExperiment` class {#modifyLink}

Here, we show an example on how to write custom functions for
`TreeSummarizedExperiment` objects. To extract data of specific leaves, we
created a function `subsetByLeaf` by combining functions working on the `phylo`
class (e.g., `convertNode`, `keep.tip`, `trackNode`, `isLeaf`) with the accessor
function `subsetByNode`. Here, `convertNode`, `trackNode` and `isLeaf` are
available in `TreeSummarizedExperiment`, and `keep.tip` is from the `r
CRANpkg("ape")` package. Since the node number of a node is changed after
pruning a tree with `keep.tip`, `trackNode` is provided to track the node and
further update the link between the data and the new tree.

```{r}
# tse: a TreeSummarizedExperiment object
# rowLeaf: specific leaves
subsetByLeaf <- function(tse, rowLeaf) {
  # if rowLeaf is provided as node labels, convert them to node numbers
  if (is.character(rowLeaf)) {
    rowLeaf <- convertNode(tree = rowTree(tse), node = rowLeaf)
  }
  
  # subset data by leaves
  sse <- subsetByNode(tse, rowNode = rowLeaf)
  
  # update the row tree
    ## -------------- new tree: drop leaves ----------
    oldTree <- rowTree(sse)
    newTree <- ape::keep.tip(phy = oldTree, tip = rowLeaf)
    
    ## -------------- update the row link ----------
    # track the tree
    track <- trackNode(oldTree)
    track <- ape::keep.tip(phy = track, tip = rowLeaf)
    
    # row links
    rowL <- rowLinks(sse)
    rowL <- DataFrame(rowL)
    
    # update the row links: 
    #   1. use the alias label to track and updates the nodeNum
    #   2. the nodeLab should be updated based on the new tree using the new
    #      nodeNum
    #   3. lastly, update the nodeLab_alias
    rowL$nodeNum <- convertNode(tree = track, node = rowL$nodeLab_alias,
                              message = FALSE)
    rowL$nodeLab <- convertNode(tree = newTree, node = rowL$nodeNum, 
                              use.alias = FALSE, message = FALSE)
    rowL$nodeLab_alias <- convertNode(tree = newTree, node = rowL$nodeNum, 
                                    use.alias = TRUE, message = FALSE)
    rowL$isLeaf <- isLeaf(tree = newTree, node = rowL$nodeNum)

    rowNL <- new("LinkDataFrame", rowL)
    
    ## update the row tree and links
    BiocGenerics:::replaceSlots(sse,
                              rowLinks = rowNL,
                              rowTree = list(phylo = newTree))
}

```

The row tree is updated after the subsetting. It now has only two leaves, `t2` and `t3`. 
```{r}
(both_sse <- subsetByLeaf(tse = both_tse, rowLeaf = c("t2", "t3")))
rowLinks(both_sse)
```

# Session Info

```{r}
sessionInfo()
```

# Reference

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TreeSummarizedExperiment.R, R/allClass.R
\name{TreeSummarizedExperiment-internal}
\alias{TreeSummarizedExperiment-internal}
\alias{vertical_slot_names,TreeSummarizedExperiment-method}
\title{TreeSummarizedExperiment internals}
\usage{
\S4method{vertical_slot_names}{TreeSummarizedExperiment}(x)
}
\description{
Internal functions which should only be used in TreeSummarizedExperiment
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/updateObject.R
\name{updateObject,TreeSummarizedExperiment-method}
\alias{updateObject,TreeSummarizedExperiment-method}
\title{Update a \code{TreeSummarizedExperiment} object}
\usage{
\S4method{updateObject}{TreeSummarizedExperiment}(object, ..., verbose = FALSE)
}
\arguments{
\item{object}{A \code{TreeSummarizedExperiment} object}

\item{...}{additional arguments, for use in specific \code{updateObject}
methods.}

\item{verbose}{\code{TRUE} or \code{FALSE}, indicating whether information 
about the update should be reported.}
}
\value{
An updated \code{TreeSummarizedExperiment} object
}
\description{
Update \code{TreeSummarizedExperiment} objects to the latest version of the 
class structure. This is usually called by methods in the 
\code{TreeSummarizedExperiment} package rather than by users or downstream 
packages.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecate_Fun.R
\name{aggValue}
\alias{aggValue}
\title{Perform data aggregations based on the available tree structures}
\usage{
aggValue(
  x,
  rowLevel = NULL,
  rowBlock = NULL,
  colLevel = NULL,
  colBlock = NULL,
  FUN = sum,
  assay = NULL,
  message = FALSE
)
}
\arguments{
\item{x}{A \code{TreeSummarizedExperiment} object.}

\item{rowLevel}{A numeric (node numbers) or character (node labels) vector.
It provides the level on the tree that data is aggregated to. The
aggregation is on the row dimension. The default is \code{rowLevel = NULL},
and no aggregation is performed.}

\item{rowBlock}{A column name in the \code{rowData} to separate the
aggregation.}

\item{colLevel}{A numeric (node numbers) or character (node labels) vector.
It provides the level on the tree that data is aggregated to. The
aggregation is on the column dimension. The default is \code{colLevel =
NULL}, and no aggregation is performed.}

\item{colBlock}{A column name in the \code{colData} to separate the
aggregation.}

\item{FUN}{A function to be applied on the aggregation. It's similar to the
\code{FUN} in \code{\link[base]{apply}}.}

\item{assay}{A integer scalar or string indicating which assay of \code{x} to
use in the aggregation. If NULL, all assay tables are used in aggregation.}

\item{message}{A logical value. The default is TRUE. If TRUE, it will print
out the running process.}
}
\value{
A \code{TreeSummarizedExperiment} object or a
  \code{matrix}. The output has the same class of the input \code{x}.
}
\description{
\code{aggValue} aggregates values on the leaf nodes of a tree to a specific
arbitrary level of the tree. The level is specified via the nodes of the
tree. Users could decide on which dimension (row or column) and how should
the aggregation be performed.
}
\seealso{
\code{\link{aggTSE}}
}
\author{
Ruizhu HUANG
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenerics.R, R/classAccessor.R
\name{rowLinks}
\alias{rowLinks}
\alias{rowLinks,TreeSummarizedExperiment-method}
\alias{colLinks}
\alias{colLinks,TreeSummarizedExperiment-method}
\alias{rowTree}
\alias{rowTree,TreeSummarizedExperiment-method}
\alias{rowTree<-}
\alias{rowTree<-,TreeSummarizedExperiment-method}
\alias{colTree}
\alias{colTree,TreeSummarizedExperiment-method}
\alias{colTree<-}
\alias{colTree<-,TreeSummarizedExperiment-method}
\alias{rowTreeNames}
\alias{rowTreeNames,TreeSummarizedExperiment-method}
\alias{rowTreeNames<-}
\alias{rowTreeNames<-,TreeSummarizedExperiment-method}
\alias{colTreeNames}
\alias{colTreeNames,TreeSummarizedExperiment-method}
\alias{colTreeNames<-}
\alias{colTreeNames<-,TreeSummarizedExperiment-method}
\alias{referenceSeq}
\alias{referenceSeq,TreeSummarizedExperiment-method}
\alias{referenceSeq<-}
\alias{referenceSeq<-,TreeSummarizedExperiment-method}
\alias{[,TreeSummarizedExperiment,ANY,ANY,ANY-method}
\alias{[<-,TreeSummarizedExperiment,ANY,ANY,TreeSummarizedExperiment-method}
\alias{rownames<-,TreeSummarizedExperiment-method}
\alias{colnames<-,TreeSummarizedExperiment-method}
\alias{subsetByLeaf}
\alias{subsetByLeaf,TreeSummarizedExperiment-method}
\alias{subsetByNode}
\alias{subsetByNode,TreeSummarizedExperiment-method}
\alias{TreeSummarizedExperiment-accessor}
\title{TreeSummarizedExperiment-accessors}
\usage{
rowLinks(x)

\S4method{rowLinks}{TreeSummarizedExperiment}(x)

colLinks(x)

\S4method{colLinks}{TreeSummarizedExperiment}(x)

rowTree(x, whichTree = 1, value)

\S4method{rowTree}{TreeSummarizedExperiment}(x, whichTree = 1, value)

rowTree(x, whichTree = 1) <- value

\S4method{rowTree}{TreeSummarizedExperiment}(x, whichTree = 1) <- value

colTree(x, whichTree = 1)

\S4method{colTree}{TreeSummarizedExperiment}(x, whichTree = 1)

colTree(x, whichTree = 1) <- value

\S4method{colTree}{TreeSummarizedExperiment}(x, whichTree = 1) <- value

rowTreeNames(x, value)

\S4method{rowTreeNames}{TreeSummarizedExperiment}(x, value)

rowTreeNames(x) <- value

\S4method{rowTreeNames}{TreeSummarizedExperiment}(x) <- value

colTreeNames(x, value)

\S4method{colTreeNames}{TreeSummarizedExperiment}(x, value)

colTreeNames(x) <- value

\S4method{colTreeNames}{TreeSummarizedExperiment}(x) <- value

referenceSeq(x)

\S4method{referenceSeq}{TreeSummarizedExperiment}(x)

referenceSeq(x) <- value

\S4method{referenceSeq}{TreeSummarizedExperiment}(x) <- value

\S4method{[}{TreeSummarizedExperiment,ANY,ANY,ANY}(x, i, j, ..., drop = TRUE)

\S4method{[}{TreeSummarizedExperiment,ANY,ANY,TreeSummarizedExperiment}(x, i, j, ...) <- value

\S4method{rownames}{TreeSummarizedExperiment}(x) <- value

\S4method{colnames}{TreeSummarizedExperiment}(x) <- value

subsetByLeaf(
  x,
  rowLeaf,
  colLeaf,
  whichRowTree,
  whichColTree,
  updateTree = TRUE
)

\S4method{subsetByLeaf}{TreeSummarizedExperiment}(
  x,
  rowLeaf,
  colLeaf,
  whichRowTree,
  whichColTree,
  updateTree = TRUE
)

subsetByNode(x, rowNode, colNode, whichRowTree, whichColTree)

\S4method{subsetByNode}{TreeSummarizedExperiment}(x, rowNode, colNode, whichRowTree, whichColTree)
}
\arguments{
\item{x}{A TreeSummarizedExperiment object}

\item{whichTree}{A numeric indicator or name character to specify which tree
in the \code{rowTree} or \code{colTree} to be extracted. The default is to
extract the first tree. If \code{whichTree = NULL}, a list of all trees is
extracted.}

\item{value}{\itemize{
  \item{the new rownames or colnames as a \code{character} value. See
    \code{\link[BiocGenerics:row_colnames]{BiocGenerics}}.}
  \item{A \code{\link[Biostrings:XStringSet-class]{DNAStringSet}}
    object or an object coercible to one}
}}

\item{i, j}{The row, column index to subset \code{x}. The arguments of the
subset function \code{[]}}

\item{...}{The argument from the subset function \code{[]}}

\item{drop}{A logical value, TRUE or FALSE. The argument from the subset
function \code{[]}}

\item{rowLeaf}{A vector of leaves that are used to subset rows. One could use
the leaf number, or the leaf label to specify nodes, but not a mixture of
them.}

\item{colLeaf}{A vector of leaves that are used to subset columns. One could
use the leaf number, or the leaf label to specify nodes, but not a mixture
of them.}

\item{whichRowTree}{A numeric indicator or name character to specify which tree
in the \code{rowTree}.}

\item{whichColTree}{A numeric indicator or name character to specify which tree
in the \code{colTree}.}

\item{updateTree}{TRUE or FALSE. Default is TRUE, which updates tree
structures after subsetting.}

\item{rowNode}{A vector of nodes that are used to subset rows. One could use
the node number, the node label or the node alias to specify nodes, but not
a mixture of them.}

\item{colNode}{A vector of nodes that are used to subset columns. One could
use the node number, the node label or the node alias to specify nodes, but
not a mixture of them.}
}
\value{
Elements from \code{TreeSummarizedExperiment}.
}
\description{
All accessor functions that work on
\code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
should work on \strong{TreeSummarizedExperiment}. Additionally, new accessors
\code{rowLinks} \code{colLinks}, \code{rowTree} and \code{colTree} accessor
function are available for \strong{TreeSummarizedExperiment}.
}
\examples{

# the assay table
set.seed(1)
y <- matrix(rnbinom(300,size=1,mu=10),nrow=10)
colnames(y) <- paste(rep(LETTERS[1:3], each = 10), rep(1:10,3), sep = "_")
rownames(y) <- tinyTree$tip.label

# the row data
rowInf <- DataFrame(var1 = sample(letters[1:3], 10, replace = TRUE),
                    var2 = sample(c(TRUE, FALSE), 10, replace = TRUE))
# the column data
colInf <- DataFrame(gg = factor(sample(1:3, 30, replace = TRUE)),
                    group = rep(LETTERS[1:3], each = 10))

# the tree structure on the rows of assay tables
data("tinyTree")

# the tree structure on the columns of assay tables
sampTree <- ape::rtree(30)
sampTree$tip.label <- colnames(y)

# create the TreeSummarizedExperiment object
toy_tse <- TreeSummarizedExperiment(assays = list(y),
                                    rowData = rowInf,
                                    colData = colInf,
                                    rowTree = tinyTree,
                                    colTree = sampTree)

## extract the rowData
(rowD <- rowData(x = toy_tse))

## extract the colData
(colD <- colData(x = toy_tse))

## extract the linkData
# on rows
(rowL <- rowLinks(x = toy_tse))
# on columns
(colL <- colLinks(x = toy_tse))

 ## extract the treeData
# on rows
(rowT <- rowTree(x = toy_tse))
# on columns
(colT <- colTree(x = toy_tse))

# the referenceSeq data
refSeq <- DNAStringSetList(one = DNAStringSet(rep("A",nrow(toy_tse))),
                           two = DNAStringSet(rep("B",nrow(toy_tse))))
referenceSeq(toy_tse) <- refSeq
toy_tse

# subset treeSE by leaves
library(ape)
set.seed(1)
z <- makeTSE(nrow = 5, ncol = 4, include.rowTree = TRUE, include.colTree = FALSE)
y <- makeTSE(nrow = 4, ncol = 4, include.rowTree = TRUE, include.colTree = FALSE)
tr <- ape::rtree(4)
zy <- rbind(z, y)
x <- changeTree(x = zy, rowTree = tr, whichRowTree = 2, rowNodeLab = tr$tip.label)
rowLinks(zy)
rowLinks(x)
## 1) rowLeaf exist only in one of trees
rf <- c("t1", "t3")
sx <- subsetByLeaf(x = x, rowLeaf = rf)
rowLinks(sx)

sx <- subsetByLeaf(x = x, rowLeaf = rf, updateTree = FALSE)
rowLinks(sx)

## 2) rowLeaf exist in all trees
rf <- 1:3
sxx <- subsetByLeaf(x = x, rowLeaf = rf)
rowLinks(sxx)



## 3) rowLeaf exist in all trees, but subset and update only the specified
trees
rf <- c(3:4)
sxx <- subsetByLeaf(x = x, rowLeaf = rf, whichRowTree = "phylo")
rowLinks(sxx)
}
\seealso{
\code{\link{TreeSummarizedExperiment}}
  \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
}
\author{
Ruizhu HUANG
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenerics.R, R/combine.R
\name{rbind,TreeSummarizedExperiment-method}
\alias{rbind,TreeSummarizedExperiment-method}
\alias{cbind,TreeSummarizedExperiment-method}
\alias{TreeSummarizedExperiment-combine}
\title{Combine TSEs by rows or columns}
\usage{
\S4method{rbind}{TreeSummarizedExperiment}(..., deparse.level = 1)

\S4method{cbind}{TreeSummarizedExperiment}(..., deparse.level = 1)
}
\arguments{
\item{...}{One or more \code{TreeSummarizedExperiment} objects.}

\item{deparse.level}{See \code{\link[base]{cbind}}}
}
\value{
A TreeSummarizedExperiment object
}
\description{
\code{rbind} and \code{cbind} take one or more
\code{TreeSummarizedExperiment} objects and combine them by columns or rows,
respectively.
}
\examples{

# rbind works : 
# a) TSE without rowTree and without colTree
# b) TSE with rowTree but without colTree
# c) TSE without rowTree but with colTree
# d) TSE with rowTree & colTree

set.seed(1)
# a) 
(tse_a <- makeTSE(include.colTree = FALSE))
(tse_b <- makeTSE(include.colTree = FALSE))

# b) 
(tse_c <- makeTSE(include.rowTree = FALSE))
(tse_d <- makeTSE(include.rowTree = FALSE))

rbind(tse_a, tse_b)
cbind(tse_c, tse_d)
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_findSibling.R
\name{findSibling}
\alias{findSibling}
\title{find the sibling node}
\usage{
findSibling(tree, node, use.alias = FALSE)
}
\arguments{
\item{tree}{A phylo object.}

\item{node}{A numeric or character vector. Node labels or node numbers.}

\item{use.alias}{A logical value, TRUE or FALSE. The default is FALSE, and
the original node label would be used to name the output; otherwise, the
alias of node label would be used to name the output. The alias of node
label is created by adding a prefix \code{"alias_"} to the node number.}
}
\value{
A vector of nodes. The numeric value is the node number, and the
  vector name is the corresponding node label. If a node has no label, it
  would have NA as name when \code{use.alias = FALSE}, and have the alias of
  node label as name when \code{use.alias = TRUE}.
}
\description{
\code{findSibling} is to find the sibling node of an \code{node} node.
}
\examples{
library(ggtree)
data(tinyTree)
ggtree(tinyTree, branch.length = 'none') +
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)


 findSibling(tree = tinyTree, node = 17)
 findSibling(tree = tinyTree, node = c(13, 17))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_distNode.R
\name{distNode}
\alias{distNode}
\title{Calculate the distance between any two nodes on the tree}
\usage{
distNode(tree, node)
}
\arguments{
\item{tree}{A phylo object.}

\item{node}{A numeric or character vector of length two.}
}
\value{
A numeric value.
}
\description{
\code{distNode} is to calculate the distance between any two nodes on
a \code{phylo} tree
}
\examples{
library(ggtree)
data(tinyTree)
ggtree(tinyTree) +
    geom_text2(aes(label = node), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = branch.length), color = "darkblue",
               vjust = 0.7)


distNode(tree = tinyTree, node = c(10, 11))
distNode(tree = tinyTree, node = c(12, 13))
distNode(tree = tinyTree, node = c(13, 15))
distNode(tree = tinyTree, node = c(12, 14))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.subset_leaf}
\alias{.subset_leaf}
\title{update dimLinks and dimTree (used in subsetByLeaf)}
\usage{
.subset_leaf(x, leaf, dim = "row", updateTree = TRUE)
}
\description{
update dimLinks and dimTree (used in subsetByLeaf)
}
\author{
Ruizhu Huang
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.name_y_with_x}
\alias{.name_y_with_x}
\title{name y with x}
\usage{
.name_y_with_x(x, y)
}
\description{
name y with x
}
\examples{
\dontrun{
x <- letters[1:5]
y <- 1:5
.name_y_with_x(x, y)
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aboutLoop.R
\name{detectLoop}
\alias{detectLoop}
\title{Detect loops 
\code{detectLoop} detects loops}
\usage{
detectLoop(tax_tab)
}
\arguments{
\item{tax_tab}{a data frame where columns store hierarchical levels. The
columns from the left to the right correspond nodes from the root to the
leaf.}
}
\value{
a data frame
}
\description{
Detect loops 
\code{detectLoop} detects loops
}
\examples{

df <- data.frame(A = rep("a", 8),
                 B = rep (c("b1", "b2", "b3", "b4"), each = 2),
                 C = paste0("c", c(1, 2, 2, 3:7)),
                 D = paste0("d", 1:8))
 
# The result means that a loop is caused by 'b1' and 'b2' in column 'B' and
# 'c2' in column 'C' (a-b1-c2; a-b2-c2)
detectLoop(tax_tab = df)

df <- data.frame(R1 = rep("A", 6),
                     R2 = c("B1", rep("B2", 4), "B3"),
                     R3 = c("C1", "C2", "C3", NA, NA, NA),
                     R4 = c("D1", "D2", "D3", NA, NA, NA),
                     R5 = paste0("E", 1:6))
detectLoop(tax_tab = df)

df <- data.frame(R1 = rep("A", 7),
                     R2 = c("B1", rep("B2", 4), "B3", "B3"),
                     R3 = c("C1", "C2", "C3", "", "", "", ""),
                     R4 = c("D1", "D2", "D3", "", "", "", ""),
                     R5 = paste0("E", 1:7))
detectLoop(tax_tab = df)

df <- data.frame(R1 = rep("A", 7),
                     R2 = c("B1", rep("B2", 4), "B3", "B3"),
                     R3 = c("C1", "C2", "C3", NA, NA, NA, NA),
                     R4 = c("D1", "D2", "D3", NA, NA, NA, NA),
                     R5 = paste0("E", 1:7))
detectLoop(tax_tab = df) 
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_matTree.R
\name{matTree}
\alias{matTree}
\title{Transform a phylo object into a matrix.}
\usage{
matTree(tree)
}
\arguments{
\item{tree}{A phylo object}
}
\value{
A matrix
}
\description{
\code{matTree} transforms a phylo tree into a matrix. The entry of the matrix
is node number. Each row represents a path connecting a leaf node and the
root. The columns are arranged in the order as the path passing the nodes to
reach the root.
}
\examples{
library(ggtree)

data(tinyTree)
ggtree(tinyTree, branch.length = 'none') +
 geom_text2(aes(label = node))


# each row of the matrix representing a path.
# the first column is leaf nodes; the last non-NA value in a row is the root
mat <- matTree(tree = tinyTree)

}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_findAncestor.R
\name{findAncestor}
\alias{findAncestor}
\title{Find the ancestors of specified nodes}
\usage{
findAncestor(tree, node, level, use.alias = FALSE)
}
\arguments{
\item{tree}{A phylo object}

\item{node}{A vector of node numbers or node labels}

\item{level}{A vector of numbers to define nth generation before the
specified nodes}

\item{use.alias}{A logical value, TRUE or FALSE. The default is FALSE, and
the node label would be used to name the output; otherwise, the alias of
node label would be used to name the output. The alias of node label is
created by adding a prefix \code{"alias_"} to the node number.}
}
\value{
A vector of nodes. The numeric value is the node number, and the
  vector name is the corresponding node label. If a node has no label, it
  would have NA as name when \code{use.alias = FALSE}, and have the alias of
  node label as name when \code{use.alias = TRUE}.
}
\description{
\code{findAncestor} finds the ancestor in the nth generation above
specified nodes.
}
\examples{
library(ggtree)
data(tinyTree)
ggtree(tinyTree, branch.length = 'none') +
 geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
 geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)

 findAncestor(tree = tinyTree, node = c(18, 13), level = 1)
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.all_have_DNAStringSet}
\alias{.all_have_DNAStringSet}
\title{test all TSEs have DNAStringSet in the referenceSeq slot}
\usage{
.all_have_DNAStringSet(args)
}
\description{
test all TSEs have DNAStringSet in the referenceSeq slot
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/changeTree.R
\name{changeTree}
\alias{changeTree}
\title{Change the row or column tree}
\usage{
changeTree(
  x,
  rowTree = NULL,
  rowNodeLab = NULL,
  colTree = NULL,
  colNodeLab = NULL,
  whichRowTree = 1,
  whichColTree = 1
)
}
\arguments{
\item{x}{A TreeSummarizedExperiment object}

\item{rowTree}{A phylo object. A new row tree.}

\item{rowNodeLab}{A character string. It provides the labels of nodes that
the rows of assays tables corresponding to. If NULL (default), the row
names of the assays tables are used.}

\item{colTree}{A phylo object. A new column tree.}

\item{colNodeLab}{A character string. It provides the labels of nodes that
the columns of assays tables corresponding to. If NULL (default), the
column names of the assays tables are used.}

\item{whichRowTree}{Which row tree to be replaced? Default is 1 (the first
tree in the \code{rowTree} slot).}

\item{whichColTree}{Which column tree to be replaced? Default is 1 (the first
tree in the \code{colTree} slot).}
}
\value{
A TreeSummarizedExperiment object
}
\description{
\code{changeTree} changes a row or column tree in a
\code{TreeSummarizedExperiment} object.
}
\examples{

library(ape)
set.seed(1)
treeR <- ape::rtree(10)

# the count table
count <- matrix(rpois(160, 50), nrow = 20)
rownames(count) <- paste0("entity", 1:20)
colnames(count) <- paste("sample", 1:8, sep = "_")
# The sample information
sampC <- data.frame(condition = rep(c("control", "trt"), 
                                    each = 4),
                    gender = sample(x = 1:2, size = 8, 
                                    replace = TRUE))
rownames(sampC) <- colnames(count)
# build a TreeSummarizedExperiment object
tse <- TreeSummarizedExperiment(assays = list(count),
                                colData = sampC,
                                rowTree = treeR,
                                rowNodeLab = rep(treeR$tip.label, each =2))

treeR2 <- drop.tip(phy = treeR, tip = c("t10", "t9", "t8"))

# if rownames are not used in node labels of the tree, provide rowNodeLab
use <- changeTree(x = tse, rowTree = treeR2, 
                  rowNodeLab = rep(treeR$tip.label, each =2))
use

# if rownames are used in node labels of tree, rowNodeLab is not required.

rownames(tse) <- rep(treeR$tip.label, each =2)
cse <- changeTree(x = tse, rowTree = treeR2)
cse
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.match_x_dupY}
\alias{.match_x_dupY}
\title{convert char. indicator to num. indicator}
\usage{
.match_x_dupY(x, dy)
}
\arguments{
\item{x}{A vector. The values to be matched.}

\item{dy}{A vector. The values to be matched agaist.}
}
\description{
This differs to \code{match} with that the duplicated values in dy are not
ignored.
}
\author{
Ruizhu Huang
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_toTree.R
\name{toTree}
\alias{toTree}
\title{Translate a data frame to a phylo object}
\usage{
toTree(data, column_order = NULL)
}
\arguments{
\item{data}{A data frame or matrix.}

\item{column_order}{A vector that includes the column names of data to
reorder columns of \code{data}. Default is NULL, the original order of
\code{data} is kept.}
}
\value{
a phylo object
}
\description{
\code{toTree} translates a data frame to a phylo object
}
\details{
The last column is used as the leaf nodes
}
\examples{

library(ggtree)
# Example 1:
taxTab <- data.frame(R1 = rep("A", 5),
                     R2 = c("B1", rep("B2", 4)),
                     R3 = paste0("C", 1:5))
# Internal nodes: their labels are prefixed with colnames of taxTab
#  e.g., R2:B2
tree <- toTree(data = taxTab)
# viz the tree           
 ggtree(tree) + 
 geom_text2(aes(label = label), color = "red", vjust = 1) + 
 geom_nodepoint()

# Example 2: duplicated rows in the 3rd and 4th rows
taxTab <- data.frame(R1 = rep("A", 5),
                     R2 = c("B1", rep("B2", 4)),
                     R3 = c("C1", "C2", "C3", "C3", "C4"))
# duplicated rows are removed with warnings
tree <- toTree(data = taxTab)

# Example 3: NA values in R2 column 
# results: the internal node with the label 'R2:'
taxTab <- data.frame(R1 = rep("A", 5),
                     R2 = c("B1", rep("B2", 2), NA, "B2"),
                     R3 = c("C1", "C2", "C3", NA, "C4"))
tree <- toTree(data = taxTab)
# viz the tree           
 ggtree(tree) + 
 geom_text2(aes(label = label), color = "red", vjust = 1) + 
 geom_nodepoint()

# Example 4: duplicated values in the leaf column (R4)
# Not allowed and give errors
# taxTab <- data.frame(R1 = rep("A", 5),
#                      R2 = c("B1", rep("B2", 3), "B3"),
#                      R3 = c("C1", "C2", "C3", "C3",NA),
#                      R4 = c("D1", "D2", "D3", NA, NA))

# Example 5: loops caused by missing values in B2-C4, B3-C4
taxTab <- data.frame(R1 = rep("A", 6),
                     R2 = c("B1", rep("B2", 4), "B3"),
                     R3 = c("C1", "C2", "C3", "C3", "C4", "C4"),
                     R4 = c("D1", "D2", "D3", "D3", "D4" , "D4"),
                     R5 = paste0("E", 1:6))
 # resolove loops before run to Tree
 # Suffix are adding to C4
 taxNew <- resolveLoop(taxTab)           
 tree <- toTree(data = taxNew)
 
 # viz the tree           
 ggtree(tree) + 
 geom_text2(aes(label = label), color = "red", vjust = 1) + 
 geom_nodepoint()
}
\author{
Ruizhu HUANG
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{tinyTree}
\alias{tinyTree}
\title{A simulated phylogenetic tree with 10 tips and 9 internal nodes}
\format{
A phylo object with 10 tips and 9 internal nodes:
\describe{
  \item{Tip labels}{t1, t2, ..., t10.}
  \item{Node labels}{Node_11, Node_12, ..., Node_19}
}
}
\usage{
tinyTree
}
\description{
A random phylo object created using the function \code{\link[ape:rtree]{rtree}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aggTSE.R
\name{aggTSE}
\alias{aggTSE}
\title{Perform data aggregations based on the available tree structures}
\usage{
aggTSE(
  x,
  rowLevel = NULL,
  rowBlock = NULL,
  colLevel = NULL,
  colBlock = NULL,
  rowFun = sum,
  colFun = sum,
  whichRowTree = 1,
  whichColTree = 1,
  whichAssay = NULL,
  message = FALSE,
  rowDataCols,
  colDataCols,
  rowFirst = TRUE,
  BPPARAM = NULL
)
}
\arguments{
\item{x}{A \code{TreeSummarizedExperiment} object.}

\item{rowLevel}{A numeric (node numbers) or character (node labels) vector.
It provides the level on the tree that data is aggregated to. The
aggregation is on the row dimension. The default is \code{rowLevel = NULL},
and no aggregation is performed.}

\item{rowBlock}{A column name in the \code{rowData} to separate the
aggregation.}

\item{colLevel}{A numeric (node numbers) or character (node labels) vector.
It provides the level on the tree that data is aggregated to. The
aggregation is on the column dimension. The default is \code{colLevel =
NULL}, and no aggregation is performed.}

\item{colBlock}{A column name in the \code{colData} to separate the
aggregation.}

\item{rowFun}{A function to be applied on the row aggregation. It's similar
to the \code{FUN} in \code{\link[base]{apply}}.}

\item{colFun}{A function to be applied on the col aggregation. It's similar
to the \code{FUN} in \code{\link[base]{apply}}.}

\item{whichRowTree}{A integer scalar or string indicating which row tree is
used in the aggregation. The first row tree is used as default.}

\item{whichColTree}{A integer scalar or string indicating which row tree is
used in the aggregation. The first row tree is used as default.}

\item{whichAssay}{A integer scalar or string indicating which assay of
\code{x} to use in the aggregation. If NULL, all assay tables are used in
aggregation.}

\item{message}{A logical value. The default is TRUE. If TRUE, it will print
out the running process.}

\item{rowDataCols}{The rowData columns to include.}

\item{colDataCols}{The colData columns to include.}

\item{rowFirst}{TRUE or FALSE. If the aggregation is in both dims., it is
performed firstly on the row dim for \code{rowFirst = TRUE} or on the
column dim for \code{rowFirst = FALSE}.}

\item{BPPARAM}{Default is \code{NULL} and the computation isn't run in
parallel. To run computation parallelly, an optional
\code{\link[BiocParallel:BiocParallelParam-class]{BiocParallelParam}}
instance determining the parallel back-end to be used during evaluation, or
a list of BiocParallelParam instances, to be applied in sequence for nested
calls to \strong{BiocParallel} functions.}
}
\value{
A \code{\link{TreeSummarizedExperiment}} object
}
\description{
\code{aggTSE} aggregates values on the leaf nodes of a tree to a specific
arbitrary level of the tree. The level is specified via the nodes of the
tree. Users could decide on which dimension (row or column) and how should
the aggregation be performed.
}
\examples{

# assays data
set.seed(1)
toyTable <- matrix(rnbinom(20, size = 1, mu = 10), nrow = 5)
colnames(toyTable) <- paste(rep(LETTERS[1:2], each = 2),
                            rep(1:2, 2), sep = "_")
rownames(toyTable) <- paste("entity", seq_len(5), sep = "")

toyTable

# the column data
colInf <- DataFrame(gg = c(1, 2, 3, 3),
                    group = rep(LETTERS[1:2], each = 2),
                    row.names = colnames(toyTable))
colInf

# the toy tree
library(ape)
set.seed(4)
treeC <- rtree(4)
treeC$node.label <- c("All", "GroupA", "GroupB")

library(ggtree)
ggtree(treeC, size = 2) +
   geom_text2(aes(label = node), color = "darkblue",
           hjust = -0.5, vjust = 0.7, size = 6) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7, size = 6)


tse <- TreeSummarizedExperiment(assays = list(toyTable),
                                colData = colInf,
                                colTree = treeC,
                                colNodeLab = treeC$tip.label,
                                metadata = list(test = 1:4))

aggCol <- aggTSE(x = tse, colLevel = c("GroupA", "GroupB"),
                 colFun = sum)

assays(aggCol)[[1]]

}
\author{
Ruizhu HUANG
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.all_nonnull_in_list}
\alias{.all_nonnull_in_list}
\title{all elements in the list are NULL}
\usage{
.all_nonnull_in_list(x)
}
\description{
all elements in the list are NULL
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_addLabel.R
\name{addLabel}
\alias{addLabel}
\title{add labels to nodes of a tree}
\usage{
addLabel(tree, label = NULL, on = c("all", "leaf", "internal"))
}
\arguments{
\item{tree}{A phylo object}

\item{label}{A character vector to provide node labels. The label is passed to
nodes that are sorted by their node number in ascending order. The default
is NULL, nodes are labeled by adding a prefix \code{Node_} to their node number.}

\item{on}{Chosen from "all", "leaf", "internal". If "all", all nodes are
labeled; if "leaf", leaves are labeled; if "internal", internal nodes are
labeled.}
}
\value{
a phylo object
}
\description{
\code{addLabel} label nodes of a tree (\code{phylo} object)
}
\examples{
 
data(tinyTree)
library(ggtree)

# PLOT tree
# The node labels are in orange texts and the node numbers are in blue
ggtree(tinyTree, branch.length = 'none')+
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)

# change labels
nodes <- showNode(tree = tinyTree, only.leaf = FALSE)
tt <- addLabel(tree = tinyTree, label = LETTERS[nodes],
               on = "all")

ggtree(tt, branch.length = 'none')+
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)

}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.replace_link_tree_1d}
\alias{.replace_link_tree_1d}
\title{replace row/col links & trees}
\usage{
.replace_link_tree_1d(x, value, ij, dim = "row")
}
\arguments{
\item{x}{A TSE with \code{ij} rows/cols to be replaced by \code{value}}

\item{value}{A TSE to replace some rows/cols of \code{x}.}

\item{ij}{A character or numeric vector to specify which rows/cols to be replaced.}

\item{dim}{"row" or "col" to specify the dimension is in rows or columns}
}
\description{
replace row/col links & trees
}
\author{
Ruizhu Huang
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.auto_rename_list}
\alias{.auto_rename_list}
\title{rename a list automatically to avoid duplicated names}
\usage{
.auto_rename_list(x)
}
\description{
rename a list automatically to avoid duplicated names
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_countLeaf.R
\name{countLeaf}
\alias{countLeaf}
\title{count the number of leaf nodes}
\usage{
countLeaf(tree)
}
\arguments{
\item{tree}{A phylo object}
}
\value{
a numeric value
}
\description{
\code{countLeaf} calculates the number of leaves on a \code{phylo} tree.
}
\examples{
library(ggtree)

data(tinyTree)

ggtree(tinyTree, branch.length = 'none') +
geom_text2(aes(label = label), hjust = -0.3) +
geom_text2(aes(label = node), vjust = -0.8,
hjust = -0.3, color = 'blue')


(n <- countLeaf(tinyTree))

}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClass.R
\docType{class}
\name{LinkDataFrame-class}
\alias{LinkDataFrame-class}
\title{LinkDataFrame: A S4 class extended from DataFrame
An S4 class LinkDataFrame}
\description{
The \strong{LinkDataFrame} is extended from the class \strong{DataFrame} to
include at least four columns \code{nodeLab}, \code{nodeLab_alias},
\code{nodeNum}, and \code{isLeaf}.
}
\section{Constructor}{

See \code{\link{LinkDataFrame-constructor}} for constructor
functions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_printNode.R
\name{printNode}
\alias{printNode}
\title{To print out the node labels}
\usage{
printNode(tree, type = c("leaf", "internal", "all"))
}
\arguments{
\item{tree}{A phylo object.}

\item{type}{A character value choose from \code{leaf}, \code{all}, and
\code{internal}. If \code{leaf}, the output is a data frame including only
leaf nodes; if \code{internal}, the output is a data frame including only
internal nodes; if \code{all}, the output is a data frame including all
nodes.}
}
\value{
a data frame
}
\description{
\code{nodeLabel} is to print out the node labels of a \code{phylo} tree.
}
\examples{
data(tinyTree)
library(ggtree)

# PLOT tree
# The node labels are in orange texts and the node numbers are in blue
ggtree(tinyTree,branch.length = 'none')+
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)

(pn1 <- printNode(tinyTree, type = "leaf"))
(pn2 <- printNode(tinyTree, type = "internal"))
(pn3 <- printNode(tinyTree, type = "all"))

}
\author{
Ruizhu HUANG
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.bind_link_tree}
\alias{.bind_link_tree}
\title{bind links & trees when combine TSE}
\usage{
.bind_link_tree(x, args, drop.rowLinks, drop.colLinks, bind = "cbind")
}
\description{
bind links & trees when combine TSE
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeTSE.R
\name{makeTSE}
\alias{makeTSE}
\title{A toy TreeSummarizedExperiment object}
\usage{
makeTSE(nrow = 10, ncol = 4, include.rowTree = TRUE, include.colTree = TRUE)
}
\arguments{
\item{nrow}{a numeric value to specify the number of rows of
\code{TreeSummarizedExperiment}}

\item{ncol}{a numeric value to specify the number of columns of
\code{TreeSummarizedExperiment}}

\item{include.rowTree}{TRUE or FALSE. Default is TRUE, so the output
\code{TreeSummarizedExperiment} has a \code{phylo} object in
\code{rowTree}.}

\item{include.colTree}{TRUE or FALSE. Default is TRUE, so the output
\code{TreeSummarizedExperiment} has a \code{phylo} object in
\code{colTree}.}
}
\value{
A TreeSummarizedExperiment object
}
\description{
\code{makeTSE} creates a toy TreeSummarizedExperiment object.
}
\details{
The \code{assays} contains a matrix with values from
  \code{1:(nrow*ncol)}. The \code{rowData} has two columns, \code{var1} and
  \code{var2}. \code{var1} is created with \code{rep_len(letters, nrow)}.
  \code{var2} is created with \code{rep_len(c(TRUE, FALSE), nrow)}. The
  \code{colData} has two columns, \code{ID} and \code{group}. \code{ID} is
  created with \code{seq_len(ncol)}. \code{group} is created with
  \code{rep_len(LETTERS[1:2], ncol)}. The row/col tree is generated with
  \code{ape::rtree()}. So, to generate reproducible trees, \code{set.seed()}
  is required.
}
\examples{

set.seed(1)
makeTSE()
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.all_equal_in_list}
\alias{.all_equal_in_list}
\title{test all elements in a list are equal}
\usage{
.all_equal_in_list(x)
}
\description{
test all elements in a list are equal
}
\examples{
\dontrun{
l1 <- list(a = 1, b = 2, c = 3)
l2 <- list(a = 1, b = 1, c = 1)
.all_equal_in_list(l1)
.all_equal_in_list(l2)
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClass.R
\docType{data}
\name{phylo}
\alias{phylo}
\title{phylo: A S3 class for the phylogenetic tree}
\format{
An object of class \code{phylo} of length 0.
}
\usage{
phylo
}
\description{
The \pkg{ape} package does not export its phylo class, probably because it
is not really defined formally anywhere. Technically, it is an S3 class
extended from the class list. Any exported definitions from the \pkg{ape}
package would be preferred to use if available.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_asLeaf.R
\name{asLeaf}
\alias{asLeaf}
\title{change internal nodes to leaf nodes}
\usage{
asLeaf(tree, node)
}
\arguments{
\item{tree}{A phylo object.}

\item{node}{A numeric or character vector. It specifies internal nodes that
are changed to leaves via their node labels or numbers.}
}
\value{
A phylo object.
}
\description{
\code{asLeaf} updates a \code{phylo} tree by changing the specified internal
nodes to leaf nodes. In other words, the descendant nodes of the specified
internal nodes are removed.
}
\examples{
library(ggtree)
data(tinyTree)
ggtree(tinyTree, ladderize = FALSE) +
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7) +
    geom_hilight(node = 16) +
    geom_point2()

# remove the blue branch
NT1 <- asLeaf(tree = tinyTree, node = 16)

ggtree(NT1, ladderize = FALSE) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7) +
    geom_point2()

# if mergeSingle = TRUE, the node (Node_17) is removed.
NT2 <- asLeaf(tree = tinyTree, node = c(15, 13))


ggtree(NT2, ladderize = FALSE) +
    geom_text2(aes(label = label), color = "darkorange",
               hjust = -0.1, vjust = -0.7) +
    geom_point2()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.update_whichTree}
\alias{.update_whichTree}
\title{update the 'whichTree' column in row/column link data}
\usage{
.update_whichTree(x, y)
}
\description{
update the 'whichTree' column in row/column link data
}
\examples{
\dontrun{
(ld <- LinkDataFrame(nodeLab = letters[1:5],
                     nodeLab_alias = LETTERS[1:5],
                     nodeNum = 1:5,
                     isLeaf = TRUE,
                     whichTree = LETTERS[1:5],
                     right = 1:5))
newWhich <- setNames(letters[1:5], LETTERS[1:5])
.update_whichTree(ld, y = newWhich)
}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_unionLeaf.R
\name{unionLeaf}
\alias{unionLeaf}
\title{list leaf nodes that are the descendants of at least one specified node}
\usage{
unionLeaf(tree, node)
}
\arguments{
\item{tree}{A phylo object.}

\item{node}{A numeric or character vector. It specifies internal nodes that
are changed to leaves via their node labels or numbers.}
}
\value{
A phylo object.
}
\description{
\code{unionLeaf} list the leaf nodes that are the desendants of (at least one)
specified nodes.
}
\examples{
library(ggtree)
data(tinyTree)
ggtree(tinyTree, ladderize = FALSE) +
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7) +
    geom_hilight(node = 18) +
    geom_point2()

u1 <- unionLeaf(tree = tinyTree, node = c(19, 17))
u2 <- unionLeaf(tree = tinyTree, node = c(19, 17, 7))
(u3 <- unionLeaf(tree = tinyTree, node = c(11, 17, 7)))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClass.R
\docType{class}
\name{TreeSummarizedExperiment-class}
\alias{TreeSummarizedExperiment-class}
\title{An S4 class TreeSummarizedExperiment}
\description{
The class \strong{TreeSummarizedExperiment} is an extension class of standard
\code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}} class. It has
four more slots that are not in
\code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}} class:
\code{rowTree}, \code{rowLinks} \code{colTree} and \code{colLinks}. The
hierarchical information of rows (columns) is stored in \code{rowTree}
(\code{colTree}) and the link between the rows (columns) of \code{assays}
tables and nodes of the tree is given in \code{rowLinks} (\code{colLinks}).
}
\details{
The class \strong{TreeSummarizedExperiment} is designed to store
  rectangular data for entities (e.g., microbes or cell types)
  (\code{assays}), information about the hiearchical structure
  (\code{rowTree} on rows; \code{colTree} on columns), and the mapping
  information between the tree nodes and the rows or the columns of the
  rectangular data. Users could provide the hiearchical structure of the
  rows, columns or both) of the \code{assays} tables, and the link data will
  be automatically generated in \code{rowLinks}, \code{colData} or both,
  respectively. It's required that the object in \code{rowLinks} or
  \code{colLinks} has the \code{LinkDataFrame} class. Please see the page
  \code{\link{LinkDataFrame}} for more details.
}
\section{Slots}{

\describe{
\item{\code{rowTree}}{A phylo object or NULL. It gives information about the
hiearchical structure of rows of \code{assays} tables.}

\item{\code{colTree}}{A phylo object or NULL. It gives information about the
hiearchical structure of columns of \code{assays} tables.}

\item{\code{rowLinks}}{A LinkDataFrame. It gives information about the link between
the nodes of the \code{rowTree} and the rows of \code{assays} tables.}

\item{\code{colLinks}}{A LinkDataFrame. It gives information about the link between
the nodes of the \code{colTree} and the columns of \code{assays} tables.}

\item{\code{referenceSeq}}{A \code{DNAStringSet}/\code{DNAStringSetList} object or
some object coercible to a \code{DNAStringSet}/\code{DNAStringSetList}
object. See \code{\link[Biostrings:XStringSet-class]{DNAStringSet}} for
more details.}

\item{\code{...}}{Other slots from
\code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}}
}}

\section{Constructor}{

See \code{\link{TreeSummarizedExperiment-constructor}} for constructor
functions.
}

\section{Accessor}{

See \code{\link{TreeSummarizedExperiment-accessor}} for accessor functions.
}

\seealso{
\code{\link{TreeSummarizedExperiment}}
  \code{\link{TreeSummarizedExperiment-accessor}}
  \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_asPhylo.R
\name{asPhylo}
\alias{asPhylo}
\title{Convert a data frame to a phylo object}
\usage{
asPhylo(data, column_order = NULL, asNA = NULL)
}
\arguments{
\item{data}{A data frame or matrix.}

\item{column_order}{A vector that includes the column names of data to
reorder columns of \code{data}. Default is NULL, the original order of
\code{data} is kept.}

\item{asNA}{This specifies strings that are considered as NA}
}
\value{
a phylo object
}
\description{
\code{asPhylo} converts a data frame to a phylo object. Compared to
\code{toTree}, \code{asPhylo} allows the output tree to have different number
of nodes in paths connecting leaves to the root.
}
\details{
The last column is used as the leaf nodes
}
\examples{

library(ggtree)

# Example 0:
taxTab <- data.frame(R1 = rep("A", 5),
                     R2 = c("B1", rep("B2", 4)),
                     R3 = paste0("C", 1:5))
# Internal nodes: their labels are prefixed with colnames of taxTab
#  e.g., R2:B2
taxTree <- asPhylo(data = taxTab)
ggtree(taxTree) + 
 geom_text2(aes(label = label), color = "red", vjust = 1) + 
 geom_nodepoint()
 
 # (Below gives the same output as toTree)
 taxTab$R1 <- paste0("R1:", taxTab$R1)
 taxTab$R2 <- paste0("R2:", taxTab$R2)
 taxTree <- asPhylo(data = taxTab)
# viz the tree           
 ggtree(taxTree) + 
 geom_text2(aes(label = label), color = "red", vjust = 1) + 
 geom_nodepoint()
 
# Example 1
df1 <- rbind.data.frame(c("root", "A1", "A2", NA),
                        c("root", "B1", NA, NA))
colnames(df1) <- paste0("L", 1:4)
tree1 <- asPhylo(df1)

ggtree(tree1, color = "grey") +
geom_nodepoint() +
   geom_text2(aes(label = label), angle = 90,
               color = "red", vjust = 2,
               size = 4)
               
# Example 2
df2 <- data.frame(Group_1 = rep("Root", 11),
                  Group_2 = rep(c(13, 21), c(9, 2)),
                  Group_3 = rep(c(14, 18, "unknown"), c(5, 4, 2)),
                  Group_4 = rep(c(15, "unknown", 19, "unknown"), c(4, 1, 3, 3)),
                  Group_5 = rep(c(16, "unknown", 20, "unknown"), c(3, 2, 2, 4)),
                  Group_6 = rep(c(17, "unknown"), c(2, 9)),
                  LEAF = 1:11)
                  
tree2 <- asPhylo(df2, asNA = "unknown")

ggtree(tree2, color = "grey") +
geom_nodepoint() +
   geom_text2(aes(label = label), angle = 90,
               color = "red", vjust = 2,
               size = 4) 
               
# Example 3
df3 <- df2
df3[10:11, 3] <- ""                                            
 
tree3 <- asPhylo(df3, asNA = c("unknown", ""))

ggtree(tree3, color = "grey") +
geom_nodepoint() +
   geom_text2(aes(label = label), angle = 90,
               color = "red", vjust = 2,
               size = 4) 
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClass.R
\name{LinkDataFrame-constructor}
\alias{LinkDataFrame-constructor}
\alias{LinkDataFrame}
\title{Construct a LinkDataFrame
Construct a LinkDataFrame object}
\usage{
LinkDataFrame(nodeLab, nodeLab_alias, nodeNum, isLeaf, whichTree, ...)
}
\arguments{
\item{nodeLab}{A character vector}

\item{nodeLab_alias}{A character vector}

\item{nodeNum}{A numeric vector}

\item{isLeaf}{A logical vector}

\item{whichTree}{A character vector}

\item{...}{All arguments accepted by
\code{\link[S4Vectors:DataFrame-class]{DataFrame-class}}.}
}
\value{
A LinkDataFrame object
}
\description{
Construct a LinkDataFrame
Construct a LinkDataFrame object
}
\examples{


(ld <- LinkDataFrame(nodeLab = letters[1:5],
                     nodeLab_alias = LETTERS[1:5],
                     nodeNum = 1:5,
                     isLeaf = TRUE,
                     whichTree = LETTERS[1:5],
                     right = 1:5))
}
\seealso{
\code{\link[=LinkDataFrame-class]{LinkDataFrame}}
  \code{\link[S4Vectors:DataFrame-class]{DataFrame}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.any_null_in_list}
\alias{.any_null_in_list}
\title{Any element in the list is NULL}
\usage{
.any_null_in_list(x)
}
\description{
Any element in the list is NULL
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allClass.R
\name{TreeSummarizedExperiment-constructor}
\alias{TreeSummarizedExperiment-constructor}
\alias{TreeSummarizedExperiment}
\title{Construct a TreeSummarizedExperiment object}
\usage{
TreeSummarizedExperiment(
  ...,
  rowTree = NULL,
  colTree = NULL,
  rowNodeLab = NULL,
  colNodeLab = NULL,
  referenceSeq = NULL
)
}
\arguments{
\item{...}{Arguments passed to the \code{\link{SummarizedExperiment}} constructor to fill the slots of the base class.}

\item{rowTree}{A phylo object that provides hiearchical information of rows
of assay tables.}

\item{colTree}{A phylo object that provides hiearchical information of
columns of assay tables.}

\item{rowNodeLab}{A character string. It provides the labels of nodes that
the rows of \code{assays} tables corresponding to. If NULL (default), the
row names of the \code{assays} tables are used.}

\item{colNodeLab}{A character string. It provides the labels of nodes that
the columns of \code{assays} tables corresponding to. If NULL (default),
the column names of the \code{assays} tables are used.}

\item{referenceSeq}{A \code{DNAStringSet}/\code{DNAStringSetList} object or
some object coercible to a \code{DNAStringSet}/\code{DNAStringSetList}
object. See \code{\link[Biostrings:XStringSet-class]{DNAStringSet}} for
more details.}
}
\value{
a TreeSummarizedExperiment object
}
\description{
\code{TreeSummarizedExperiment} constructs a TreeSummarizedExperiment object.
}
\details{
The output TreeSummarizedExperiment object has very similar
  structure as the
  \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}. The
  differences are summarized be as below.
  \itemize{
  \item \strong{rowTree} A slot exists in \code{TreeSummarizedExperiment}
  but not in \code{SingleCellExperiment}. It stores the tree structure(s)
  that provide(s) hierarchical information of \code{assays} rows or columns
  or both.
  \item \strong{rowData} If a \code{phylo} object is available in the slot
  \code{treeData} to provide the hiearchical information about the rows of
  the \code{assays} table, the \code{rowData} would be a
  \code{\link{LinkDataFrame-class}} instead of
  \code{\link[S4Vectors:DataFrame-class]{DataFrame}}. The data on the right side of the
  vertical line provides the link information between the \code{assays} rows
  and the tree \code{phylo} object, and could be accessed via
  \code{linkData}; The data on the left side is the original \code{rowData}
  like \code{SingleCellExperiment} object.
  \item \strong{colData} Similar to the explanaition for \strong{rowData} as
  above.
 }
 More details about the \code{LinkDataFrame} in the \code{rowData} or
 \code{colData}.
 \itemize{
 \item nodeLab The labels of nodes on the tree.
 \item nodeLab\_alias The alias of node labels on the tree.
 \item nodeNum The numbers of nodes on the tree.
 \item isLeaf It indicates whether the node is a leaf node or internal node.
 }
}
\examples{

data("tinyTree")

# the count table
count <- matrix(rpois(100, 50), nrow = 10)
rownames(count) <- c(tinyTree$tip.label)
colnames(count) <- paste("C_", 1:10, sep = "_")

# The sample information
sampC <- data.frame(condition = rep(c("control", "trt"), each = 5),
                    gender = sample(x = 1:2, size = 10, replace = TRUE))
rownames(sampC) <- colnames(count)

# build a TreeSummarizedExperiment object
tse <- TreeSummarizedExperiment(assays = list(count),
                                colData = sampC,
                                rowTree = tinyTree)

}
\seealso{
\code{\link[=TreeSummarizedExperiment-class]{TreeSummarizedExperiment}}
  \code{\link[=TreeSummarizedExperiment-accessor]{TreeSummarizedExperiment-accessor}}
  \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment}}
}
\author{
Ruizhu HUANG
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.match_phylo_list}
\alias{.match_phylo_list}
\title{match a list of phylo (x.phys) against to a list of phylo (y.phys)}
\usage{
.match_phylo_list(x.phys, y.phys)
}
\description{
match a list of phylo (x.phys) against to a list of phylo (y.phys)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.is_equal_link}
\alias{.is_equal_link}
\title{The links & trees in the specified dim are consistent}
\usage{
.is_equal_link(args, dim = "row")
}
\description{
The links & trees in the specified dim are consistent
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecate_Fun.R, R/tree_convertNode.R
\name{transNode}
\alias{transNode}
\alias{convertNode}
\title{Transfer between node number and node label}
\usage{
transNode(tree, node, use.alias = FALSE, message = FALSE)

convertNode(tree, node, use.alias = FALSE, message = FALSE)
}
\arguments{
\item{tree}{A phylo object}

\item{node}{A character or numeric vector representing tree node label(s) or
tree node number(s)}

\item{use.alias}{A logical value, TRUE or FALSE. This is an optional argument
that only requried when the input \code{node} is a numeric vector. The
default is FALSE, and the node label would be returned; otherwise, the
alias of node label would be output. The alias of node label is created by
adding a prefix \code{"alias_"} to the node number.}

\item{message}{A logical value, TRUE or FALSE. The default is FALSE. If TRUE,
message will show when a tree have duplicated labels for some internal
nodes.}
}
\value{
a vector
}
\description{
\code{convertNode} does the transformation between the number and the label of
a node on a tree
}
\examples{
library(ggtree)

data(tinyTree)

ggtree(tinyTree, branch.length = 'none') +
geom_text2(aes(label = label), hjust = -0.3) +
geom_text2(aes(label = node), vjust = -0.8,
hjust = -0.3, color = 'blue')

#check whether the node number and node label are matched
convertNode(tinyTree, node = c(11, 2, 4, 15))

convertNode(tree = tinyTree, node = c("Node_16", "Node_11"))
convertNode(tree = tinyTree, node = c("alias_16", "alias_11"))
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_trackNode.R
\name{trackNode}
\alias{trackNode}
\title{track the nodes of a phylo tree}
\usage{
trackNode(tree)
}
\arguments{
\item{tree}{A phylo object}
}
\value{
a phylo object
}
\description{
\code{trackNode} track nodes of a phylo tree by adding the alias labels to
them
}
\examples{
library(ggtree)

data(tinyTree)

ggtree(tinyTree, branch.length = 'none') +
    geom_text2(aes(label = label), hjust = -0.3) +
    geom_text2(aes(label = node), vjust = -0.8,
               hjust = -0.3, color = 'blue')

#check whether the node number and node label are matched
trackTree <- trackNode(tinyTree)
ggtree(trackTree, branch.length = 'none') +
    geom_text2(aes(label = label), hjust = -0.3) +
    geom_text2(aes(label = node), vjust = -0.8,
               hjust = -0.3, color = 'blue')
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecate_Fun.R, R/tree_joinNode.R
\name{signalNode}
\alias{signalNode}
\alias{joinNode}
\title{Join nodes}
\usage{
signalNode(tree, node, use.alias = FALSE)

joinNode(tree, node, use.alias = FALSE)
}
\arguments{
\item{tree}{A tree (phylo object)}

\item{node}{A vector of node numbers or node labels}

\item{use.alias}{A logical value, TRUE or FALSE. The default is FALSE, and
the node label would be used to name the output; otherwise, the alias of
node label would be used to name the output. The alias of node label is
created by adding a prefix \code{"alias_"} to the node number.}
}
\value{
A vector of nodes. The numeric value is the node number, and the
  vector name is the corresponding node label. If a node has no label, it
  would have NA as name when \code{use.alias = FALSE}, and have the alias of
  node label as name when \code{use.alias = TRUE}.
}
\description{
\code{joinNode} is to use as few as possible nodes to represent the provided
nodes so that descendant leaves covered by the input nodes and output nodes
are exactly the same.
}
\examples{

data(tinyTree)
library(ggtree)

# PLOT tree
# The node labels are in orange texts and the node numbers are in blue
ggtree(tinyTree,branch.length = 'none')+
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)

## find the node shared by provided node labels
joinNode(node = c('t4','t9'), tree = tinyTree)
joinNode(node = c('t4','t9'), tree = tinyTree)
joinNode(node = c('t10','Node_18', 't8'), 
         tree = tinyTree,
         use.alias = FALSE)
joinNode(node = c('t10','Node_18', 't8'), 
         tree = tinyTree,
         use.alias = TRUE)

## find the node shared by provided node numbers
joinNode(node = c(2, 3), tree = tinyTree)
joinNode(node = c(2, 3, 16), tree = tinyTree)

}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.numeric_ij}
\alias{.numeric_ij}
\title{convert char. indicator to num. indicator}
\usage{
.numeric_ij(ij, x, dim = "row")
}
\arguments{
\item{ij}{A character or numeric indicator on rows/columns of \code{x}}

\item{x}{It provides row/col names for \code{ij} to be matched against.}

\item{dim}{"row" or "col" to specify row/col names of \code{x} to be matched
against.}
}
\description{
convert char. indicator to num. indicator
}
\author{
Ruizhu Huang
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_showNode.R
\name{showNode}
\alias{showNode}
\title{Find nodes on the tree}
\usage{
showNode(tree, only.leaf = FALSE, use.alias = FALSE)
}
\arguments{
\item{tree}{A  phylo object.}

\item{only.leaf}{A logical value, TRUE or FALSE. The default is FALSE, all
nodes are output; otherwise, leaves are output}

\item{use.alias}{A logical value, TRUE or FALSE. The default is FALSE, and
the node label would be used to name the output; otherwise, the alias of
node label would be used to name the output. The alias of node label is
created by adding a prefix \code{"alias_"} to the node number.}
}
\value{
A vector of nodes. The numeric value is the node number, and the
  vector name is the corresponding node label. If a node has no label, it
  would have NA as name when \code{use.alias = FALSE}, and have the alias of
  node label as name when \code{use.alias = TRUE}.
}
\description{
\code{showNode} is to get nodes from the tree.
}
\examples{
library(ggtree)
data(tinyTree)

# PLOT tree
ggtree(tinyTree, branch.length = 'none') +
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)


## find the node shared by provided node labels
showNode(tree = tinyTree, only.leaf = TRUE,
          use.alias = FALSE)

showNode(tree = tinyTree, only.leaf = FALSE,
          use.alias = FALSE)
}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TreeSummarizedExperiment.R
\docType{package}
\name{TreeeSummarizedExperiment-package}
\alias{TreeeSummarizedExperiment-package}
\title{The \code{TreeSummarizedExperiment} package}
\description{
\code{TreeSummarizedExperiment} implement a class of the same name, which
extends SingleCellExperiment to include hierarchical information on the rows
or columns of the rectangular data.
}
\details{
It also includes an additional slot for storing reference sequences per
feature.
}
\seealso{
\link[=TreeSummarizedExperiment-class]{TreeSummarizedExperiment} class
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_isLeaf.R
\name{isLeaf}
\alias{isLeaf}
\title{To test whether the specified nodes are leaf nodes}
\usage{
isLeaf(tree, node)
}
\arguments{
\item{tree}{A phylo object.}

\item{node}{A numeric or character vector. Node labels or node numbers.}
}
\value{
a logical vector with the same length as the input \code{node}.
}
\description{
\code{isLeaf} is to test wheter some specified nodes are leaf nodes of a
tree.
}
\examples{
data(tinyTree)
library(ggtree)

# PLOT tree
# The node labels are in orange texts and the node numbers are in blue
ggtree(tinyTree,branch.length = 'none')+
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)

isLeaf(tree = tinyTree, node = c(5, 4, 18))
isLeaf(tree = tinyTree, node = c("t4", "t9", "Node_18" ))

}
\author{
Ruizhu HUANG
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_countNode.R
\name{countNode}
\alias{countNode}
\title{count the number of nodes}
\usage{
countNode(tree)
}
\arguments{
\item{tree}{A phylo object}
}
\value{
a numeric value
}
\description{
\code{countNode} calculates the number of nodes on a \code{phylo} tree.
}
\examples{
library(ggtree)

data(tinyTree)

ggtree(tinyTree, branch.length = 'none') +
       geom_text2(aes(label = label), hjust = -0.3) +
       geom_text2(aes(label = node), vjust = -0.8,
       hjust = -0.3, color = 'blue')


(n <- countNode(tinyTree))

}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.rbind_refSeq}
\alias{.rbind_refSeq}
\title{rbind referenceSeq}
\usage{
.rbind_refSeq(args)
}
\description{
rbind referenceSeq
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_findChild.R
\name{findChild}
\alias{findChild}
\title{Find the children}
\usage{
findChild(tree, node = 11, use.alias = FALSE)
}
\arguments{
\item{tree}{A phylo object.}

\item{node}{An internal node. It could be the node number or the node
label.}

\item{use.alias}{A logical value, TRUE or FALSE. The default is FALSE, and
the node label would be used to name the output; otherwise, the alias of
node label would be used to name the output. The alias of node label is
created by adding a prefix \code{"alias_"} to the node number.}
}
\value{
A vector of nodes. The numeric value is the node number, and the
  vector name is the corresponding node label. If a node has no label, it
  would have NA as name when \code{use.alias = FALSE}, and have the alias of
  node label as name when \code{use.alias = TRUE}.
}
\description{
\code{findChild} finds children of an internal node.
}
\examples{
data(tinyTree)

library(ggtree)
ggtree(tinyTree) +
geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7) +
geom_hilight(node = 17, fill = 'steelblue', alpha = 0.5) +
geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7)

(tips <- findChild(tree = tinyTree, node = 17))

}
\author{
Ruizhu Huang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internal_utils.R
\name{.match_phylo}
\alias{.match_phylo}
\title{match a phylo to a list of phylo}
\usage{
.match_phylo(phy, phys)
}
\description{
match a phylo to a list of phylo
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_shareNode.R
\name{shareNode}
\alias{shareNode}
\title{Find the share node}
\usage{
shareNode(tree, node, use.alias = FALSE)
}
\arguments{
\item{tree}{A  phylo object.}

\item{node}{A vector of node numbers or node labels.}

\item{use.alias}{A logical value, TRUE or FALSE. The default is FALSE, and
the node label would be used to name the output; otherwise, the alias of
node label would be used to name the output. The alias of node label is
created by adding a prefix \code{"alias_"} to the node number.}
}
\value{
A vector of nodes. The numeric value is the node number, and the
  vector name is the corresponding node label. If a node has no label, it
  would have NA as name when \code{use.alias = FALSE}, and have the alias of
  node label as name when \code{use.alias = TRUE}.
}
\description{
\code{shareNode} is to find the node where the specified nodes first meet.
}
\examples{
library(ggtree)
data(tinyTree)

# PLOT tree
ggtree(tinyTree, branch.length = 'none') +
    geom_text2(aes(label = label), color = "darkorange",
           hjust = -0.1, vjust = -0.7) +
    geom_text2(aes(label = node), color = "darkblue",
               hjust = -0.5, vjust = 0.7)


## find the node shared by provided node labels
shareNode(node = c('t4','t9'), tree = tinyTree,
          use.alias = FALSE)

shareNode(node = c('t10','Node_17'), tree = tinyTree,
          use.alias = FALSE)

## find the node shared by provided node numbers
shareNode(node = c(2, 3), tree = tinyTree)
}
\author{
Ruizhu Huang
}
